package com.jollychic.constant

/**
  *  系统配置常量
  *
  */
object Constant {

  /********* MySQL配置常量 **********/
  val DB_DRIVER = "db.default.driver"
  val DB_URL = "db.default.url"
  val DB_USER = "db.default.user"
  val DB_PASSWORD = "db.default.password"
  val DB_TABLE = "db.default.table"

  /********* MySQL配置常量[监控] **********/
  val DB_MONITOR_DRIVER = "monitor.db.default.driver"
  val DB_MONITOR_URL = "monitor.db.default.url"
  val DB_MONITOR_USER = "monitor.db.default.user"
  val DB_MONITOR_PASSWORD = "monitor.db.default.password"
  val DB_MONITOR_TABLE = "monitor.db.default.table"

  /********* oracle 配置常量**********/
  val ORACALDB_DRIVER = "oracledb.default.driver"
  val ORACALDB_URL = "oracledb.default.url"
  val ORACALDB_USER = "oracledb.default.user"
  val ORACALDB_PASSWORD = "oracledb.default.password"

  val ES_HOST = "es.default.hostlist"
  val ES_CLUSTER = "es.default.cluster"
  val ES_USER = "es.default.user"
  val ES_PASSWORD = "es.default.password"

  val CH_DRIVER="clickhouse.default.driver"
  val CH_URL = "clickhouse.default.url"
  val CH_USER = "clickhouse.default.user"
  val CH_PASSWORD = "clickhouse.default.password"
  val CH_URL_TEST = "clickhouse.default.url_test"
  val CH_USER_TEST = "clickhouse.default.user_test"
  val CH_PASSWORD_TEST = "clickhouse.default.password_test"


  /********* Spark配置常量 **********/
  val FILTERD_USER_GROUP_TASK_NAME = "filterd.user.group.task.name"

  /********* 人群过滤配置常量 **********/
  val FILTERD_USER_GROUP_TASK_DESC= "filterd.user.group.task.desc"
  val FILTERD_USER_GROUP_TASK_CK_IDTABS = "inCookieIdTabs"
  val FILTERD_USER_GROUP_TASK_US_IDTABS = "inUserIdTabs"
  val SPARK_USER_GROUP_PREDIC_FACTOR = "spark.user.group.predic.factor"

}
