package com.jollychic.spark

import java.sql.{ResultSet, Statement}
import java.time.Year
import java.util

import com.jollychic.tool.{ClickhouseConnect, TagGenBase}
import com.jollychic.utils.{CommonKit, DateUtils}
import org.json4s.jackson.Serialization
import org.json4s.{Formats, NoTypeHints}


class Tag_Algorithm extends  TagGenBase{

  ///生成退订预测数据C3
  def zt_tag_cancel_data(month:String,is_Cancel:Int=0):Int ={
    //判断传进来的日期是否 为当月
    var isInMonth:Boolean=false
    val nowMonth:String= DateUtils.nowDate("yyyyMM")
    if(nowMonth==month){
      isInMonth=true
    }
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    val pr1full_month=DateUtils.getNMonth(dateStr, 1,"yyyy-MM-dd")
    val p1month=DateUtils.getNMonth(dateStr, 0,"yyyyMM")
    val p2month=DateUtils.getNMonth(dateStr, -1,"yyyyMM")
    val p3month=DateUtils.getNMonth(dateStr, -2,"yyyyMM")
    val p4month=DateUtils.getNMonth(dateStr, -3,"yyyyMM")
    val p5month=DateUtils.getNMonth(dateStr, -4,"yyyyMM")

    val theDay=DateUtils.getNMonth(dateStr, 1,"yyyyMM")+"01"
    val per3Day=p4month+"01"

    //如果是当月的数据 调用时删除原数据 重新生成
    if(isInMonth==true) {
      var sql_Drop: String =
        s"""
           |alter table ads.ALS_XXH_CANCEL_NEW_C1 drop partition '${nowMonth}'
           |""".stripMargin + ""
      //执行2
      RunClickhouseSQL(sql_Drop);
      //让子弹飞一会
      Thread.sleep(10000)
    }

//    var order_sql1=
//      s"""
//         |	where  THEMONTH='${p1month}' and  CANCELTIME='1970-01-01'
//         |	and ORDERTIME <'${pr1full_month}'
//         |""".stripMargin
//    if(isInMonth==0){
//      order_sql1=
//        s"""
//           |	where  CANCELTIME >='${dateStr}' and  CANCELTIME <'${pr1full_month}'
//			     |  and ORDERTIME <'${dateStr}'
//           |""".stripMargin
//    }
  var sql_Cancel: String ="";
    //查退订
    if(is_Cancel==1){
      sql_Cancel=" and IS_CANCEL=1 ";
    }
    if(is_Cancel== -1){
      sql_Cancel=" ";
    }
    if(is_Cancel== 0){
      sql_Cancel=" and IS_CANCEL=0 ";
    }

    var sql:String=""
    sql=sql+
      s"""
         |insert into ads.ALS_XXH_CANCEL_NEW_C3
         |select '${month}' as TARGET_MONTH,
         |USERID,PRICE/48 as PRICE,if(MAXFLOW>50000,50000,MAXFLOW)/50000 as MAXFLOW,
         |if(TOTAL_FEE_AVG>300,300,TOTAL_FEE_AVG)/300 as TOTAL_FEE_AVG,IS_ACCT_AVG,
         |if(TOTAL_FLUX_AVG>20000,20000,TOTAL_FLUX_AVG)/20000 as TOTAL_FLUX_AVG,
         |if(TOTAL_FLUX_VIDEO_AVG>20000,20000,TOTAL_FLUX_VIDEO_AVG)/20000 as TOTAL_FLUX_VIDEO_AVG ,
         |multiIf(MAvg3_Flow_P<=0,'Buk0',MAvg3_Flow_P>0 and MAvg3_Flow_P<0.1,'Buk0_1',MAvg3_Flow_P>=0.1 and MAvg3_Flow_P<0.3,'Buk1_3',
         |MAvg3_Flow_P>=0.3 and MAvg3_Flow_P<0.5,'Buk3_5',MAvg3_Flow_P>=0.5 and MAvg3_Flow_P<0.8,'Buk5_8','Buk8_p') as MAvg3_Flow_P_Buk,
         |multiIf(MPer1_Flow_P<=0,'Buk0',MPer1_Flow_P>0 and MPer1_Flow_P<0.1,'Buk0_1',MPer1_Flow_P>=0.1 and MPer1_Flow_P<0.3,'Buk1_3',
         |MPer1_Flow_P>=0.3 and MPer1_Flow_P<0.5,'Buk3_5',MPer1_Flow_P>=0.5 and MPer1_Flow_P<0.8,'Buk5_8','Buk8_p') as MPer1_Flow_P_Buk,
         |multiIf(M1_Flow02_P<=0,'Buk0',M1_Flow02_P>0 and M1_Flow02_P<0.1,'Buk0_1',M1_Flow02_P>=0.1 and M1_Flow02_P<0.3,'Buk1_3',
         |M1_Flow02_P>=0.3 and M1_Flow02_P<0.5,'Buk3_5',M1_Flow02_P>=0.5 and M1_Flow02_P<0.8,'Buk5_8','Buk8_p') as M1_Flow02_P_Buk,
         |PROVINCE,CHANNEL,CPID,SPID,DIFF_MONYH_TYPE,CUST_SEX,CERT_AGE,MANU_NAME,
         |BELONGTO,CPTYPE,IS_VIP,ORDER_HOUR,
         |`MPer1_Flow`, MAvg3_Flow,M1_Flow02,
         |IS_CANCEL
         |from (
         |	select
         |	s0.USERID as USERID,`PROVINCE`,`CHANNEL`,s0.CPID as CPID,s0.SPID as SPID,`ORDERTIME`,`DIFF_MONYH_TYPE`,`IS_CANCEL`,`PRICE`,toFloat64OrZero(e1.MAXFLOW ) as MAXFLOW,
         |	s1.USERID,if(isNaN(MAvg3_Flow),0,MAvg3_Flow) as MAvg3_Flow,`MPer1_Flow`,
         |	--处理当月流量，使其更合理
         |	`M1_Flow`,dateDiff('day', ORDERTIME, now()) as diffDay,if(diffDay<30,(30/diffDay)*M1_Flow,M1_Flow) as M1_Flow01,if(M1_Flow01>MAXFLOW,MAXFLOW,M1_Flow01) as M1_Flow02,
         |	MAvg3_Flow/MAXFLOW as MAvg3_Flow_P,MPer1_Flow/MAXFLOW as MPer1_Flow_P,M1_Flow02/MAXFLOW as M1_Flow02_P,
         |	s2.DEVICE_NUMBER,ifNull(CUST_SEX,'未知') CUST_SEX,ifNull(CERT_AGE,'未知') CERT_AGE ,ifNull(TOTAL_FEE_AVG,0) TOTAL_FEE_AVG,
         |	ifNull(MANU_NAME,'未知') MANU_NAME ,ifNull(IS_ACCT_AVG,0) IS_ACCT_AVG ,ifNull(TOTAL_FLUX_AVG,0) TOTAL_FLUX_AVG,
         |	ifNull(TOTAL_FLUX_VIDEO_AVG,0) TOTAL_FLUX_VIDEO_AVG,BELONGTO,concat('c',toString(CPTYPE)) as CPTYPE,if(USERVAL='','unget','get') as IS_VIP,ORDER_HOUR
         |	from
         |	(
         |		--订购数据
         |		select USERID,any(PROVINCE) as PROVINCE,CHANNEL,CPID ,SPID,
         |		ORDERTIME,--CANCELTIME,
         |		DIFF_MONYH_TYPE,IS_CANCEL,ORDER_HOUR
         |		from (
         |			with toString(THEMONTH) as mstr
         |			select USERID,THEMONTH,replaceOne(replaceOne(replaceOne(PROVINCE,'省',''),'市',''),'自治区','') as PROVINCE,CHANNEL,CPID,SPID,
         |			ORDERTIME,--CANCELTIME,
         |			dateDiff('month', ORDERTIME, toDate(concat(SUBSTRING(mstr,1,4),'-' ,SUBSTRING(mstr,5,2),'-01')))+1 DIFF_MONYH,
         |			multiIf(DIFF_MONYH>6,'diff6_p',DIFF_MONYH>=4 and DIFF_MONYH<=6 ,'diff4_6',concat('diff',toString(DIFF_MONYH))) as DIFF_MONYH_TYPE,
         |			if(CANCELTIME!='1970-01-01' and CANCELTIME <'${pr1full_month}',1,0) as IS_CANCEL,
         |      concat('h',toString(floor(toHour(ORDERTIME2,'Asia/Shanghai')/3))) as ORDER_HOUR
         |			from
         |			ads.HIS_FLOW_ORDER
         |			where THEMONTH ='${month}' and DIFF_MONYH<13
         |      and SPID !='99144186'
         |      ${sql_Cancel}
         |			-- and DIFF_MONYH>3 	order by USERID
         |			-- and USERID ='15694037210'
         |		) group by  USERID,SPID,CPID,ORDERTIME,CHANNEL,DIFF_MONYH_TYPE,IS_CANCEL,ORDER_HOUR
         |	) s0
         |	left join
         |	(
         |		--流量使用数据
         |		select USERID,SPID,
         |		-- 前三月平均流量
         |		avgIf(SumMonthFlow,THEMONTH<'${month}') as MAvg3_Flow,
         |		-- 最近一月流量
         |		anyIf(SumMonthFlow,THEMONTH='${p2month}') as MPer1_Flow,
         |		-- 当月此时使用流量
         |		anyIf(SumMonthFlow,THEMONTH='${month}') as M1_Flow from
         |		(
         |			--算出每个月 每人 每产品 流量和
         |			select THEMONTH,USERID,SPID,sum(FLOW) as SumMonthFlow from
         |			(
         |				select THEMONTH,USERID,SPID,FLOW from ads.TD_DXFLOWINPUT_MONTH
         |				where THEMONTH in ('${p4month}','${p3month}','${p2month}','${month}')
         |				-- and USERID ='15694037210'
         |			)
         |			group by THEMONTH,USERID,SPID
         |		) group by USERID,SPID
         |	) s1 on s0.USERID=s1.USERID and s0.SPID=s1.SPID
         |	left join ads.ETL_V_TB_SP_INFO e1 on s0.SPID=e1.SPID
         | 	left join ads.DIM_TB_CHANNELS c1 on s0.CHANNEL=c1.ID
         |	left join
         |	(
         |		select DISTINCT USERVAL
         |		from ads.ETL_TL_VIP_LOG
         |		where THEDAY >='${per3Day}'
         |		and THEDAY<'${theDay}'
         |		and VIPID in
         |		(select VIPID from ads.DIM_SXXHY)
         |	) v1 on s0.USERID=v1.USERVAL
         |	left join
         |	(
         |		select DEVICE_NUMBER,any(CUST_SEX) as  CUST_SEX,any(CERT_AGE) as  CERT_AGE, avgIf(TOTAL_FEE,IS_ACCT=1) as TOTAL_FEE_AVG,
         |		--any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC,
         |		any(MANU_NAME) as MANU_NAME,avg(IS_ACCT) as IS_ACCT_AVG,avg(TOTAL_FLUX) as TOTAL_FLUX_AVG,avg(REAL_TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO_AVG
         |		from
         |		 (
         |		 	 --INNET_MONTHS,
         |			 select MONTH_ID,DEVICE_NUMBER,CUST_SEX ,CERT_AGE ,toFloat64OrZero(TOTAL_FEE) as TOTAL_FEE,
         |			 MANU_NAME,toUInt8OrZero(IS_ACCT) as IS_ACCT,PRODUCT_CLASS_DESC,toFloat64OrZero(TOTAL_FLUX) as TOTAL_FLUX,
         |			 toFloat64OrZero(TOTAL_FLUX_VIDEO) as REAL_TOTAL_FLUX_VIDEO  from  ads.XXH_ALL_MONTH
         |			 where MONTH_ID in ('${p3month}','${p4month}','${p5month}')
         |			 --and  DEVICE_NUMBER ='15694037210'
         |			 and DEVICE_NUMBER in (select distinct USERID from ads.HIS_FLOW_ORDER where THEMONTH ='${month}' and (dateDiff('month', ORDERTIME, toDate('${dateStr}'))+1)<13)
         |		 ) s
         |		group by DEVICE_NUMBER
         |	) s2
         |	 on s0.USERID=s2.DEVICE_NUMBER
         |   where e1.CPTYPE in ('0','1')
         | )
         |""".stripMargin;
    println(sql)
    //执行
    //RunClickhouseSQL(sql);

    0
  }
  ///生成退订分析多维表V2.0
  def zt_tag_cancel_fin(month:String):Int ={
    //val nowMonth:String= DateUtils.nowDate("yyyyMM")
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    val pr1full_month=DateUtils.getNMonth(dateStr, 1,"yyyy-MM-dd")
    val p1month=DateUtils.getNMonth(dateStr, 0,"yyyyMM")
    val p2month=DateUtils.getNMonth(dateStr, -1,"yyyyMM")
    val p3month=DateUtils.getNMonth(dateStr, -2,"yyyyMM")
    val p4month=DateUtils.getNMonth(dateStr, -3,"yyyyMM")
    val p5month=DateUtils.getNMonth(dateStr, -4,"yyyyMM")

//    val theDay=DateUtils.getNMonth(dateStr, 1,"yyyyMM")+"01"
//    val per3Day=p4month+"01"
    var sql:String=""
    sql=sql+
      s"""
         |insert into ads.FIN_ALS_XXH_CANCEL_RESULT_V2
         |select TARGET_MONTH,USERID,SPID,PROVINCE,AREA,CHANNEL,CPID,`e1.CPNAME` as CPNAME,`e1.SPNAME` as SPNAME,
         |ORDERTIME,DIFF_MONYH,PRICE,MAXFLOW,MAvg3_Flow,MPer1_Flow,M1_Flow,CUST_SEX,CERT_AGE,TOTAL_FEE_AVG,MANU_NAME,
         |IS_ACCT_AVG,TOTAL_FLUX_AVG,TOTAL_FLUX_VIDEO_AVG,BELONGTO,`e1.CATEGORYNAME` as CATEGORYNAME,round(CANCEL_P*100,2) as CANCEL_P,IS_CANCEL from
         |(
         |	SELECT * from
         |	(
         |	select *,substring(USERID, 1, 7) as U7
         |	from ads.ALS_XXH_CANCEL_RESULT where TARGET_MONTH ='${month}'
         |	) t,
         |	(select * from  ads.ETL_VW_TB_CALLER_AREACODE where LENGTH(CALLERHEAD)=7 ) ea
         |	where U7=CALLERHEAD
         |) t1
         |left join
         |(
         |select
         |s0.USERID as USERID,`CHANNEL`,s0.CPID as CPID,e1.CPNAME, s0.SPID as SPID,e1.SPNAME,`ORDERTIME`,`DIFF_MONYH`,`PRICE`,toFloat64OrZero(e1.MAXFLOW ) as MAXFLOW,
         |s1.USERID,if(isNaN(MAvg3_Flow),0,MAvg3_Flow) as MAvg3_Flow,`MPer1_Flow`,`M1_Flow`,
         |s2.DEVICE_NUMBER,ifNull(CUST_SEX,'未知') CUST_SEX,ifNull(CERT_AGE,'未知') CERT_AGE ,ifNull(TOTAL_FEE_AVG,0) TOTAL_FEE_AVG,
         |ifNull(MANU_NAME,'未知') MANU_NAME ,ifNull(IS_ACCT_AVG,0) IS_ACCT_AVG ,ifNull(TOTAL_FLUX_AVG,0) TOTAL_FLUX_AVG,
         |ifNull(TOTAL_FLUX_VIDEO_AVG,0) TOTAL_FLUX_VIDEO_AVG,BELONGTO,e1.CATEGORYNAME ,`IS_CANCEL`
         |from
         |(
         |	--订购数据
         |	select USERID,any(PROVINCE) as PROVINCE,CHANNEL,CPID ,SPID,
         |	ORDERTIME,--CANCELTIME,
         |	DIFF_MONYH,IS_CANCEL,ORDER_HOUR
         |	from (
         |		with toString(THEMONTH) as mstr
         |		select USERID,THEMONTH,replaceOne(replaceOne(replaceOne(PROVINCE,'省',''),'市',''),'自治区','') as PROVINCE,CHANNEL,CPID,SPID,
         |		ORDERTIME,--CANCELTIME,
         |		dateDiff('month', ORDERTIME, toDate(concat(SUBSTRING(mstr,1,4),'-' ,SUBSTRING(mstr,5,2),'-01')))+1 DIFF_MONYH,
         |		if(CANCELTIME!='1970-01-01' and CANCELTIME <'${pr1full_month}',1,0) as IS_CANCEL,
         |  concat('h',toString(floor(toHour(ORDERTIME2,'Asia/Shanghai')/3))) as ORDER_HOUR
         |		from
         |		ads.HIS_FLOW_ORDER
         |		where THEMONTH ='${month}' and DIFF_MONYH<13
         |		-- and USERID ='15694037210'
         |	) group by  USERID,SPID,CPID,ORDERTIME,CHANNEL,DIFF_MONYH,IS_CANCEL,ORDER_HOUR
         |) s0
         |left join
         |(
         |	--流量使用数据
         |	select USERID,SPID,
         |	-- 前三月平均流量
         |	avgIf(SumMonthFlow,THEMONTH<'${month}') as MAvg3_Flow,
         |	-- 最近一月流量
         |	anyIf(SumMonthFlow,THEMONTH='${p2month}') as MPer1_Flow,
         |	-- 当月此时使用流量
         |	anyIf(SumMonthFlow,THEMONTH='${month}') as M1_Flow from
         |	(
         |		--算出每个月 每人 每产品 流量和
         |		select THEMONTH,USERID,SPID,sum(FLOW) as SumMonthFlow from
         |		(
         |			select THEMONTH,USERID,SPID,FLOW from ads.TD_DXFLOWINPUT_MONTH
         |			where THEMONTH in ('${p4month}','${p3month}','${p2month}','${month}')
         |			-- and USERID ='15694037210'
         |		)
         |		group by THEMONTH,USERID,SPID
         |	) group by USERID,SPID
         |) s1 on s0.USERID=s1.USERID and s0.SPID=s1.SPID
         |left join ads.ETL_V_TB_SP_INFO e1 on s0.SPID=e1.SPID
         |left join ads.DIM_TB_CHANNELS c1 on s0.CHANNEL=c1.ID
         |left join
         |(
         |	select DEVICE_NUMBER,any(CUST_SEX) as  CUST_SEX,any(CERT_AGE) as  CERT_AGE, avgIf(TOTAL_FEE,IS_ACCT=1) as TOTAL_FEE_AVG,
         |	any(MANU_NAME) as MANU_NAME,avg(IS_ACCT) as IS_ACCT_AVG,avg(TOTAL_FLUX) as TOTAL_FLUX_AVG,avg(REAL_TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO_AVG
         |	from
         |	 (
         |	 	 --INNET_MONTHS,
         |		 select MONTH_ID,DEVICE_NUMBER,CUST_SEX ,CERT_AGE ,toFloat64OrZero(TOTAL_FEE) as TOTAL_FEE,
         |		 MANU_NAME,toUInt8OrZero(IS_ACCT) as IS_ACCT,PRODUCT_CLASS_DESC,toFloat64OrZero(TOTAL_FLUX) as TOTAL_FLUX,
         |		 toFloat64OrZero(TOTAL_FLUX_VIDEO) as REAL_TOTAL_FLUX_VIDEO  from  ads.XXH_ALL_MONTH
         |		  where MONTH_ID in ('${p3month}','${p4month}','${p5month}')
         |			 --and  DEVICE_NUMBER ='15694037210'
         |			 and DEVICE_NUMBER in (select distinct USERID from ads.HIS_FLOW_ORDER where THEMONTH ='${month}' and (dateDiff('month', ORDERTIME, toDate('${dateStr}'))+1)<13)
         |	 ) s
         |	group by DEVICE_NUMBER
         |) s2
         | on s0.USERID=s2.DEVICE_NUMBER
         |) t2 on t1.USERID=t2.USERID
         |""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }




  ///生成退订预测数据C4
  def zt_tag_cancel_data_C4(month:String,is_Cancel:Int=0,isDropMonth:Boolean=false):Int ={
    //判断传进来的日期是否 为当月
   // var isDropMonth:Boolean=false
//    val nowMonth:String= DateUtils.nowDate("yyyyMM")
//    if(isDropMonth==month){
//      isDropMonth=true
//    }
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    val pr1full_month=DateUtils.getNMonth(dateStr, 1,"yyyy-MM-dd")
    val p1month=DateUtils.getNMonth(dateStr, 0,"yyyyMM")
    val p2month=DateUtils.getNMonth(dateStr, -1,"yyyyMM")
    val p3month=DateUtils.getNMonth(dateStr, -2,"yyyyMM")
    val p4month=DateUtils.getNMonth(dateStr, -3,"yyyyMM")
    val p5month=DateUtils.getNMonth(dateStr, -4,"yyyyMM")

    val theDay=DateUtils.getNMonth(dateStr, 1,"yyyyMM")+"01"
    val per3Day=p4month+"01"

    //如果是当月的数据 调用时删除原数据 重新生成
    if(isDropMonth==true) {
      var sql_Drop: String =
        s"""
           |alter table ads.ALS_XXH_CANCEL_NEW_C4 drop partition '${month}'
           |""".stripMargin + ""
      //执行2
      RunClickhouseSQL(sql_Drop);
      Thread.sleep(3000)

      var sql_Drop1: String =
        s"""
           |alter table ads.ALS_XXH_CANCEL_NEW_C4_lowDim drop partition '${month}'
           |""".stripMargin + ""
      //执行2
      RunClickhouseSQL(sql_Drop1);
      Thread.sleep(3000)

      var sql_Drop2: String =
        s"""
           |alter table ads.ALS_XXH_CANCEL_RESULT_C4 drop partition '${month}'
           |""".stripMargin + ""
      //执行2
      RunClickhouseSQL(sql_Drop2);
      Thread.sleep(3000)

      var sql_Drop3: String =
        s"""
           |alter table ads.FIN_XXH_CANCEL_NEW_C4_RESULT drop partition '${month}'
           |""".stripMargin + ""
      //执行2
      RunClickhouseSQL(sql_Drop3);
      Thread.sleep(3000)
    }

    var sql_Cancel: String ="";
    //查退订
    if(is_Cancel==1){
      sql_Cancel=" and IS_CANCEL=1 ";
    }
    if(is_Cancel== -1){
      sql_Cancel=" ";
    }
    if(is_Cancel== 0){
      sql_Cancel=" and IS_CANCEL=0 ";
    }

    var sql:String=""
    sql=sql+
      s"""
         |insert into ads.ALS_XXH_CANCEL_NEW_C4
         |select '${month}' as TARGET_MONTH,
         |	s0.USERID as USERID,`PROVINCE`,`CHANNEL`,s0.CPID as CPID,s0.SPID as SPID,`ORDERTIME`,DIFF_MONYH,`DIFF_MONYH_TYPE`,`IS_CANCEL`,e1.`PRICE` as `PRICE`,toFloat64OrZero(e1.MAXFLOW ) as MAXFLOW,
         |	if(isNaN(MAvg3_Flow),0,MAvg3_Flow) as MAvg3_Flow,`MPer1_Flow`,
         |	--处理当月流量，使其更合理
         |	`M1_Flow`,dateDiff('day', ORDERTIME, now()) as diffDay,if(diffDay<30,(30/diffDay)*M1_Flow,M1_Flow) as M1_Flow01,if(M1_Flow01>MAXFLOW,MAXFLOW,M1_Flow01) as M1_Flow02,
         |	MAvg3_Flow/MAXFLOW as MAvg3_Flow_P,MPer1_Flow/MAXFLOW as MPer1_Flow_P,M1_Flow02/MAXFLOW as M1_Flow02_P,
         |	ifNull(CUST_SEX,'未知') CUST_SEX,ifNull(CERT_AGE,'未知') CERT_AGE ,ifNull(TOTAL_FEE_AVG,0) TOTAL_FEE_AVG,
         |	ifNull(MANU_NAME,'未知') MANU_NAME ,ifNull(IS_ACCT_AVG,0) IS_ACCT_AVG ,ifNull(TOTAL_FLUX_AVG,0) TOTAL_FLUX_AVG,
         |	ifNull(TOTAL_FLUX_VIDEO_AVG,0) TOTAL_FLUX_VIDEO_AVG,BELONGTO,concat('c',toString(CPTYPE)) as CPTYPE,if(USERVAL='','unget','get') as IS_VIP,ORDER_HOUR
         |	--new
         |	,taocan.PRICE as PACKAGE_PRICE,H_FLUX,IS_DAWANG
         |	,MPer1_TOTAL_FLUX,MPer2_TOTAL_FLUX,MPer3_TOTAL_FLUX,MPer4_TOTAL_FLUX,MPer1_TOTAL_VIDEO_FLUX,MPer2_TOTAL_VIDEO_FLUX,MPer3_TOTAL_VIDEO_FLUX,MPer4_TOTAL_VIDEO_FLUX
         |	,MPer1_Flow_kuaishou,MPer2_Flow_kuaishou,MPer3_Flow_kuaishou,MPer4_Flow_kuaishou
         |	,MPer1_Flow_tencent,MPer2_Flow_tencent,MPer3_Flow_tencent,MPer4_Flow_tencent,
         |	MPer1_Flow_bilibl,MPer2_Flow_bilibl,MPer3_Flow_bilibl,MPer4_Flow_bilibl,
         |	MPer1_Flow_aiqy,MPer2_Flow_aiqy,MPer3_Flow_aiqy,MPer4_Flow_aiqy,
         |	MPer1_Flow_youtu,MPer2_Flow_youtu,MPer3_Flow_youtu,MPer4_Flow_youtu
         |	from
         |	(
         |		--订购数据
         |		select USERID,any(PROVINCE) as PROVINCE,CHANNEL,CPID ,SPID,
         |		ORDERTIME,--CANCELTIME,
         |		DIFF_MONYH,DIFF_MONYH_TYPE,IS_CANCEL,ORDER_HOUR
         |		from (
         |			with toString(THEMONTH) as mstr
         |			select USERID,THEMONTH,replaceOne(replaceOne(replaceOne(PROVINCE,'省',''),'市',''),'自治区','') as PROVINCE,CHANNEL,CPID,SPID,
         |			ORDERTIME,--CANCELTIME,
         |			dateDiff('month', ORDERTIME, toDate(concat(SUBSTRING(mstr,1,4),'-' ,SUBSTRING(mstr,5,2),'-01')))+1 DIFF_MONYH,
         |			multiIf(DIFF_MONYH>6,'diff6_p',DIFF_MONYH>=4 and DIFF_MONYH<=6 ,'diff4_6',concat('diff',toString(DIFF_MONYH))) as DIFF_MONYH_TYPE,
         |			if(CANCELTIME!='1970-01-01' and CANCELTIME <'${pr1full_month}',1,0) as IS_CANCEL,
         |      concat('h',toString(floor(toHour(ORDERTIME2,'Asia/Shanghai')/3))) as ORDER_HOUR
         |			from
         |			ads.HIS_FLOW_ORDER
         |			where THEMONTH ='${month}' and DIFF_MONYH<13
         |      and SPID !='99144186'
         |      ${sql_Cancel}
         |			-- and DIFF_MONYH>3 	order by USERID
         |			-- and USERID ='15694037210'
         |		) group by  USERID,SPID,CPID,ORDERTIME,CHANNEL,DIFF_MONYH,DIFF_MONYH_TYPE,IS_CANCEL,ORDER_HOUR
         |	) s0
         |	left join
         |	(
         |		--流量使用数据
         |		select USERID,SPID,
         |		-- 前三月平均流量
         |		avgIf(SumMonthFlow,THEMONTH<'${month}') as MAvg3_Flow,
         |		-- 最近一月流量
         |		anyIf(SumMonthFlow,THEMONTH='${p2month}') as MPer1_Flow,
         |		-- 当月此时使用流量
         |		anyIf(SumMonthFlow,THEMONTH='${month}') as M1_Flow from
         |		(
         |			--算出每个月 每人 每产品 流量和
         |			select THEMONTH,USERID,SPID,sum(FLOW) as SumMonthFlow from
         |			(
         |				select THEMONTH,USERID,SPID,FLOW from ads.TD_DXFLOWINPUT_MONTH
         |				where THEMONTH in ('${p4month}','${p3month}','${p2month}','${month}')
         |				-- and USERID ='15694037210'
         |			)
         |			group by THEMONTH,USERID,SPID
         |		) group by USERID,SPID
         |	) s1 on s0.USERID=s1.USERID and s0.SPID=s1.SPID
         |	left join ads.ETL_V_TB_SP_INFO e1 on s0.SPID=e1.SPID
         | 	left join ads.DIM_TB_CHANNELS c1 on s0.CHANNEL=c1.ID
         |	left join
         |	(
         |		select DISTINCT USERVAL
         |		from ads.ETL_TL_VIP_LOG
         |		where THEDAY >='${per3Day}'
         |		and THEDAY<'${theDay}'
         |		and VIPID in
         |		(select VIPID from ads.DIM_SXXHY)
         |	) v1 on s0.USERID=v1.USERVAL
         |	left join
         |	(
         |		select DEVICE_NUMBER,avgIf(TOTAL_FEE,IS_ACCT=1) as TOTAL_FEE_AVG,
         |		any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC,
         |		any(MANU_NAME) as MANU_NAME,avg(IS_ACCT) as IS_ACCT_AVG,
         |		avg(TOTAL_FLUX) as TOTAL_FLUX_AVG,
         |		avg(REAL_TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO_AVG,
         |  		-- 前1月流量
         |		anyOrNullIf(TOTAL_FLUX,MONTH_ID='${p2month}') as MPer1_TOTAL_FLUX,
         |		-- 前2月流量
         |		anyOrNullIf(TOTAL_FLUX,MONTH_ID='${p3month}') as MPer2_TOTAL_FLUX,
         |		-- 前3月流量
         |		anyOrNullIf(TOTAL_FLUX,MONTH_ID='${p4month}') as MPer3_TOTAL_FLUX,
         |		-- 前4月流量
         |		anyOrNullIf(TOTAL_FLUX,MONTH_ID='${p5month}') as MPer4_TOTAL_FLUX,
         |		-- 前1月流量
         |		anyOrNullIf(REAL_TOTAL_FLUX_VIDEO,MONTH_ID='${p2month}') as MPer1_TOTAL_VIDEO_FLUX,
         |		-- 前2月流量
         |		anyOrNullIf(REAL_TOTAL_FLUX_VIDEO,MONTH_ID='${p3month}') as MPer2_TOTAL_VIDEO_FLUX,
         |		-- 前3月流量
         |		anyOrNullIf(REAL_TOTAL_FLUX_VIDEO,MONTH_ID='${p4month}') as MPer3_TOTAL_VIDEO_FLUX,
         |		-- 前4月流量
         |		anyOrNullIf(REAL_TOTAL_FLUX_VIDEO,MONTH_ID='${p5month}') as MPer4_TOTAL_VIDEO_FLUX
         |    from
         |		 (
         |		 	 --INNET_MONTHS,
         |			 select MONTH_ID,DEVICE_NUMBER,CUST_SEX ,CERT_AGE ,toFloat64OrZero(TOTAL_FEE) as TOTAL_FEE,
         |			 MANU_NAME,toUInt8OrZero(IS_ACCT) as IS_ACCT,PRODUCT_CLASS_DESC,toFloat64OrZero(TOTAL_FLUX) as TOTAL_FLUX,
         |			 toFloat64OrZero(TOTAL_FLUX_VIDEO) as REAL_TOTAL_FLUX_VIDEO  from  ads.XXH_ALL_MONTH
         |			 where MONTH_ID in ('${p2month}','${p3month}','${p4month}','${p5month}')
         |			 --and  DEVICE_NUMBER ='15694037210'
         |			 and DEVICE_NUMBER in (select distinct USERID from ads.HIS_FLOW_ORDER where THEMONTH ='${month}' and (dateDiff('month', ORDERTIME, toDate('${dateStr}'))+1)<13)
         |		 ) s
         |		group by DEVICE_NUMBER
         |	) s2 on s0.USERID=s2.DEVICE_NUMBER
         | left join ads.ETL_TB_TAOCAN_INFO_2 taocan on s2.PRODUCT_CLASS_DESC=taocan.PRODUCT_CLASS_DESC
         |	left JOIN
         | 	(select DEVICE_NUMBER,CUST_SEX,CERT_AGE from  ads.XXH_ALL_MONTH_LONG	where
         | 		DEVICE_NUMBER in
         | 		(select distinct USERID from ads.HIS_FLOW_ORDER where THEMONTH ='${month}' and (dateDiff('month', ORDERTIME, toDate('${dateStr}'))+1)<13)
         | 		 --and  DEVICE_NUMBER ='15501470503'
         | 	) lo on s0.USERID=lo.DEVICE_NUMBER
         | 	--快手数据
         | 	left JOIN
         | 	(
         | 	select DEVICE_NUMBER,
         |		-- 前1月流量
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p2month}' and APP_NAME='快手') as MPer1_Flow_kuaishou,
         |		-- 前2月流量
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p3month}' and APP_NAME='快手') as MPer2_Flow_kuaishou,
         |		-- 前3月流量
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p4month}' and APP_NAME='快手') as MPer3_Flow_kuaishou,
         |		-- 前4月流量
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p5month}' and APP_NAME='快手') as MPer4_Flow_kuaishou,
         |				anyOrNullIf(MonthFlow,MONTH_ID='${p2month}' and APP_NAME='腾讯视频') as MPer1_Flow_tencent,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p3month}' and APP_NAME='腾讯视频') as MPer2_Flow_tencent,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p4month}' and APP_NAME='腾讯视频') as MPer3_Flow_tencent,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p5month}' and APP_NAME='腾讯视频') as MPer4_Flow_tencent,
         |				anyOrNullIf(MonthFlow,MONTH_ID='${p2month}' and APP_NAME='哔哩哔哩') as MPer1_Flow_bilibl,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p3month}' and APP_NAME='哔哩哔哩') as MPer2_Flow_bilibl,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p4month}' and APP_NAME='哔哩哔哩') as MPer3_Flow_bilibl,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p5month}' and APP_NAME='哔哩哔哩') as MPer4_Flow_bilibl,
         |				anyOrNullIf(MonthFlow,MONTH_ID='${p2month}' and APP_NAME='爱奇艺') as MPer1_Flow_aiqy,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p3month}' and APP_NAME='爱奇艺') as MPer2_Flow_aiqy,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p4month}' and APP_NAME='爱奇艺') as MPer3_Flow_aiqy,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p5month}' and APP_NAME='爱奇艺') as MPer4_Flow_aiqy,
         |				anyOrNullIf(MonthFlow,MONTH_ID='${p2month}' and APP_NAME='优酷视频') as MPer1_Flow_youtu,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p3month}' and APP_NAME='优酷视频') as MPer2_Flow_youtu,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p4month}' and APP_NAME='优酷视频') as MPer3_Flow_youtu,
         |		anyOrNullIf(MonthFlow,MONTH_ID='${p5month}' and APP_NAME='优酷视频') as MPer4_Flow_youtu
         |		from
         |		(
         |			select MONTH_ID,DEVICE_NUMBER,APP_NAME,MAX(ONE_FLUX) as MonthFlow from
         |			(
         |				select MONTH_ID ,DEVICE_NUMBER,APP_NAME,ONE_FLUX from ads.XXH_ALL_APP_MONTH
         |				where MONTH_ID in ('${p2month}','${p3month}','${p4month}','${p5month}')
         |				and APP_NAME in ('快手','腾讯视频','哔哩哔哩','爱奇艺','优酷视频')
         |				--and DEVICE_NUMBER ='15501470503'
         |				and DEVICE_NUMBER in
         | 				(select distinct USERID from ads.HIS_FLOW_ORDER where THEMONTH ='${month}' and (dateDiff('month', ORDERTIME, toDate('${dateStr}'))+1)<13)
         |			)
         |			group by MONTH_ID,APP_NAME,DEVICE_NUMBER
         |		) group by DEVICE_NUMBER
         | 	) t_app on s0.USERID=t_app.DEVICE_NUMBER
         |   where e1.CPTYPE in ('0','1')
         |""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  def zt_tag_cancel_data_C4_2(month:String):Int ={

    var sql:String=""
    sql=sql+
      s"""
         |--CREATE TABLE ads.ALS_XXH_CANCEL_NEW_C4_lowDim ENGINE = MergeTree
         |--PARTITION BY TARGET_MONTH
         |--ORDER BY USERID as
         |insert into ads.ALS_XXH_CANCEL_NEW_C4_lowDim
         |select
         |TARGET_MONTH,USERID,PRICE,MAXFLOW,TOTAL_FEE_AVG,IS_ACCT_AVG,
         |PROVINCE,CHANNEL,CPID,SPID,DIFF_MONYH_TYPE,CUST_SEX,CERT_AGE,MANU_NAME,BELONGTO,CPTYPE,
         |IS_VIP,MPer1_Flow,MAvg3_Flow,M1_Flow02,pprice,PACKAGE_PRICE_TYPE,H_FLUX_TYPE,IS_DAWANG,
         |'+++流量+++' as cl1,
         |--MPer3_TOTAL_FLUX,MPer3_TOTAL_VIDEO_FLUX,
         |--TOTAL_FLUX 99000  TOTAL_FLUX_VIDEO 50000
         |MAvg_TOTAL_FLUX_1_3,
         |if(MAvg_TOTAL_FLUX_1_3>99000,99000,MAvg_TOTAL_FLUX_1_3)/99000 as MAvg_TOTAL_FLUX_1_3_zs,
         |ifNull(MPer1_TOTAL_FLUX,MAvg_TOTAL_FLUX_1_3) as MPer1_TOTAL_FLUX,
         |if(MPer1_TOTAL_FLUX>99000,99000,MPer1_TOTAL_FLUX)/99000 as MPer1_TOTAL_FLUX_zs,
         |MAvg_TOTAL_VIDEO_FLUX_1_3,
         |if(MAvg_TOTAL_VIDEO_FLUX_1_3>50000,50000,MAvg_TOTAL_VIDEO_FLUX_1_3)/50000 as MAvg_TOTAL_VIDEO_FLUX_1_3_zs,
         |ifNull(MPer1_TOTAL_VIDEO_FLUX,MAvg_TOTAL_VIDEO_FLUX_1_3) as MPer1_TOTAL_VIDEO_FLUX,
         |if(MPer1_TOTAL_VIDEO_FLUX>50000,50000,MPer1_TOTAL_VIDEO_FLUX)/50000 as MPer1_TOTAL_VIDEO_FLUX_zs,
         |--分桶nan 0  1 2 5 10 20 50 +
         |Mavg_TOTAL_FLUX_GRAD_1_3,
         |multiIf(isNaN(Mavg_TOTAL_FLUX_GRAD_1_3),'Mavg_TOTAL_FLUX_GRAD_1_3_vNAN',Mavg_TOTAL_FLUX_GRAD_1_3=0 ,'Mavg_TOTAL_FLUX_GRAD_1_3_v0',
         |Mavg_TOTAL_FLUX_GRAD_1_3>0 and Mavg_TOTAL_FLUX_GRAD_1_3<=1000,'Mavg_TOTAL_FLUX_GRAD_1_3_正0_1',Mavg_TOTAL_FLUX_GRAD_1_3>1000 and Mavg_TOTAL_FLUX_GRAD_1_3<=2000,'Mavg_TOTAL_FLUX_GRAD_1_3_正1_2',
         |Mavg_TOTAL_FLUX_GRAD_1_3>2000 and Mavg_TOTAL_FLUX_GRAD_1_3<=5000,'Mavg_TOTAL_FLUX_GRAD_1_3_正2_5',Mavg_TOTAL_FLUX_GRAD_1_3>5000 and Mavg_TOTAL_FLUX_GRAD_1_3<=10000,'Mavg_TOTAL_FLUX_GRAD_1_3_正5_10',
         |Mavg_TOTAL_FLUX_GRAD_1_3>10000 and Mavg_TOTAL_FLUX_GRAD_1_3<=20000,'Mavg_TOTAL_FLUX_GRAD_1_3_正10_20',Mavg_TOTAL_FLUX_GRAD_1_3>20000 and Mavg_TOTAL_FLUX_GRAD_1_3<=50000,'Mavg_TOTAL_FLUX_GRAD_1_3_正20_50',
         |Mavg_TOTAL_FLUX_GRAD_1_3>50000 ,'Mavg_TOTAL_FLUX_GRAD_1_3_正50_p',
         |Mavg_TOTAL_FLUX_GRAD_1_3<0 and Mavg_TOTAL_FLUX_GRAD_1_3>=-1000,'Mavg_TOTAL_FLUX_GRAD_1_3_负0_1',Mavg_TOTAL_FLUX_GRAD_1_3<-1000 and Mavg_TOTAL_FLUX_GRAD_1_3>=-2000,'Mavg_TOTAL_FLUX_GRAD_1_3_负1_2',
         |Mavg_TOTAL_FLUX_GRAD_1_3<-2000 and Mavg_TOTAL_FLUX_GRAD_1_3>=-5000,'Mavg_TOTAL_FLUX_GRAD_1_3_负2_5',Mavg_TOTAL_FLUX_GRAD_1_3<-5000 and Mavg_TOTAL_FLUX_GRAD_1_3>=-10000,'Mavg_TOTAL_FLUX_GRAD_1_3_负5_10',
         |Mavg_TOTAL_FLUX_GRAD_1_3<-10000 and Mavg_TOTAL_FLUX_GRAD_1_3>=-20000,'Mavg_TOTAL_FLUX_GRAD_1_3_负10_20',Mavg_TOTAL_FLUX_GRAD_1_3<-20000 and Mavg_TOTAL_FLUX_GRAD_1_3>=-50000,'Mavg_TOTAL_FLUX_GRAD_1_3_负20_50',
         |Mavg_TOTAL_FLUX_GRAD_1_3<-50000 ,'Mavg_TOTAL_FLUX_GRAD_1_3_负50_p','xxx') as Mavg_TOTAL_FLUX_GRAD_1_3_TYPE,
         |--
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3,
         |multiIf(isNaN(Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3),'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_vNAN',Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3=0 ,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_v0',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>0 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<=1000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_正0_1',Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>1000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<=2000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_正1_2',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>2000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<=5000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_正2_5',Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>5000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<=10000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_正5_10',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>10000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<=20000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_正10_20',Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>20000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<=50000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_正20_50',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>50000 ,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_正50_p',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<0 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>=-1000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_负0_1',Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<-1000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>=-2000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_负1_2',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<-2000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>=-5000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_负2_5',Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<-5000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>=-10000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_负5_10',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<-10000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>=-20000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_负10_20',Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<-20000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3>=-50000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_负20_50',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3<-50000 ,'Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_负50_p','xxx') as Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3_TYPE,
         |if(arrayReduce('avg',[Div_vFlux_tFlux_1_3,DivAvg_vFlux_tFlux_1_3])>1,1,arrayReduce('avg',[Div_vFlux_tFlux_1_3,DivAvg_vFlux_tFlux_1_3])) as Div_vFlux_tFlux_1_3,
         |
         |
         |MAvg_TOTAL_FLUX_2_4,
         |if(MAvg_TOTAL_FLUX_2_4>99000,99000,MAvg_TOTAL_FLUX_2_4)/99000 as MAvg_TOTAL_FLUX_2_4_zs,
         |ifNull(MPer2_TOTAL_FLUX,MAvg_TOTAL_FLUX_2_4) as MPer2_TOTAL_FLUX,
         |if(MPer2_TOTAL_FLUX>99000,99000,MPer2_TOTAL_FLUX)/99000 as MPer2_TOTAL_FLUX_zs,
         |MAvg_TOTAL_VIDEO_FLUX_2_4,
         |if(MAvg_TOTAL_VIDEO_FLUX_2_4>50000,50000,MAvg_TOTAL_VIDEO_FLUX_2_4)/50000 as MAvg_TOTAL_VIDEO_FLUX_2_4_zs,
         |ifNull(MPer2_TOTAL_VIDEO_FLUX,MAvg_TOTAL_VIDEO_FLUX_2_4) as MPer2_TOTAL_VIDEO_FLUX,
         |if(MPer2_TOTAL_VIDEO_FLUX>50000,50000,MPer2_TOTAL_VIDEO_FLUX)/50000 as MPer2_TOTAL_VIDEO_FLUX_zs,
         |--分桶nan 0  1 2 5 10 20 50 +
         |Mavg_TOTAL_FLUX_GRAD_2_4,
         |multiIf(isNaN(Mavg_TOTAL_FLUX_GRAD_2_4),'Mavg_TOTAL_FLUX_GRAD_2_4_vNAN',Mavg_TOTAL_FLUX_GRAD_2_4=0 ,'Mavg_TOTAL_FLUX_GRAD_2_4_v0',
         |Mavg_TOTAL_FLUX_GRAD_2_4>0 and Mavg_TOTAL_FLUX_GRAD_2_4<=1000,'Mavg_TOTAL_FLUX_GRAD_2_4_正0_1',Mavg_TOTAL_FLUX_GRAD_2_4>1000 and Mavg_TOTAL_FLUX_GRAD_2_4<=2000,'Mavg_TOTAL_FLUX_GRAD_2_4_正1_2',
         |Mavg_TOTAL_FLUX_GRAD_2_4>2000 and Mavg_TOTAL_FLUX_GRAD_2_4<=5000,'Mavg_TOTAL_FLUX_GRAD_2_4_正2_5',Mavg_TOTAL_FLUX_GRAD_2_4>5000 and Mavg_TOTAL_FLUX_GRAD_2_4<=10000,'Mavg_TOTAL_FLUX_GRAD_2_4_正5_10',
         |Mavg_TOTAL_FLUX_GRAD_2_4>10000 and Mavg_TOTAL_FLUX_GRAD_2_4<=20000,'Mavg_TOTAL_FLUX_GRAD_2_4_正10_20',Mavg_TOTAL_FLUX_GRAD_2_4>20000 and Mavg_TOTAL_FLUX_GRAD_2_4<=50000,'Mavg_TOTAL_FLUX_GRAD_2_4_正20_50',
         |Mavg_TOTAL_FLUX_GRAD_2_4>50000 ,'Mavg_TOTAL_FLUX_GRAD_2_4_正50_p',
         |Mavg_TOTAL_FLUX_GRAD_2_4<0 and Mavg_TOTAL_FLUX_GRAD_2_4>=-1000,'Mavg_TOTAL_FLUX_GRAD_2_4_负0_1',Mavg_TOTAL_FLUX_GRAD_2_4<-1000 and Mavg_TOTAL_FLUX_GRAD_2_4>=-2000,'Mavg_TOTAL_FLUX_GRAD_2_4_负1_2',
         |Mavg_TOTAL_FLUX_GRAD_2_4<-2000 and Mavg_TOTAL_FLUX_GRAD_2_4>=-5000,'Mavg_TOTAL_FLUX_GRAD_2_4_负2_5',Mavg_TOTAL_FLUX_GRAD_2_4<-5000 and Mavg_TOTAL_FLUX_GRAD_2_4>=-10000,'Mavg_TOTAL_FLUX_GRAD_2_4_负5_10',
         |Mavg_TOTAL_FLUX_GRAD_2_4<-10000 and Mavg_TOTAL_FLUX_GRAD_2_4>=-20000,'Mavg_TOTAL_FLUX_GRAD_2_4_负10_20',Mavg_TOTAL_FLUX_GRAD_2_4<-20000 and Mavg_TOTAL_FLUX_GRAD_2_4>=-50000,'Mavg_TOTAL_FLUX_GRAD_2_4_负20_50',
         |Mavg_TOTAL_FLUX_GRAD_2_4<-50000 ,'Mavg_TOTAL_FLUX_GRAD_2_4_负50_p','xxx') as Mavg_TOTAL_FLUX_GRAD_2_4_TYPE,
         |--
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4,
         |multiIf(isNaN(Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4),'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_vNAN',Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4=0 ,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_v0',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>0 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<=1000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_正0_1',Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>1000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<=2000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_正1_2',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>2000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<=5000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_正2_5',Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>5000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<=10000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_正5_10',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>10000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<=20000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_正10_20',Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>20000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<=50000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_正20_50',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>50000 ,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_正50_p',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<0 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>=-1000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_负0_1',Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<-1000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>=-2000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_负1_2',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<-2000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>=-5000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_负2_5',Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<-5000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>=-10000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_负5_10',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<-10000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>=-20000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_负10_20',Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<-20000 and Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4>=-50000,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_负20_50',
         |Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4<-50000 ,'Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_负50_p','xxx') as Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4_TYPE,
         |if(arrayReduce('avg',[Div_vFlux_tFlux_2_4,DivAvg_vFlux_tFlux_2_4])>1,1,arrayReduce('avg',[Div_vFlux_tFlux_2_4,DivAvg_vFlux_tFlux_2_4])) as Div_vFlux_tFlux_2_4,
         |'+++快手+++' as cl2,
         |-- kuaishou 50   其他 20
         |MAvg_Flow_kuaishou_1_3,
         |ifNull(MPer1_Flow_kuaishou,MAvg_Flow_kuaishou_1_3) as MPer1_Flow_kuaishou,
         |if(MAvg_Flow_kuaishou_1_3>50000,50000,MAvg_Flow_kuaishou_1_3)/50000 as MAvg_Flow_kuaishou_1_3_zs,
         |if(MPer1_Flow_kuaishou>50000,50000,MPer1_Flow_kuaishou)/50000 as MPer1_Flow_kuaishou_zs,
         |--分桶nan 0 500 1 2 5 10 20 +
         |Mavg_Flow_kuaishou_GRAD_1_3,
         |multiIf(isNaN(Mavg_Flow_kuaishou_GRAD_1_3),'Mavg_Flow_kuaishou_GRAD_1_3_vNAN',Mavg_Flow_kuaishou_GRAD_1_3=0 ,'Mavg_Flow_kuaishou_GRAD_1_3_v0',
         |Mavg_Flow_kuaishou_GRAD_1_3>0 and Mavg_Flow_kuaishou_GRAD_1_3<=500,'Mavg_Flow_kuaishou_GRAD_1_3_正0_0.5',Mavg_Flow_kuaishou_GRAD_1_3>500 and Mavg_Flow_kuaishou_GRAD_1_3<=1000,'Mavg_Flow_kuaishou_GRAD_1_3_正0.5_1',
         |Mavg_Flow_kuaishou_GRAD_1_3>1000 and Mavg_Flow_kuaishou_GRAD_1_3<=2000,'Mavg_Flow_kuaishou_GRAD_1_3_正1_2',Mavg_Flow_kuaishou_GRAD_1_3>2000 and Mavg_Flow_kuaishou_GRAD_1_3<=5000,'Mavg_Flow_kuaishou_GRAD_1_3_正2_5',
         |Mavg_Flow_kuaishou_GRAD_1_3>5000 and Mavg_Flow_kuaishou_GRAD_1_3<=10000,'Mavg_Flow_kuaishou_GRAD_1_3_正5_10',Mavg_Flow_kuaishou_GRAD_1_3>10000 and Mavg_Flow_kuaishou_GRAD_1_3<=20000,'Mavg_Flow_kuaishou_GRAD_1_3_正10_20',
         |Mavg_Flow_kuaishou_GRAD_1_3>20000 ,'Mavg_Flow_kuaishou_GRAD_1_3_正20_p',
         |Mavg_Flow_kuaishou_GRAD_1_3<0 and Mavg_Flow_kuaishou_GRAD_1_3>=-500,'Mavg_Flow_kuaishou_GRAD_1_3_负0_0.5',Mavg_Flow_kuaishou_GRAD_1_3<-500 and Mavg_Flow_kuaishou_GRAD_1_3>=-1000,'Mavg_Flow_kuaishou_GRAD_1_3_负0.5_1',
         |Mavg_Flow_kuaishou_GRAD_1_3<-1000 and Mavg_Flow_kuaishou_GRAD_1_3>=-2000,'Mavg_Flow_kuaishou_GRAD_1_3_负1_2',Mavg_Flow_kuaishou_GRAD_1_3<-2000 and Mavg_Flow_kuaishou_GRAD_1_3>=-5000,'Mavg_Flow_kuaishou_GRAD_1_3_负2_5',
         |Mavg_Flow_kuaishou_GRAD_1_3<-5000 and Mavg_Flow_kuaishou_GRAD_1_3>=-10000,'Mavg_Flow_kuaishou_GRAD_1_3_负5_10',Mavg_Flow_kuaishou_GRAD_1_3<-10000 and Mavg_Flow_kuaishou_GRAD_1_3>=-20000,'Mavg_Flow_kuaishou_GRAD_1_3_负10_20',
         |Mavg_Flow_kuaishou_GRAD_1_3<-20000 ,'Mavg_Flow_kuaishou_GRAD_1_3_负20_p','xxx') as Mavg_Flow_kuaishou_GRAD_1_3_TYPE,
         |if(arrayReduce('avg',[Div_kuaishou_vFlux_1_3,DivAvg_kuaishou_vFlux_1_3])>1,1,arrayReduce('avg',[Div_kuaishou_vFlux_1_3,DivAvg_kuaishou_vFlux_1_3])) as Div_kuaishou_vFlux_1_3,
         |MAvg_Flow_kuaishou_2_4,
         |ifNull(MPer2_Flow_kuaishou,MAvg_Flow_kuaishou_2_4) as MPer2_Flow_kuaishou,
         |if(MAvg_Flow_kuaishou_2_4>50000,50000,MAvg_Flow_kuaishou_2_4)/50000 as MAvg_Flow_kuaishou_2_4_zs,
         |if(MPer2_Flow_kuaishou>50000,50000,MPer2_Flow_kuaishou)/50000 as MPer2_Flow_kuaishou_zs,
         |--
         |Mavg_Flow_kuaishou_GRAD_2_4,
         |multiIf(isNaN(Mavg_Flow_kuaishou_GRAD_2_4),'Mavg_Flow_kuaishou_GRAD_2_4_vNAN',Mavg_Flow_kuaishou_GRAD_2_4=0 ,'Mavg_Flow_kuaishou_GRAD_2_4_v0',
         |Mavg_Flow_kuaishou_GRAD_2_4>0 and Mavg_Flow_kuaishou_GRAD_2_4<=500,'Mavg_Flow_kuaishou_GRAD_2_4_正0_0.5',Mavg_Flow_kuaishou_GRAD_2_4>500 and Mavg_Flow_kuaishou_GRAD_2_4<=1000,'Mavg_Flow_kuaishou_GRAD_2_4_正0.5_1',
         |Mavg_Flow_kuaishou_GRAD_2_4>1000 and Mavg_Flow_kuaishou_GRAD_2_4<=2000,'Mavg_Flow_kuaishou_GRAD_2_4_正1_2',Mavg_Flow_kuaishou_GRAD_2_4>2000 and Mavg_Flow_kuaishou_GRAD_2_4<=5000,'Mavg_Flow_kuaishou_GRAD_2_4_正2_5',
         |Mavg_Flow_kuaishou_GRAD_2_4>5000 and Mavg_Flow_kuaishou_GRAD_2_4<=10000,'Mavg_Flow_kuaishou_GRAD_2_4_正5_10',Mavg_Flow_kuaishou_GRAD_2_4>10000 and Mavg_Flow_kuaishou_GRAD_2_4<=20000,'Mavg_Flow_kuaishou_GRAD_2_4_正10_20',
         |Mavg_Flow_kuaishou_GRAD_2_4>20000 ,'Mavg_Flow_kuaishou_GRAD_2_4_正20_p',
         |Mavg_Flow_kuaishou_GRAD_2_4<0 and Mavg_Flow_kuaishou_GRAD_2_4>=-500,'Mavg_Flow_kuaishou_GRAD_2_4_负0_0.5',Mavg_Flow_kuaishou_GRAD_2_4<-500 and Mavg_Flow_kuaishou_GRAD_2_4>=-1000,'Mavg_Flow_kuaishou_GRAD_2_4_负0.5_1',
         |Mavg_Flow_kuaishou_GRAD_2_4<-1000 and Mavg_Flow_kuaishou_GRAD_2_4>=-2000,'Mavg_Flow_kuaishou_GRAD_2_4_负1_2',Mavg_Flow_kuaishou_GRAD_2_4<-2000 and Mavg_Flow_kuaishou_GRAD_2_4>=-5000,'Mavg_Flow_kuaishou_GRAD_2_4_负2_5',
         |Mavg_Flow_kuaishou_GRAD_2_4<-5000 and Mavg_Flow_kuaishou_GRAD_2_4>=-10000,'Mavg_Flow_kuaishou_GRAD_2_4_负5_10',Mavg_Flow_kuaishou_GRAD_2_4<-10000 and Mavg_Flow_kuaishou_GRAD_2_4>=-20000,'Mavg_Flow_kuaishou_GRAD_2_4_负10_20',
         |Mavg_Flow_kuaishou_GRAD_2_4<-20000 ,'Mavg_Flow_kuaishou_GRAD_2_4_负20_p','xxx') as Mavg_Flow_kuaishou_GRAD_2_4_TYPE,
         |if(arrayReduce('avg',[Div_kuaishou_vFlux_2_4,DivAvg_kuaishou_vFlux_2_4])>1,1,arrayReduce('avg',[Div_kuaishou_vFlux_2_4,DivAvg_kuaishou_vFlux_2_4])) as Div_kuaishou_vFlux_2_4,
         |'+++腾讯+++' as cl3,
         |MAvg_Flow_tencent_1_3,
         |ifNull(MPer1_Flow_tencent,MAvg_Flow_tencent_1_3) as MPer1_Flow_tencent,
         |if(MAvg_Flow_tencent_1_3>20000,20000,MAvg_Flow_tencent_1_3)/20000 as MAvg_Flow_tencent_1_3_zs,
         |if(MPer1_Flow_tencent>20000,20000,MPer1_Flow_tencent)/20000 as MPer1_Flow_tencent_zs,
         |--分桶nan 0 500 1 2 5 10  20+
         |Mavg_Flow_tencent_GRAD_1_3,
         |multiIf(isNaN(Mavg_Flow_tencent_GRAD_1_3),'Mavg_Flow_tencent_GRAD_1_3_vNAN',Mavg_Flow_tencent_GRAD_1_3=0 ,'Mavg_Flow_tencent_GRAD_1_3_v0',
         |Mavg_Flow_tencent_GRAD_1_3>0 and Mavg_Flow_tencent_GRAD_1_3<=500,'Mavg_Flow_tencent_GRAD_1_3_正0_0.5',Mavg_Flow_tencent_GRAD_1_3>500 and Mavg_Flow_tencent_GRAD_1_3<=1000,'Mavg_Flow_tencent_GRAD_1_3_正0.5_1',
         |Mavg_Flow_tencent_GRAD_1_3>1000 and Mavg_Flow_tencent_GRAD_1_3<=2000,'Mavg_Flow_tencent_GRAD_1_3_正1_2',Mavg_Flow_tencent_GRAD_1_3>2000 and Mavg_Flow_tencent_GRAD_1_3<=5000,'Mavg_Flow_tencent_GRAD_1_3_正2_5',
         |Mavg_Flow_tencent_GRAD_1_3>5000 and Mavg_Flow_tencent_GRAD_1_3<=10000,'Mavg_Flow_tencent_GRAD_1_3_正5_10',Mavg_Flow_tencent_GRAD_1_3>10000 and Mavg_Flow_tencent_GRAD_1_3<=20000,'Mavg_Flow_tencent_GRAD_1_3_正10_20',
         |Mavg_Flow_tencent_GRAD_1_3>20000 ,'Mavg_Flow_tencent_GRAD_1_3_正20_p',
         |Mavg_Flow_tencent_GRAD_1_3<0 and Mavg_Flow_tencent_GRAD_1_3>=-500,'Mavg_Flow_tencent_GRAD_1_3_负0_0.5',Mavg_Flow_tencent_GRAD_1_3<-500 and Mavg_Flow_tencent_GRAD_1_3>=-1000,'Mavg_Flow_tencent_GRAD_1_3_负0.5_1',
         |Mavg_Flow_tencent_GRAD_1_3<-1000 and Mavg_Flow_tencent_GRAD_1_3>=-2000,'Mavg_Flow_tencent_GRAD_1_3_负1_2',Mavg_Flow_tencent_GRAD_1_3<-2000 and Mavg_Flow_tencent_GRAD_1_3>=-5000,'Mavg_Flow_tencent_GRAD_1_3_负2_5',
         |Mavg_Flow_tencent_GRAD_1_3<-5000 and Mavg_Flow_tencent_GRAD_1_3>=-10000,'Mavg_Flow_tencent_GRAD_1_3_负5_10',Mavg_Flow_tencent_GRAD_1_3<-10000 and Mavg_Flow_tencent_GRAD_1_3>=-20000,'Mavg_Flow_tencent_GRAD_1_3_负10_20',
         |Mavg_Flow_tencent_GRAD_1_3<-20000 ,'Mavg_Flow_tencent_GRAD_1_3_负20_p','xxx') as Mavg_Flow_tencent_GRAD_1_3_TYPE,
         |if(arrayReduce('avg',[Div_tencent_vFlux_1_3,DivAvg_tencent_vFlux_1_3])>1,1,arrayReduce('avg',[Div_tencent_vFlux_1_3,DivAvg_tencent_vFlux_1_3])) as Div_tencent_vFlux_1_3,
         |--
         |MAvg_Flow_tencent_2_4,
         |ifNull(MPer2_Flow_tencent,MAvg_Flow_tencent_2_4) as MPer2_Flow_tencent,
         |if(MAvg_Flow_tencent_2_4>20000,20000,MAvg_Flow_tencent_2_4)/20000 as MAvg_Flow_tencent_2_4_zs,
         |if(MPer2_Flow_tencent>20000,20000,MPer2_Flow_tencent)/20000 as MPer2_Flow_tencent_zs,
         |
         |Mavg_Flow_tencent_GRAD_2_4,
         |multiIf(isNaN(Mavg_Flow_tencent_GRAD_2_4),'Mavg_Flow_tencent_GRAD_2_4_vNAN',Mavg_Flow_tencent_GRAD_2_4=0 ,'Mavg_Flow_tencent_GRAD_2_4_v0',
         |Mavg_Flow_tencent_GRAD_2_4>0 and Mavg_Flow_tencent_GRAD_2_4<=500,'Mavg_Flow_tencent_GRAD_2_4_正0_0.5',Mavg_Flow_tencent_GRAD_2_4>500 and Mavg_Flow_tencent_GRAD_2_4<=1000,'Mavg_Flow_tencent_GRAD_2_4_正0.5_1',
         |Mavg_Flow_tencent_GRAD_2_4>1000 and Mavg_Flow_tencent_GRAD_2_4<=2000,'Mavg_Flow_tencent_GRAD_2_4_正1_2',Mavg_Flow_tencent_GRAD_2_4>2000 and Mavg_Flow_tencent_GRAD_2_4<=5000,'Mavg_Flow_tencent_GRAD_2_4_正2_5',
         |Mavg_Flow_tencent_GRAD_2_4>5000 and Mavg_Flow_tencent_GRAD_2_4<=10000,'Mavg_Flow_tencent_GRAD_2_4_正5_10',Mavg_Flow_tencent_GRAD_2_4>10000 and Mavg_Flow_tencent_GRAD_2_4<=20000,'Mavg_Flow_tencent_GRAD_2_4_正10_20',
         |Mavg_Flow_tencent_GRAD_2_4>20000 ,'Mavg_Flow_tencent_GRAD_2_4_正20_p',
         |Mavg_Flow_tencent_GRAD_2_4<0 and Mavg_Flow_tencent_GRAD_2_4>=-500,'Mavg_Flow_tencent_GRAD_2_4_负0_0.5',Mavg_Flow_tencent_GRAD_2_4<-500 and Mavg_Flow_tencent_GRAD_2_4>=-1000,'Mavg_Flow_tencent_GRAD_2_4_负0.5_1',
         |Mavg_Flow_tencent_GRAD_2_4<-1000 and Mavg_Flow_tencent_GRAD_2_4>=-2000,'Mavg_Flow_tencent_GRAD_2_4_负1_2',Mavg_Flow_tencent_GRAD_2_4<-2000 and Mavg_Flow_tencent_GRAD_2_4>=-5000,'Mavg_Flow_tencent_GRAD_2_4_负2_5',
         |Mavg_Flow_tencent_GRAD_2_4<-5000 and Mavg_Flow_tencent_GRAD_2_4>=-10000,'Mavg_Flow_tencent_GRAD_2_4_负5_10',Mavg_Flow_tencent_GRAD_2_4<-10000 and Mavg_Flow_tencent_GRAD_2_4>=-20000,'Mavg_Flow_tencent_GRAD_2_4_负10_20',
         |Mavg_Flow_tencent_GRAD_2_4<-20000 ,'Mavg_Flow_tencent_GRAD_2_4_负20_p','xxx') as Mavg_Flow_tencent_GRAD_2_4_TYPE,
         |if(arrayReduce('avg',[Div_tencent_vFlux_2_4,DivAvg_tencent_vFlux_2_4])>1,1,arrayReduce('avg',[Div_tencent_vFlux_2_4,DivAvg_tencent_vFlux_2_4])) as Div_tencent_vFlux_2_4,
         |'+++哔哩+++' as cl4,
         |MAvg_Flow_bilibl_1_3,
         |ifNull(MPer1_Flow_bilibl,MAvg_Flow_bilibl_1_3) as MPer1_Flow_bilibl,
         |if(MAvg_Flow_bilibl_1_3>20000,20000,MAvg_Flow_bilibl_1_3)/20000 as MAvg_Flow_bilibl_1_3_zs,
         |if(MPer1_Flow_bilibl>20000,20000,MPer1_Flow_bilibl)/20000 as MPer1_Flow_bilibl_zs,
         |--分桶nan 0 500 1 2 5 10 +
         |Mavg_Flow_bilibl_GRAD_1_3,
         |multiIf(isNaN(Mavg_Flow_bilibl_GRAD_1_3),'Mavg_Flow_bilibl_GRAD_1_3_vNAN',Mavg_Flow_bilibl_GRAD_1_3=0 ,'Mavg_Flow_bilibl_GRAD_1_3_v0',
         |Mavg_Flow_bilibl_GRAD_1_3>0 and Mavg_Flow_bilibl_GRAD_1_3<=500,'Mavg_Flow_bilibl_GRAD_1_3_正0_0.5',Mavg_Flow_bilibl_GRAD_1_3>500 and Mavg_Flow_bilibl_GRAD_1_3<=1000,'Mavg_Flow_bilibl_GRAD_1_3_正0.5_1',
         |Mavg_Flow_bilibl_GRAD_1_3>1000 and Mavg_Flow_bilibl_GRAD_1_3<=2000,'Mavg_Flow_bilibl_GRAD_1_3_正1_2',Mavg_Flow_bilibl_GRAD_1_3>2000 and Mavg_Flow_bilibl_GRAD_1_3<=5000,'Mavg_Flow_bilibl_GRAD_1_3_正2_5',
         |Mavg_Flow_bilibl_GRAD_1_3>5000 and Mavg_Flow_bilibl_GRAD_1_3<=10000,'Mavg_Flow_bilibl_GRAD_1_3_正5_10',Mavg_Flow_bilibl_GRAD_1_3>10000 ,'Mavg_Flow_bilibl_GRAD_1_3_正10_p',
         |Mavg_Flow_bilibl_GRAD_1_3<0 and Mavg_Flow_bilibl_GRAD_1_3>=-500,'Mavg_Flow_bilibl_GRAD_1_3_负0_0.5',Mavg_Flow_bilibl_GRAD_1_3<-500 and Mavg_Flow_bilibl_GRAD_1_3>=-1000,'Mavg_Flow_bilibl_GRAD_1_3_负0.5_1',
         |Mavg_Flow_bilibl_GRAD_1_3<-1000 and Mavg_Flow_bilibl_GRAD_1_3>=-2000,'Mavg_Flow_bilibl_GRAD_1_3_负1_2',Mavg_Flow_bilibl_GRAD_1_3<-2000 and Mavg_Flow_bilibl_GRAD_1_3>=-5000,'Mavg_Flow_bilibl_GRAD_1_3_负2_5',
         |Mavg_Flow_bilibl_GRAD_1_3<-5000 and Mavg_Flow_bilibl_GRAD_1_3>=-10000,'Mavg_Flow_bilibl_GRAD_1_3_负5_10',Mavg_Flow_bilibl_GRAD_1_3<-10000 ,'Mavg_Flow_bilibl_GRAD_1_3_负10_p','xxx')
         |as Mavg_Flow_bilibl_GRAD_1_3_TYPE,
         |if(arrayReduce('avg',[Div_bilibl_vFlux_1_3,DivAvg_bilibl_vFlux_1_3])>1,1,arrayReduce('avg',[Div_bilibl_vFlux_1_3,DivAvg_bilibl_vFlux_1_3])) as Div_bilibl_vFlux_1_3,
         |
         |MAvg_Flow_bilibl_2_4,
         |ifNull(MPer2_Flow_bilibl,MAvg_Flow_bilibl_2_4) as MPer2_Flow_bilibl,
         |if(MAvg_Flow_bilibl_2_4>20000,20000,MAvg_Flow_bilibl_2_4)/20000 as MAvg_Flow_bilibl_2_4_zs,
         |if(MPer2_Flow_bilibl>20000,20000,MPer2_Flow_bilibl)/20000 as MPer2_Flow_bilibl_zs,
         |--
         |Mavg_Flow_bilibl_GRAD_2_4,
         |multiIf(isNaN(Mavg_Flow_bilibl_GRAD_2_4),'Mavg_Flow_bilibl_GRAD_2_4_vNAN',Mavg_Flow_bilibl_GRAD_2_4=0 ,'Mavg_Flow_bilibl_GRAD_2_4_v0',
         |Mavg_Flow_bilibl_GRAD_2_4>0 and Mavg_Flow_bilibl_GRAD_2_4<=500,'Mavg_Flow_bilibl_GRAD_2_4_正0_0.5',Mavg_Flow_bilibl_GRAD_2_4>500 and Mavg_Flow_bilibl_GRAD_2_4<=1000,'Mavg_Flow_bilibl_GRAD_2_4_正0.5_1',
         |Mavg_Flow_bilibl_GRAD_2_4>1000 and Mavg_Flow_bilibl_GRAD_2_4<=2000,'Mavg_Flow_bilibl_GRAD_2_4_正1_2',Mavg_Flow_bilibl_GRAD_2_4>2000 and Mavg_Flow_bilibl_GRAD_2_4<=5000,'Mavg_Flow_bilibl_GRAD_2_4_正2_5',
         |Mavg_Flow_bilibl_GRAD_2_4>5000 and Mavg_Flow_bilibl_GRAD_2_4<=10000,'Mavg_Flow_bilibl_GRAD_2_4_正5_10',Mavg_Flow_bilibl_GRAD_2_4>10000 ,'Mavg_Flow_bilibl_GRAD_2_4_正10_p',
         |Mavg_Flow_bilibl_GRAD_2_4<0 and Mavg_Flow_bilibl_GRAD_2_4>=-500,'Mavg_Flow_bilibl_GRAD_2_4_负0_0.5',Mavg_Flow_bilibl_GRAD_2_4<-500 and Mavg_Flow_bilibl_GRAD_2_4>=-1000,'Mavg_Flow_bilibl_GRAD_2_4_负0.5_1',
         |Mavg_Flow_bilibl_GRAD_2_4<-1000 and Mavg_Flow_bilibl_GRAD_2_4>=-2000,'Mavg_Flow_bilibl_GRAD_2_4_负1_2',Mavg_Flow_bilibl_GRAD_2_4<-2000 and Mavg_Flow_bilibl_GRAD_2_4>=-5000,'Mavg_Flow_bilibl_GRAD_2_4_负2_5',
         |Mavg_Flow_bilibl_GRAD_2_4<-5000 and Mavg_Flow_bilibl_GRAD_2_4>=-10000,'Mavg_Flow_bilibl_GRAD_2_4_负5_10',Mavg_Flow_bilibl_GRAD_2_4<-10000 ,'Mavg_Flow_bilibl_GRAD_2_4_负10_p','xxx')
         |as Mavg_Flow_bilibl_GRAD_2_4_TYPE,
         |if(arrayReduce('avg',[Div_bilibl_vFlux_2_4,DivAvg_bilibl_vFlux_2_4])>1,1,arrayReduce('avg',[Div_bilibl_vFlux_2_4,DivAvg_bilibl_vFlux_2_4])) as Div_bilibl_vFlux_2_4,
         |'+++爱奇艺+++' as cl5,
         |MAvg_Flow_aiqy_1_3,
         |ifNull(MPer1_Flow_aiqy,MAvg_Flow_aiqy_1_3) as MPer1_Flow_aiqy,
         |if(MAvg_Flow_aiqy_1_3>20000,20000,MAvg_Flow_aiqy_1_3)/20000 as MAvg_Flow_aiqy_1_3_zs,
         |if(MPer1_Flow_aiqy>20000,20000,MPer1_Flow_aiqy)/20000 as MPer1_Flow_aiqy_zs,
         |--分桶nan 0 500 1 2 5 10 +
         |Mavg_Flow_aiqy_GRAD_1_3,
         |multiIf(isNaN(Mavg_Flow_aiqy_GRAD_1_3),'Mavg_Flow_aiqy_GRAD_1_3_vNAN',Mavg_Flow_aiqy_GRAD_1_3=0 ,'Mavg_Flow_aiqy_GRAD_1_3_v0',
         |Mavg_Flow_aiqy_GRAD_1_3>0 and Mavg_Flow_aiqy_GRAD_1_3<=500,'Mavg_Flow_aiqy_GRAD_1_3_正0_0.5',Mavg_Flow_aiqy_GRAD_1_3>500 and Mavg_Flow_aiqy_GRAD_1_3<=1000,'Mavg_Flow_aiqy_GRAD_1_3_正0.5_1',
         |Mavg_Flow_aiqy_GRAD_1_3>1000 and Mavg_Flow_aiqy_GRAD_1_3<=2000,'Mavg_Flow_aiqy_GRAD_1_3_正1_2',Mavg_Flow_aiqy_GRAD_1_3>2000 and Mavg_Flow_aiqy_GRAD_1_3<=5000,'Mavg_Flow_aiqy_GRAD_1_3_正2_5',
         |Mavg_Flow_aiqy_GRAD_1_3>5000 and Mavg_Flow_aiqy_GRAD_1_3<=10000,'Mavg_Flow_aiqy_GRAD_1_3_正5_10',Mavg_Flow_aiqy_GRAD_1_3>10000 ,'Mavg_Flow_aiqy_GRAD_1_3_正10_p',
         |Mavg_Flow_aiqy_GRAD_1_3<0 and Mavg_Flow_aiqy_GRAD_1_3>=-500,'Mavg_Flow_aiqy_GRAD_1_3_负0_0.5',Mavg_Flow_aiqy_GRAD_1_3<-500 and Mavg_Flow_aiqy_GRAD_1_3>=-1000,'Mavg_Flow_aiqy_GRAD_1_3_负0.5_1',
         |Mavg_Flow_aiqy_GRAD_1_3<-1000 and Mavg_Flow_aiqy_GRAD_1_3>=-2000,'Mavg_Flow_aiqy_GRAD_1_3_负1_2',Mavg_Flow_aiqy_GRAD_1_3<-2000 and Mavg_Flow_aiqy_GRAD_1_3>=-5000,'Mavg_Flow_aiqy_GRAD_1_3_负2_5',
         |Mavg_Flow_aiqy_GRAD_1_3<-5000 and Mavg_Flow_aiqy_GRAD_1_3>=-10000,'Mavg_Flow_aiqy_GRAD_1_3_负5_10',Mavg_Flow_aiqy_GRAD_1_3<-10000 ,'Mavg_Flow_aiqy_GRAD_1_3_负10_p','xxx')
         |as Mavg_Flow_aiqy_GRAD_1_3_TYPE,
         |if(arrayReduce('avg',[Div_aiqy_vFlux_1_3,DivAvg_aiqy_vFlux_1_3])>1,1,arrayReduce('avg',[Div_aiqy_vFlux_1_3,DivAvg_aiqy_vFlux_1_3])) as Div_aiqy_vFlux_1_3,
         |MAvg_Flow_aiqy_2_4,
         |ifNull(MPer2_Flow_aiqy,MAvg_Flow_aiqy_2_4) as MPer2_Flow_aiqy,
         |if(MAvg_Flow_aiqy_2_4>20000,20000,MAvg_Flow_aiqy_2_4)/20000 as MAvg_Flow_aiqy_2_4_zs,
         |if(MPer2_Flow_aiqy>20000,20000,MPer2_Flow_aiqy)/20000 as MPer2_Flow_aiqy_zs,
         |--
         |Mavg_Flow_aiqy_GRAD_2_4,
         |multiIf(isNaN(Mavg_Flow_aiqy_GRAD_2_4),'Mavg_Flow_aiqy_GRAD_2_4_vNAN',Mavg_Flow_aiqy_GRAD_2_4=0 ,'Mavg_Flow_aiqy_GRAD_2_4_v0',
         |Mavg_Flow_aiqy_GRAD_2_4>0 and Mavg_Flow_aiqy_GRAD_2_4<=500,'Mavg_Flow_aiqy_GRAD_2_4_正0_0.5',Mavg_Flow_aiqy_GRAD_2_4>500 and Mavg_Flow_aiqy_GRAD_2_4<=1000,'Mavg_Flow_aiqy_GRAD_2_4_正0.5_1',
         |Mavg_Flow_aiqy_GRAD_2_4>1000 and Mavg_Flow_aiqy_GRAD_2_4<=2000,'Mavg_Flow_aiqy_GRAD_2_4_正1_2',Mavg_Flow_aiqy_GRAD_2_4>2000 and Mavg_Flow_aiqy_GRAD_2_4<=5000,'Mavg_Flow_aiqy_GRAD_2_4_正2_5',
         |Mavg_Flow_aiqy_GRAD_2_4>5000 and Mavg_Flow_aiqy_GRAD_2_4<=10000,'Mavg_Flow_aiqy_GRAD_2_4_正5_10',Mavg_Flow_aiqy_GRAD_2_4>10000 ,'Mavg_Flow_aiqy_GRAD_2_4_正10_p',
         |Mavg_Flow_aiqy_GRAD_2_4<0 and Mavg_Flow_aiqy_GRAD_2_4>=-500,'Mavg_Flow_aiqy_GRAD_2_4_负0_0.5',Mavg_Flow_aiqy_GRAD_2_4<-500 and Mavg_Flow_aiqy_GRAD_2_4>=-1000,'Mavg_Flow_aiqy_GRAD_2_4_负0.5_1',
         |Mavg_Flow_aiqy_GRAD_2_4<-1000 and Mavg_Flow_aiqy_GRAD_2_4>=-2000,'Mavg_Flow_aiqy_GRAD_2_4_负1_2',Mavg_Flow_aiqy_GRAD_2_4<-2000 and Mavg_Flow_aiqy_GRAD_2_4>=-5000,'Mavg_Flow_aiqy_GRAD_2_4_负2_5',
         |Mavg_Flow_aiqy_GRAD_2_4<-5000 and Mavg_Flow_aiqy_GRAD_2_4>=-10000,'Mavg_Flow_aiqy_GRAD_2_4_负5_10',Mavg_Flow_aiqy_GRAD_2_4<-10000 ,'Mavg_Flow_aiqy_GRAD_2_4_负10_p','xxx')
         |as Mavg_Flow_aiqy_GRAD_2_4_TYPE,
         |if(arrayReduce('avg',[Div_aiqy_vFlux_2_4,DivAvg_aiqy_vFlux_2_4])>1,1,arrayReduce('avg',[Div_aiqy_vFlux_2_4,DivAvg_aiqy_vFlux_2_4])) as Div_aiqy_vFlux_2_4,
         |'+++优酷+++' as cl6,
         |MAvg_Flow_youtu_1_3,
         |ifNull(MPer1_Flow_youtu,MAvg_Flow_youtu_1_3) as MPer1_Flow_youtu,
         |if(MAvg_Flow_youtu_1_3>20000,20000,MAvg_Flow_youtu_1_3)/20000 as MAvg_Flow_youtu_1_3_zs,
         |if(MPer1_Flow_youtu>20000,20000,MPer1_Flow_youtu)/20000 as MPer1_Flow_youtu_zs,
         |--分桶nan 0 500 1 2 5 10 +
         |Mavg_Flow_youtu_GRAD_1_3,
         |multiIf(isNaN(Mavg_Flow_youtu_GRAD_1_3),'Mavg_Flow_youtu_GRAD_1_3_vNAN',Mavg_Flow_youtu_GRAD_1_3=0 ,'Mavg_Flow_youtu_GRAD_1_3_v0',
         |Mavg_Flow_youtu_GRAD_1_3>0 and Mavg_Flow_youtu_GRAD_1_3<=500,'Mavg_Flow_youtu_GRAD_1_3_正0_0.5',Mavg_Flow_youtu_GRAD_1_3>500 and Mavg_Flow_youtu_GRAD_1_3<=1000,'Mavg_Flow_youtu_GRAD_1_3_正0.5_1',
         |Mavg_Flow_youtu_GRAD_1_3>1000 and Mavg_Flow_youtu_GRAD_1_3<=2000,'Mavg_Flow_youtu_GRAD_1_3_正1_2',Mavg_Flow_youtu_GRAD_1_3>2000 and Mavg_Flow_youtu_GRAD_1_3<=5000,'Mavg_Flow_youtu_GRAD_1_3_正2_5',
         |Mavg_Flow_youtu_GRAD_1_3>5000 and Mavg_Flow_youtu_GRAD_1_3<=10000,'Mavg_Flow_youtu_GRAD_1_3_正5_10',Mavg_Flow_youtu_GRAD_1_3>10000 ,'Mavg_Flow_youtu_GRAD_1_3_正10_p',
         |Mavg_Flow_youtu_GRAD_1_3<0 and Mavg_Flow_youtu_GRAD_1_3>=-500,'Mavg_Flow_youtu_GRAD_1_3_负0_0.5',Mavg_Flow_youtu_GRAD_1_3<-500 and Mavg_Flow_youtu_GRAD_1_3>=-1000,'Mavg_Flow_youtu_GRAD_1_3_负0.5_1',
         |Mavg_Flow_youtu_GRAD_1_3<-1000 and Mavg_Flow_youtu_GRAD_1_3>=-2000,'Mavg_Flow_youtu_GRAD_1_3_负1_2',Mavg_Flow_youtu_GRAD_1_3<-2000 and Mavg_Flow_youtu_GRAD_1_3>=-5000,'Mavg_Flow_youtu_GRAD_1_3_负2_5',
         |Mavg_Flow_youtu_GRAD_1_3<-5000 and Mavg_Flow_youtu_GRAD_1_3>=-10000,'Mavg_Flow_youtu_GRAD_1_3_负5_10',Mavg_Flow_youtu_GRAD_1_3<-10000 ,'Mavg_Flow_youtu_GRAD_1_3_负10_p','xxx')
         |as Mavg_Flow_youtu_GRAD_1_3_TYPE,
         |if(arrayReduce('avg',[Div_youtu_vFlux_1_3,DivAvg_youtu_vFlux_1_3])>1,1,arrayReduce('avg',[Div_youtu_vFlux_1_3,DivAvg_youtu_vFlux_1_3])) as Div_youtu_vFlux_1_3,
         |
         |MAvg_Flow_youtu_2_4,
         |ifNull(MPer2_Flow_youtu,MAvg_Flow_youtu_2_4) as MPer2_Flow_youtu,
         |if(MAvg_Flow_youtu_2_4>20000,20000,MAvg_Flow_youtu_2_4)/20000 as MAvg_Flow_youtu_2_4_zs,
         |if(MPer2_Flow_youtu>20000,20000,MPer2_Flow_youtu)/20000 as MPer2_Flow_youtu_zs,
         |--
         |Mavg_Flow_youtu_GRAD_2_4,
         |multiIf(isNaN(Mavg_Flow_youtu_GRAD_2_4),'Mavg_Flow_youtu_GRAD_2_4_vNAN',Mavg_Flow_youtu_GRAD_2_4=0 ,'Mavg_Flow_youtu_GRAD_2_4_v0',
         |Mavg_Flow_youtu_GRAD_2_4>0 and Mavg_Flow_youtu_GRAD_2_4<=500,'Mavg_Flow_youtu_GRAD_2_4_正0_0.5',Mavg_Flow_youtu_GRAD_2_4>500 and Mavg_Flow_youtu_GRAD_2_4<=1000,'Mavg_Flow_youtu_GRAD_2_4_正0.5_1',
         |Mavg_Flow_youtu_GRAD_2_4>1000 and Mavg_Flow_youtu_GRAD_2_4<=2000,'Mavg_Flow_youtu_GRAD_2_4_正1_2',Mavg_Flow_youtu_GRAD_2_4>2000 and Mavg_Flow_youtu_GRAD_2_4<=5000,'Mavg_Flow_youtu_GRAD_2_4_正2_5',
         |Mavg_Flow_youtu_GRAD_2_4>5000 and Mavg_Flow_youtu_GRAD_2_4<=10000,'Mavg_Flow_youtu_GRAD_2_4_正5_10',Mavg_Flow_youtu_GRAD_2_4>10000 ,'Mavg_Flow_youtu_GRAD_2_4_正10_p',
         |Mavg_Flow_youtu_GRAD_2_4<0 and Mavg_Flow_youtu_GRAD_2_4>=-500,'Mavg_Flow_youtu_GRAD_2_4_负0_0.5',Mavg_Flow_youtu_GRAD_2_4<-500 and Mavg_Flow_youtu_GRAD_2_4>=-1000,'Mavg_Flow_youtu_GRAD_2_4_负0.5_1',
         |Mavg_Flow_youtu_GRAD_2_4<-1000 and Mavg_Flow_youtu_GRAD_2_4>=-2000,'Mavg_Flow_youtu_GRAD_2_4_负1_2',Mavg_Flow_youtu_GRAD_2_4<-2000 and Mavg_Flow_youtu_GRAD_2_4>=-5000,'Mavg_Flow_youtu_GRAD_2_4_负2_5',
         |Mavg_Flow_youtu_GRAD_2_4<-5000 and Mavg_Flow_youtu_GRAD_2_4>=-10000,'Mavg_Flow_youtu_GRAD_2_4_负5_10',Mavg_Flow_youtu_GRAD_2_4<-10000 ,'Mavg_Flow_youtu_GRAD_2_4_负10_p','xxx')
         |as Mavg_Flow_youtu_GRAD_2_4_TYPE,
         |if(arrayReduce('avg',[Div_youtu_vFlux_2_4,DivAvg_youtu_vFlux_2_4])>1,1,arrayReduce('avg',[Div_youtu_vFlux_2_4,DivAvg_youtu_vFlux_2_4])) as Div_youtu_vFlux_2_4,
         |
         |IS_CANCEL
         |from
         |(
         |select TARGET_MONTH,
         |USERID,PRICE/48 as PRICE,if(MAXFLOW>50000,50000,MAXFLOW)/50000 as MAXFLOW,
         |if(TOTAL_FEE_AVG>300,300,TOTAL_FEE_AVG)/300 as TOTAL_FEE_AVG,IS_ACCT_AVG,
         |--if(TOTAL_FLUX_AVG>20000,20000,TOTAL_FLUX_AVG)/20000 as TOTAL_FLUX_AVG,
         |--if(TOTAL_FLUX_VIDEO_AVG>20000,20000,TOTAL_FLUX_VIDEO_AVG)/20000 as TOTAL_FLUX_VIDEO_AVG,
         |PROVINCE,
         |if(c1.CODE='','其他',c1.CODE) as CHANNEL,
         |if(cp.CODE='','其他',cp.CODE) as CPID,
         |if(sp.CODE='','其他',sp.CODE) as SPID,
         |DIFF_MONYH_TYPE,CUST_SEX,CERT_AGE,MANU_NAME,
         |BELONGTO,CPTYPE,IS_VIP,`MPer1_Flow`, MAvg3_Flow,M1_Flow02,
         |toInt32OrNull(PACKAGE_PRICE) as pprice,
         |multiIf(pprice is NULL,'pkgPic_null',pprice<=10 ,'pkgPic_0_10',pprice>10 and pprice<=20,'pkgPic_10_20',pprice>20 and pprice<=40,'pkgPic_20_40',
         |pprice>40 and pprice<=60,'pkgPic_40_60',pprice>60 and pprice<=80,'pkgPic_60_80',pprice>80 and pprice<=100,'pkgPic_80_100',
         |pprice>100 and pprice<=150,'pkgPic_100_150',pprice>150 and pprice<=300,'pkgPic_150_300',pprice>300,'pkgPic_300_p','pkgPic_xxx') as PACKAGE_PRICE_TYPE,
         |
         |multiIf(H_FLUX is NULL,'hflux_null',H_FLUX=0,'hflux_0',H_FLUX>0 and H_FLUX<=5,'hflux_0_5',H_FLUX>5 and H_FLUX<=10,'hflux_5_10',
         |H_FLUX>10 and H_FLUX<=20,'hflux_10_20',H_FLUX>20 and H_FLUX<=40,'hflux_20_40',H_FLUX>40 and H_FLUX<=60,'hflux_40_60',
         |H_FLUX>60,'hflux_60_p','hflux_xxx') as H_FLUX_TYPE,IS_DAWANG,
         |MPer1_TOTAL_FLUX,MPer2_TOTAL_FLUX,MPer3_TOTAL_FLUX,MPer4_TOTAL_FLUX,
         |MPer1_TOTAL_VIDEO_FLUX,MPer2_TOTAL_VIDEO_FLUX,MPer3_TOTAL_VIDEO_FLUX,MPer4_TOTAL_VIDEO_FLUX,
         |
         |[MPer3_TOTAL_FLUX,MPer2_TOTAL_FLUX,MPer1_TOTAL_FLUX] as TOTAL_FLUX_1_3,
         |arrayReduce('avg', TOTAL_FLUX_1_3) MAvg_TOTAL_FLUX_1_3,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer3_TOTAL_FLUX,-1),ifNull(MPer2_TOTAL_FLUX,-1),ifNull(MPer1_TOTAL_FLUX,-1)]) as TOTAL_FLUX_1_3_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(TOTAL_FLUX_1_3_notNull))) as Mavg_TOTAL_FLUX_GRAD_1_3, --近1-3月有数值情况下 流量变化趋势（平均）
         |
         |[MPer4_TOTAL_FLUX,MPer3_TOTAL_FLUX,MPer2_TOTAL_FLUX] as TOTAL_FLUX_2_4,
         |arrayReduce('avg', TOTAL_FLUX_2_4) MAvg_TOTAL_FLUX_2_4,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer4_TOTAL_FLUX,-1),ifNull(MPer3_TOTAL_FLUX,-1),ifNull(MPer2_TOTAL_FLUX,-1)]) as TOTAL_FLUX_2_4_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(TOTAL_FLUX_2_4_notNull))) as Mavg_TOTAL_FLUX_GRAD_2_4, --近2-4月有数值情况下 流量变化趋势（平均）
         |
         |[MPer3_TOTAL_VIDEO_FLUX,MPer2_TOTAL_VIDEO_FLUX,MPer1_TOTAL_VIDEO_FLUX] as TOTAL_VIDEO_FLUX_1_3,
         |arrayReduce('avg', TOTAL_VIDEO_FLUX_1_3) MAvg_TOTAL_VIDEO_FLUX_1_3,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer3_TOTAL_VIDEO_FLUX,-1),ifNull(MPer2_TOTAL_VIDEO_FLUX,-1),ifNull(MPer1_TOTAL_VIDEO_FLUX,-1)]) as TOTAL_VIDEO_FLUX_1_3_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(TOTAL_VIDEO_FLUX_1_3_notNull))) as Mavg_TOTAL_VIDEO_FLUX_GRAD_1_3, --近1-3月有数值情况下 视频流量变化趋势（平均）
         |
         |[MPer4_TOTAL_VIDEO_FLUX,MPer3_TOTAL_VIDEO_FLUX,MPer2_TOTAL_VIDEO_FLUX] as TOTAL_VIDEO_FLUX_2_4,
         |arrayReduce('avg', TOTAL_VIDEO_FLUX_2_4) MAvg_TOTAL_VIDEO_FLUX_2_4,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer4_TOTAL_VIDEO_FLUX,-1),ifNull(MPer3_TOTAL_VIDEO_FLUX,-1),ifNull(MPer2_TOTAL_VIDEO_FLUX,-1)]) as TOTAL_VIDEO_FLUX_2_4_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(TOTAL_VIDEO_FLUX_2_4_notNull))) as Mavg_TOTAL_VIDEO_FLUX_GRAD_2_4, --近2-4月有数值情况下 视频流量变化趋势（平均）
         |
         |(MPer1_TOTAL_VIDEO_FLUX/MPer1_TOTAL_FLUX) as Div_vFlux_tFlux_1_3,-- 前1月视频流量占总流量比值
         |(MAvg_TOTAL_VIDEO_FLUX_1_3/MAvg_TOTAL_FLUX_1_3) as DivAvg_vFlux_tFlux_1_3,-- 近1-3月视频流量占总流量比值
         |(MPer2_TOTAL_VIDEO_FLUX/MPer2_TOTAL_FLUX) as Div_vFlux_tFlux_2_4,-- 前2月视频流量占总流量比值
         |(MAvg_TOTAL_VIDEO_FLUX_2_4/MAvg_TOTAL_FLUX_2_4) as DivAvg_vFlux_tFlux_2_4,-- 前近2-4月视频流量占总流量比值
         |
         |'+++++',
         |--kuaishou
         |MPer4_Flow_kuaishou,MPer3_Flow_kuaishou,MPer2_Flow_kuaishou,MPer1_Flow_kuaishou,
         |[MPer3_Flow_kuaishou,MPer2_Flow_kuaishou,MPer1_Flow_kuaishou] as Flow_kuaishou_1_3,
         |arrayReduce('avg', Flow_kuaishou_1_3) MAvg_Flow_kuaishou_1_3,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer3_Flow_kuaishou,-1),ifNull(MPer2_Flow_kuaishou,-1),ifNull(MPer1_Flow_kuaishou,-1)]) as Flow_kuaishou_1_3_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_kuaishou_1_3_notNull))) as Mavg_Flow_kuaishou_GRAD_1_3,
         |
         |[MPer4_Flow_kuaishou,MPer3_Flow_kuaishou,MPer2_Flow_kuaishou] as Flow_kuaishou_2_4,
         |arrayReduce('avg', Flow_kuaishou_2_4) MAvg_Flow_kuaishou_2_4,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer4_Flow_kuaishou,-1),ifNull(MPer3_Flow_kuaishou,-1),ifNull(MPer2_Flow_kuaishou,-1)]) as Flow_kuaishou_2_4_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_kuaishou_2_4_notNull))) as Mavg_Flow_kuaishou_GRAD_2_4,
         |(MPer1_Flow_kuaishou/MPer1_TOTAL_VIDEO_FLUX) as Div_kuaishou_vFlux_1_3,
         |(MAvg_Flow_kuaishou_1_3/MAvg_TOTAL_VIDEO_FLUX_1_3) as DivAvg_kuaishou_vFlux_1_3,
         |(MPer2_Flow_kuaishou/MPer2_TOTAL_VIDEO_FLUX) as Div_kuaishou_vFlux_2_4,
         |(MAvg_Flow_kuaishou_2_4/MAvg_TOTAL_VIDEO_FLUX_2_4) as DivAvg_kuaishou_vFlux_2_4,
         |--tencent
         |MPer1_Flow_tencent,MPer2_Flow_tencent,MPer3_Flow_tencent,MPer4_Flow_tencent,
         |[MPer3_Flow_tencent,MPer2_Flow_tencent,MPer1_Flow_tencent] as Flow_tencent_1_3,
         |arrayReduce('avg', Flow_tencent_1_3) MAvg_Flow_tencent_1_3,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer3_Flow_tencent,-1),ifNull(MPer2_Flow_tencent,-1),ifNull(MPer1_Flow_tencent,-1)]) as Flow_tencent_1_3_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_tencent_1_3_notNull))) as Mavg_Flow_tencent_GRAD_1_3,
         |
         |[MPer4_Flow_tencent,MPer3_Flow_tencent,MPer2_Flow_tencent] as Flow_tencent_2_4,
         |arrayReduce('avg', Flow_tencent_2_4) MAvg_Flow_tencent_2_4,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer4_Flow_tencent,-1),ifNull(MPer3_Flow_tencent,-1),ifNull(MPer2_Flow_tencent,-1)]) as Flow_tencent_2_4_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_tencent_2_4_notNull))) as Mavg_Flow_tencent_GRAD_2_4,
         |(MPer1_Flow_tencent/MPer1_TOTAL_VIDEO_FLUX) as Div_tencent_vFlux_1_3,
         |(MAvg_Flow_tencent_1_3/MAvg_TOTAL_VIDEO_FLUX_1_3) as DivAvg_tencent_vFlux_1_3,
         |(MPer2_Flow_tencent/MPer2_TOTAL_VIDEO_FLUX) as Div_tencent_vFlux_2_4,
         |(MAvg_Flow_tencent_2_4/MAvg_TOTAL_VIDEO_FLUX_2_4) as DivAvg_tencent_vFlux_2_4,
         |--bilibl
         |MPer4_Flow_bilibl,MPer3_Flow_bilibl,MPer2_Flow_bilibl,MPer1_Flow_bilibl,
         |[MPer3_Flow_bilibl,MPer2_Flow_bilibl,MPer1_Flow_bilibl] as Flow_bilibl_1_3,
         |arrayReduce('avg', Flow_bilibl_1_3) MAvg_Flow_bilibl_1_3,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer3_Flow_bilibl,-1),ifNull(MPer2_Flow_bilibl,-1),ifNull(MPer1_Flow_bilibl,-1)]) as Flow_bilibl_1_3_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_bilibl_1_3_notNull))) as Mavg_Flow_bilibl_GRAD_1_3,
         |
         |[MPer4_Flow_bilibl,MPer3_Flow_bilibl,MPer2_Flow_bilibl] as Flow_bilibl_2_4,
         |arrayReduce('avg', Flow_bilibl_2_4) MAvg_Flow_bilibl_2_4,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer4_Flow_bilibl,-1),ifNull(MPer3_Flow_bilibl,-1),ifNull(MPer2_Flow_bilibl,-1)]) as Flow_bilibl_2_4_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_bilibl_2_4_notNull))) as Mavg_Flow_bilibl_GRAD_2_4,
         |(MPer1_Flow_bilibl/MPer1_TOTAL_VIDEO_FLUX) as Div_bilibl_vFlux_1_3,
         |(MAvg_Flow_bilibl_1_3/MAvg_TOTAL_VIDEO_FLUX_1_3) as DivAvg_bilibl_vFlux_1_3,
         |(MPer2_Flow_bilibl/MPer2_TOTAL_VIDEO_FLUX) as Div_bilibl_vFlux_2_4,
         |(MAvg_Flow_bilibl_2_4/MAvg_TOTAL_VIDEO_FLUX_2_4) as DivAvg_bilibl_vFlux_2_4,
         |--aiqy
         |MPer4_Flow_aiqy,MPer3_Flow_aiqy,MPer2_Flow_aiqy,MPer1_Flow_aiqy,
         |[MPer3_Flow_aiqy,MPer2_Flow_aiqy,MPer1_Flow_aiqy] as Flow_aiqy_1_3,
         |arrayReduce('avg', Flow_aiqy_1_3) MAvg_Flow_aiqy_1_3,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer3_Flow_aiqy,-1),ifNull(MPer2_Flow_aiqy,-1),ifNull(MPer1_Flow_aiqy,-1)]) as Flow_aiqy_1_3_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_aiqy_1_3_notNull))) as Mavg_Flow_aiqy_GRAD_1_3,
         |
         |[MPer4_Flow_aiqy,MPer3_Flow_aiqy,MPer2_Flow_aiqy] as Flow_aiqy_2_4,
         |arrayReduce('avg', Flow_aiqy_2_4) MAvg_Flow_aiqy_2_4,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer4_Flow_aiqy,-1),ifNull(MPer3_Flow_aiqy,-1),ifNull(MPer2_Flow_aiqy,-1)]) as Flow_aiqy_2_4_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_aiqy_2_4_notNull))) as Mavg_Flow_aiqy_GRAD_2_4,
         |(MPer1_Flow_aiqy/MPer1_TOTAL_VIDEO_FLUX) as Div_aiqy_vFlux_1_3,
         |(MAvg_Flow_aiqy_1_3/MAvg_TOTAL_VIDEO_FLUX_1_3) as DivAvg_aiqy_vFlux_1_3,
         |(MPer2_Flow_aiqy/MPer2_TOTAL_VIDEO_FLUX) as Div_aiqy_vFlux_2_4,
         |(MAvg_Flow_aiqy_2_4/MAvg_TOTAL_VIDEO_FLUX_2_4) as DivAvg_aiqy_vFlux_2_4,
         |--youtu
         |MPer4_Flow_youtu,MPer3_Flow_youtu,MPer2_Flow_youtu,MPer1_Flow_youtu,
         |[MPer3_Flow_youtu,MPer2_Flow_youtu,MPer1_Flow_youtu] as Flow_youtu_1_3,
         |arrayReduce('avg', Flow_youtu_1_3) MAvg_Flow_youtu_1_3,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer3_Flow_youtu,-1),ifNull(MPer2_Flow_youtu,-1),ifNull(MPer1_Flow_youtu,-1)]) as Flow_youtu_1_3_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_youtu_1_3_notNull))) as Mavg_Flow_youtu_GRAD_1_3,
         |
         |[MPer4_Flow_youtu,MPer3_Flow_youtu,MPer2_Flow_youtu] as Flow_youtu_2_4,
         |arrayReduce('avg', Flow_youtu_2_4) MAvg_Flow_youtu_2_4,
         |arrayFilter(x -> x> 0 ,[ifNull(MPer4_Flow_youtu,-1),ifNull(MPer3_Flow_youtu,-1),ifNull(MPer2_Flow_youtu,-1)]) as Flow_youtu_2_4_notNull,
         |arrayReduce('avg',arrayFilter(x-> x!=0 ,arrayDifference(Flow_youtu_2_4_notNull))) as Mavg_Flow_youtu_GRAD_2_4,
         |(MPer1_Flow_youtu/MPer1_TOTAL_VIDEO_FLUX) as Div_youtu_vFlux_1_3,
         |(MAvg_Flow_youtu_1_3/MAvg_TOTAL_VIDEO_FLUX_1_3) as DivAvg_youtu_vFlux_1_3,
         |(MPer2_Flow_youtu/MPer2_TOTAL_VIDEO_FLUX) as Div_youtu_vFlux_2_4,
         |(MAvg_Flow_youtu_2_4/MAvg_TOTAL_VIDEO_FLUX_2_4) as DivAvg_youtu_vFlux_2_4,
         |IS_CANCEL
         |from ads.ALS_XXH_CANCEL_NEW_C4 c
         |left join (select * from ALS_XXH_CANCEL_NEW_C3_lowDim_dic where `TYPE`='CHANNEL') as c1 on c.CHANNEL =c1.CODE
         |left join (select * from ALS_XXH_CANCEL_NEW_C3_lowDim_dic where `TYPE`='CPID') as cp on c.CPID =cp.CODE
         |left join (select * from ALS_XXH_CANCEL_NEW_C3_lowDim_dic where `TYPE`='SPID') as sp on c.SPID =sp.CODE
         |where c.TARGET_MONTH ='${month}'
         |)
         |""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  ///生成退订预测标签C4  检查表对不对 ALS_XXH_ORDER_RESULT
  def zt_tag_cancel_C4(month:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    var sql:String=""

    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_ORDER_CANCEL ENGINE = MergeTree PARTITION BY THEMONTH_CEL ORDER BY USERID_CEL  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_ORDER_CANCEL
          |""".stripMargin
    }

    sql=sql+s"select ${month} as THEMONTH_CEL,USERID as USERID_CEL,";
    sql=sql+GenSelectTagSql_C("退订预测","CANCEL_P1",field_value = "CANCEL_P2",use_tag_nv = "tag_value");

    sql=sql+
      s"""
         |from
         |(
         |	select USERID,intDiv(CANCEL_P*100,10)*10 as CANCEL_P1,CANCEL_P*100 as CANCEL_P2
         |	from ads.ALS_XXH_CANCEL_RESULT_C4
         |	where TARGET_MONTH ='${month}'
         |) t
         |""".stripMargin;
    println(sql)
    //执行
    //RunClickhouseSQL(sql);

    0
  }


  ///生成 订购偏好预测标签
  def zt_tag_order_V1_sp(month:String,isInsert:Boolean=false,isCreate:Boolean=false)={
    if(isCreate==false){
      //【1】drop
      val sqlDrop_View=
        s"""
           |DROP TABLE IF EXISTS  ads.ZT_ORDER_PREFERENCE_temp
           |""".stripMargin
      print(sqlDrop_View)
      RunClickhouseSQL(sqlDrop_View)
      Thread.sleep(3000)

      zt_tag_order_V1(month,isInsert=isInsert,uid_l="0",uid_r="131")
      zt_tag_order_V1(month,isInsert=true,uid_l="131",uid_r="132");
      zt_tag_order_V1(month,isInsert=true,uid_l="132",uid_r="150");
      zt_tag_order_V1(month,isInsert=true,uid_l="150",uid_r="156");
      zt_tag_order_V1(month,isInsert=true,uid_l="156",uid_r="166");
      zt_tag_order_V1(month,isInsert=true,uid_l="166",uid_r="176");
      zt_tag_order_V1(month,isInsert=true,uid_l="176",uid_r="1768");
      zt_tag_order_V1(month,isInsert=true,uid_l="1768",uid_r="1855");
      zt_tag_order_V1(month,isInsert=true,uid_l="1855",uid_r="186");
      zt_tag_order_V1(month,isInsert=true,uid_l="186",uid_r="1865");
      zt_tag_order_V1(month,isInsert=true,uid_l="1865",uid_r="9999");
    }
    else{
      val sqlDrop_View=
        s"""
           |DROP TABLE IF EXISTS  ads.ZT_ORDER_PREFERENCE
           |""".stripMargin
      print(sqlDrop_View)
      RunClickhouseSQL(sqlDrop_View)
      Thread.sleep(3000)

      zt_tag_order_V1_create(month,isInsert=isInsert,uid_l="0",uid_r="131")
      zt_tag_order_V1_create(month,isInsert=true,uid_l="131",uid_r="132");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="132",uid_r="150");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="150",uid_r="156");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="156",uid_r="166");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="166",uid_r="176");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="176",uid_r="1768");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="1768",uid_r="1855");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="1855",uid_r="186");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="186",uid_r="1865");
      zt_tag_order_V1_create(month,isInsert=true,uid_l="1865",uid_r="9999");
    }

  }

  ///生成 订购偏好预测标签
  def zt_tag_order_V1(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String=""):Int ={
    val maptags: Map[String, String]=get_alltags()
    var sql:String=""

    //生成sql
    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_ORDER_PREFERENCE_temp ENGINE = MergeTree ORDER BY tDeepCross_AQY.USERID  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_ORDER_PREFERENCE_temp
          |""".stripMargin
    }
    //爱奇艺
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"AQY","爱奇艺","DeepCross", joinStr=" select * from ",  uid_l = uid_l,uid_r=uid_r)
    //bi占
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"BZ","哔哩","DeepCross", uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tDeepCross_BZ.USERID";
    //快手
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"KS","快手","DeepCross",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tDeepCross_KS.USERID";
    //腾讯
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"TX","腾讯","DeepCross",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tDeepCross_TX.USERID";
    //优酷
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"YK","优酷","DeepCross",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tDeepCross_YK.USERID";
    //芒果
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"MG","芒果","DeepCross",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tDeepCross_MG.USERID";

    //爱奇艺2
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"AQY","爱奇艺","XGBoost",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tXGBoost_AQY.USERID";
    //bi占2
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"BZ","哔哩","XGBoost", uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tXGBoost_BZ.USERID";
    //快手2
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"KS","快手","XGBoost",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tXGBoost_KS.USERID";
    //腾讯2
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"TX","腾讯","XGBoost",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tXGBoost_TX.USERID";
    //优酷2
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"YK","优酷","XGBoost",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tXGBoost_YK.USERID";
    //芒果2
    sql=sql+GET_ORDER_PREFERENCE_SQL1(month,"MG","芒果","XGBoost",uid_l = uid_l,uid_r=uid_r)
    sql=sql+s"on tDeepCross_AQY.USERID=tXGBoost_MG.USERID";

    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }
  def zt_tag_order_V1_create(month:String,isInsert:Boolean=true,uid_l:String="",uid_r:String="")={
    var sql_r1:String=""
    var sql_table:String="desc ads.ZT_ORDER_PREFERENCE_temp"
    var list_cols= ExecClickhouseSQL(sql_table)
    var list_userid = new util.ArrayList[String]
    //"表中包含的字段"
    var list_c1=new util.ArrayList[String]
    for (i <- 0 to list_cols.size()-1) {
      val row_cols = list_cols.get(i)
      val name: String = row_cols.get("name").toString
      if (name.contains("USERID")) {
        list_userid.add(name)
      }
      else  {
        list_c1.add(name)
        //cols=cols+"`"+name.split('.')(1)+"`,"
      }
    }
    //cols= cols.substring(0,cols.length-1)
    //生成sql
    if(isInsert==false){
      sql_r1=sql_r1+
        """
          |create table ads.ZT_ORDER_PREFERENCE ENGINE = MergeTree PARTITION BY THEMONTH_PRE ORDER BY USERID_PRE  as
          |""".stripMargin
    }else{
      sql_r1=sql_r1+
        """
          |insert into ads.ZT_ORDER_PREFERENCE
          |""".stripMargin
    }

    sql_r1=sql_r1+s"select  '${month}' as THEMONTH_PRE, USERID_PRE, ";
    //值0
    for (i <- 0 to list_c1.size()-1) {
      val name: String  = list_c1.get(i).toString.split('.')(1)
      sql_r1=sql_r1+s"any(`${name}`) as ${name}" +(if (i==list_c1.size()-1) "" else "," )
    }

     sql_r1=sql_r1+s" from ( select multiIf(";
    //用户判断
    for (i <- 0 to list_userid.size()-1) {
      var name: String  = list_userid.get(i).toString
      //name =s"`"+name.split('.')(1)+"`"
      name =s"`"+name+"`"
      sql_r1=sql_r1+s"${name}!='',${name},"
    }
    sql_r1=sql_r1+"'err') as USERID_PRE,"
    sql_r1=sql_r1+
      s"""
         |""".stripMargin
    //值
    for (i <- 0 to list_c1.size()-1) {
      val name: String  = list_c1.get(i).toString
      val nameAs =name.split('.')(1)
      sql_r1=sql_r1+s"`${name}` as ${nameAs},"
    }
    sql_r1= sql_r1.substring(0,sql_r1.length-1)
    sql_r1=sql_r1+
      s"""
         | from ads.ZT_ORDER_PREFERENCE_temp  where
         |""".stripMargin

    //where 条件
    for (i <- 0 to list_userid.size()-1) {
      var name: String  = list_userid.get(i).toString
      sql_r1=sql_r1+s"(`${name}` >='${uid_l}' and `${name}` <'${uid_r}') or "
    }
    sql_r1= sql_r1.substring(0,sql_r1.length-3)

    sql_r1=sql_r1+") group by USERID_PRE "
    print(sql_r1)

    //执行
    RunClickhouseSQL(sql_r1);
  }
  //获取内部SQL
  def GET_ORDER_PREFERENCE_SQL1(month:String,tp:String,tpName:String,tableAlsStr:String, joinStr:String=" full outer join ", uid_l:String="",uid_r:String=""):String= {
    val lrSql_USERID = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    var sql:String=""
    sql=sql+s" ${joinStr} (select USERID,";
    sql=sql+GenSelectTagSql_C(s"订购预测_${tpName}_${if(tableAlsStr=="DeepCross") "dec" else "xgb"}","CANCEL_P1",field_value = "CANCEL_P2",use_tag_nv = "tag_value");

    val valueStr:String=if (tableAlsStr=="XGBoost") "PRO_RESULT" else "`1_PRO_RESULT`"
    sql=sql+
    s"""
      |from
      |(
      |		select DEVICE_NUMBER as  USERID,intDiv(${valueStr}*100,10)*10 as CANCEL_P1,${valueStr}*100 as CANCEL_P2
               |    from ads.ADS_ORDER_PRE_${tableAlsStr}_${tp}_${if (tableAlsStr=="XGBoost") "RESULT" else "result"}
      |    where 1=1  ${lrSql_USERID}
      |) t
      |) t${tableAlsStr}_${tp}
      |""".stripMargin;
    sql
  }

  ///app temp
  def z_xxh_app_temp_sp(month:String="",isInsert:Boolean=true)={
    z_xxh_app_temp(month,uid_l="0",uid_r="131",isInsert = true)
    z_xxh_app_temp(month,uid_l="131",uid_r="132",isInsert = true);
    z_xxh_app_temp(month,uid_l="132",uid_r="150",isInsert = true);
    z_xxh_app_temp(month,uid_l="150",uid_r="156",isInsert = true);
    z_xxh_app_temp(month,uid_l="156",uid_r="166",isInsert = true);
    z_xxh_app_temp(month,uid_l="166",uid_r="176",isInsert = true);
    z_xxh_app_temp(month,uid_l="176",uid_r="1768",isInsert = true);
    z_xxh_app_temp(month,uid_l="1768",uid_r="1855",isInsert = true);
    z_xxh_app_temp(month,uid_l="1855",uid_r="186",isInsert = true);
    z_xxh_app_temp(month,uid_l="186",uid_r="1865",isInsert = true);
    z_xxh_app_temp(month,uid_l="1865",uid_r="9999",isInsert = true);
  }
  ///
  def z_xxh_app_temp(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="")={
    var sql:String=""
    sql=sql+
      """
        |insert into ads.XXH_APP_temp
        |""".stripMargin

    val lrSql_USERID = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    sql=sql+
      s"""
         |select '${month}',DEVICE_NUMBER,APP_NAME,ONE_FLUX from
         |ads.XXH_ALL_APP_MONTH where MONTH_ID ='${month}'  ${lrSql_USERID}
         |order by ONE_FLUX desc
         |Limit 1 by DEVICE_NUMBER
         |""".stripMargin

    print(sql)
    RunClickhouseSQL(sql);
  }

  def z_xxh_app_join_temp(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="")={
    var sql:String=""
    sql=sql+
      """
        |insert into ads.XXH_APP_temp2
        |""".stripMargin

    val lrSql_USERID = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    sql=sql+
      s"""
         |select t.*,t1.TOTAL_FLUX_VIDEO from
         |(select * from ads.XXH_APP_temp where MONTH_ID ='${month}' ${lrSql_USERID}) t
         |left join
         |(select DEVICE_NUMBER,TOTAL_FLUX_VIDEO from ads.XXH_ALL_MONTH where MONTH_ID ='${month}' ${lrSql_USERID})  t1
         |on t.DEVICE_NUMBER =t1.DEVICE_NUMBER
         |""".stripMargin

    print(sql)
    RunClickhouseSQL(sql);
  }
}
