package com.jollychic.spark

import java.sql.{ResultSet, Statement}

import com.jollychic.tool.{ClickhouseConnect, TagGenBase}
import com.jollychic.utils.EnDecHelper
/**
 * 生成埋点相关 数据
 */
class Tag_Event extends  TagGenBase{

    def Gen_UserIds(reInsert:Boolean=false):Int = {

      val chConn=ClickhouseConnect.conn()
      val chSt: Statement = chConn.createStatement
      //清空表
      chSt.executeUpdate(s"truncate table ads.user_uids ")
      //插入数据
      val res: ResultSet = chSt.executeQuery(s" select distinct anonymous_id ,login_id from ads.user_event where login_id is not null and length(login_id)>11 ")
      val pstmt = chConn.prepareStatement("INSERT into ads.user_uids values(?,?,NULL)")
      while (res.next) {
        val anonymous_id=res.getString("anonymous_id")
        val login_id=EnDecHelper.decode(res.getString("login_id"))
        pstmt.setString(1,anonymous_id )
        pstmt.setString(2, login_id)
        pstmt.addBatch
      }
      pstmt.executeBatch()

      val res1: ResultSet = chSt.executeQuery(s" select distinct anonymous_id ,login_id from ads.user_event where login_id is not null and length(login_id)=11 ")
      val pstmt1 = chConn.prepareStatement("INSERT into ads.user_uids values(?,?,NULL)")
      while (res1.next) {
        val anonymous_id=res1.getString("anonymous_id")
        val login_id=res1.getString("login_id")
        pstmt1.setString(1,anonymous_id )
        pstmt1.setString(2, login_id)
        pstmt1.addBatch
      }

      pstmt1.executeBatch()
      chSt.close()
      0
    }

  }
