package com.jollychic.spark

import com.jollychic.utils.DateUtils


/**
 * 最开始根据业务 批量生成标签 com.jollychic.spark.Tag_GenAds 000
 */
object Tag_GenAds {
  def main(args: Array[String]): Unit = {
    //arg0
    var sendTp = ""
    //arg1
    var permonth = DateUtils.getNMonth(DateUtils.nowDate("yyyy-MM-dd"), -1, "yyyyMM")
    var p_permonth = DateUtils.getNMonth(DateUtils.nowDate("yyyy-MM-dd"), -2, "yyyyMM")
    if (args != null && args.length > 0) {
      sendTp = args(0)
      if (args.length > 0) {
        permonth = args(1)
        p_permonth = DateUtils.getNMonth(permonth.substring(0, 4) + "-" + permonth.substring(4) + "-01", -1, "yyyyMM")
      }
    }
    println("sendType:")
    println(sendTp)

    val tDawang = new Tag_DaWang()
    val tDawang_Long=new Tag_DaWang_Long()
    val tAlg=new Tag_Algorithm()

    //tDawang.z_xxh_from_etl_sp2("202203")
    //tDawang.z_user_tag_update_Clu()
    //tAlg.zt_tag_order_V1_sp("202203",isInsert = false,isCreate = true)

    //生成标签
    if (sendTp == "zt_tag") {
      //更新 Long 年字段表
      tDawang_Long.z_Long_tag_C_XXH_sp()
      ///生成 订购用户 大网标签
      tDawang.zt_tag_C_XXH_sp(p_permonth, isInsert = true)
      ///生成大网 APP标签
      tDawang.zt_tag_C_XXH_APP_sp(p_permonth, isInsert = true)
      ///生成订购相关标签
      tDawang.zt_tag_C_ORDER_sp(permonth, isInsert = true)
      //生成用户订购状态标签
      tDawang.zt_tag_User_OrderState(permonth, isInsert = true);
      //订购总时长
      tDawang.zt_tag_C_ORDER_SumDate(permonth, isInsert = true);
      //APP偏好
      tDawang.zt_tag_app_preference(permonth, isInsert = true)
      //投诉次数
      tDawang.zt_tag_complain(permonth, isInsert = true)
      //生成rfm表
      //tDawang.zt_tag_RMF("202106");
      //快手预测
      //tDawang.zt_tag_kuaishou("202106")
      /**
       * 退订订ding  todo
       */
      tAlg.zt_tag_cancel_C4(permonth,isInsert=true)
      //生成最终temp表,更新线上flat表，将temp数据 插入到 flat_ALL分发
      tDawang.z_user_tag_JOIN_All(permonth)
    }

    /**
     * 更新mysql中的字典表
     */
    if (sendTp == "dic_tag") {
      //生成标签帮助
      tDawang.GenSomeTagtoMysql()
      //生成事件表缓存选项
      tDawang.GenEventProptoMysql()
    }
    /**
     * 更新etl2->xxh
     */
    if (sendTp == "xxh_etl") {
      tDawang.z_xxh_from_etl_sp2(permonth)
    }
    /**
     * 退订订ding  todo
     */
    //退订数据准备  先调用这个准备数据，然后取TensorFlow训练，并预测 ？月结果
    if (sendTp == "z_cancel_data") {
      tAlg.zt_tag_cancel_data_C4(permonth,is_Cancel = -1,isDropMonth = true)
      tAlg.zt_tag_cancel_data_C4_2(permonth)
    }

    if(sendTp=="join_all"){
      tDawang.z_user_tag_JOIN_All(permonth,isUpdateSchema = true)
    }
  }

}
