package com.jollychic.tool

import java.sql.{Connection, DriverManager}

import com.jollychic.utils.ConstantUtils

object  OracleConnect {
  private var connection: Connection = _

  private val driver = ConstantUtils.ORACALDB_DRIVER
  private val url = ConstantUtils.ORACALDB_URL
  private val username = ConstantUtils.ORACALDB_USER
  private val password = ConstantUtils.ORACALDB_PASSWORD

  /**
   * 创建sql连接
   *
   * @return
   */
  def conn(): Connection = {

    if (connection == null) {
      println(this.driver)
      Class.forName(this.driver)
      connection = DriverManager.getConnection(this.url, this.username, this.password)
    }
    connection
  }
}
