package com.jollychic.tool

import java.sql.{Connection, DriverManager}

import com.jollychic.utils.ConstantUtils
object  SqlConnect {
  private var connection: Connection = _

  private val driver = ConstantUtils.DBS_DRIVER
  private val url = ConstantUtils.DBS_URL
  private val username = ConstantUtils.DBS_USER
  private val password = ConstantUtils.DBS_PASSWORD

  /**
   * 创建mysql连接
   * type: mysql ,oracle
   * @return
   */
  def conn(): Connection = {

    if (connection == null) {
      println(this.driver)
      Class.forName(this.driver)
      connection = DriverManager.getConnection(this.url, this.username, this.password)
    }
    connection
  }
}
