package com.jollychic.spark



import java.sql.{ResultSet, Statement}
import java.text.SimpleDateFormat
import java.time.Year
import java.util
import java.util.Date

import com.jollychic.entity.{FlatListUpdate, ZT_Table_IDs}
import com.jollychic.tool.{ClickhouseConnect, TagGenBase}
import com.jollychic.utils.{CommonKit, DateUtils}
import org.json4s.{Formats, NoTypeHints}
import org.json4s.jackson.Serialization

import scala.collection.JavaConversions
import scala.collection.JavaConverters._
import scala.collection.JavaConverters.asJavaIterableConverter
import scala.collection.mutable.ListBuffer
import scala.collection.mutable.SortedSet
// 需要导入这个包
import scala.util.control.Breaks._
class Tag_DaWang extends  TagGenBase{


  //--------------大网基础表---标签---------------------------
  /**
   * 生成全部标签
   */
  def GenXXHTagAll(): Unit ={
    val start = System.nanoTime()
    //    zt_tag_C_XXH("202106")
    zt_tag_C_XXH("202001",isInsert = true)
    zt_tag_C_XXH("202002",isInsert = true)
    zt_tag_C_XXH("202003",isInsert = true)
    zt_tag_C_XXH("202004",isInsert = true)
    zt_tag_C_XXH("202005",isInsert = true)
    zt_tag_C_XXH("202006",isInsert = true)
    zt_tag_C_XXH("202007",isInsert = true)
    zt_tag_C_XXH("202008",isInsert = true)
    zt_tag_C_XXH("202009",isInsert = true)
    zt_tag_C_XXH("202010",isInsert = true)
    zt_tag_C_XXH("202011",isInsert = true)
    zt_tag_C_XXH("202012",isInsert = true)

    zt_tag_C_XXH("202101",isInsert = true)
    zt_tag_C_XXH("202102",isInsert = true)
    zt_tag_C_XXH("202103",isInsert = true)
    zt_tag_C_XXH("202104",isInsert = true)
    zt_tag_C_XXH("202105",isInsert = true)
    //tag1()
    //    tag2()
    //    tag3()
    //    tag4()
    //    tag5()
    //    tag6()
    //    tag7()
    //    tag8()
    //    tag9()
    //    tag10()
    //    GenTag2ES_ALL()
    //    val end = System.nanoTime()
    //    val cost= end-start
    //    SaveRunTime("生成全部标签",cost)
  }

  def zt_tag_C_XXH_sp(month:String="",isInsert:Boolean=false)= {
    if (isInsert == false) {
      zt_tag_C_XXH(month, uid_l = "0", uid_r = "150")
    } else {
      zt_tag_C_XXH(month, uid_l = "0", uid_r = "150", isInsert = true)
    }
    zt_tag_C_XXH(month, uid_l = "150", uid_r = "176", isInsert = true);
    zt_tag_C_XXH(month, uid_l = "176", uid_r = "186", isInsert = true);
    zt_tag_C_XXH(month, uid_l = "186", uid_r = "9999", isInsert = true);
  }
  ///生成大网列标签
  def zt_tag_C_XXH(month:String="",isInsert:Boolean=false,uid_l:String="",uid_r:String=""):Int ={
    val maptags: Map[String, String]=get_alltags()

    var lr_UserSQL=if(uid_l=="") "" else s" and DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER <'${uid_r}'"

    //【2】生成大网全量用户标签 列存储表
    var sql:String=""
    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_TAG_XXH  ENGINE = MergeTree PARTITION BY MONTH_ID ORDER BY DEVICE_NUMBER  as
          |SELECT DEVICE_NUMBER,
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_TAG_XXH
          |SELECT DEVICE_NUMBER,
          |""".stripMargin
    }


    if(month!=""){
      sql=sql+s"'${month}' as MONTH_ID,";
    }else{
      sql=sql+" MONTH_ID,";
    }

    //    sql=sql+GenSelectTagSql_C("性别","CUST_SEX")+",";
    //    sql=sql+GenSelectTagSql_C("省份","PROV_DESC")+",";
    //    sql=sql+GenSelectTagSql_C("网络类型","SERVICE_TYPE")+",";
    //    sql=sql+GenSelectTagSql_C("年龄阶段","CERT_AGE")+",";
    //入网时长
    val yearStr=Year.now.getValue().toString();

    sql=sql+
      s"""
         |(case when (${yearStr}- floor(INNET_MONTHS*0.0001))>=20 then 'A112_07_001'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=10 and (${yearStr}- floor(INNET_MONTHS*0.0001))<20 then 'A112_07_002'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=5 and (${yearStr}- floor(INNET_MONTHS*0.0001))<10 then 'A112_07_003'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=2 and (${yearStr}- floor(INNET_MONTHS*0.0001))<5 then 'A112_07_004'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=1 and (${yearStr}- floor(INNET_MONTHS*0.0001))<2 then 'A112_07_005'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))<1 and (${yearStr}- floor(INNET_MONTHS*0.0001))>=0 then 'A112_07_006'
         |else 'A112_07_007' end) TAG_INTIME ,
         |(case when (${yearStr}- floor(INNET_MONTHS*0.0001))>=20 then '${maptags.get("A112_07_001").get}'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=10 and (${yearStr}- floor(INNET_MONTHS*0.0001))<20 then '${maptags.get("A112_07_002").get}'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=5 and (${yearStr}- floor(INNET_MONTHS*0.0001))<10 then '${maptags.get("A112_07_003").get}'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=2 and (${yearStr}- floor(INNET_MONTHS*0.0001))<5 then '${maptags.get("A112_07_004").get}'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=1 and (${yearStr}- floor(INNET_MONTHS*0.0001))<2 then '${maptags.get("A112_07_005").get}'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))<1 and (${yearStr}- floor(INNET_MONTHS*0.0001))>=0 then '${maptags.get("A112_07_006").get}'
         |else '${maptags.get("A112_07_007").get}' end) TAG_INTIME_C,
         |(${yearStr}- floor(INNET_MONTHS*0.0001)) as TAG_INTIME_V
         |""".stripMargin +","

    sql=sql+GenSelectTagSql_C("套餐","PRODUCT_CLASS_DESC")+",";

    //套餐价格
    sql=sql+
      s"""
         |(case when toFloat32OrNull(MON_FEE)<10 then 'A112_09_001'
         |when toFloat32OrNull(MON_FEE)>=10 and toFloat32OrNull(MON_FEE)<20 then 'A112_09_002'
         |when  toFloat32OrNull(MON_FEE)>=20 and toFloat32OrNull(MON_FEE)<60  then 'A112_09_003'
         |when  toFloat32OrNull(MON_FEE)>=60 and toFloat32OrNull(MON_FEE)<100  then 'A112_09_004'
         |when  toFloat32OrNull(MON_FEE)>=100 and toFloat32OrNull(MON_FEE)<150  then 'A112_09_005'
         |when  toFloat32OrNull(MON_FEE)>=150 and toFloat32OrNull(MON_FEE)<300  then 'A112_09_006'
         |when  toFloat32OrNull(MON_FEE)>=300  then 'A112_09_007'
         |else 'A112_09_008' end) TAG_PACKAGE_PIC,
         |(case when toFloat32OrNull(MON_FEE)<10 then '${maptags.get("A112_09_001").get}'
         |when toFloat32OrNull(MON_FEE)>=10 and toFloat32OrNull(MON_FEE)<20 then '${maptags.get("A112_09_002").get}'
         |when  toFloat32OrNull(MON_FEE)>=20 and toFloat32OrNull(MON_FEE)<60  then '${maptags.get("A112_09_003").get}'
         |when  toFloat32OrNull(MON_FEE)>=60 and toFloat32OrNull(MON_FEE)<100  then '${maptags.get("A112_09_004").get}'
         |when  toFloat32OrNull(MON_FEE)>=100 and toFloat32OrNull(MON_FEE)<150  then '${maptags.get("A112_09_005").get}'
         |when  toFloat32OrNull(MON_FEE)>=150 and toFloat32OrNull(MON_FEE)<300  then '${maptags.get("A112_09_006").get}'
         |when  toFloat32OrNull(MON_FEE)>=300  then '${maptags.get("A112_09_007").get}'
         |else '${maptags.get("A112_09_008").get}' end) TAG_PACKAGE_PIC_C,
         |toFloat32OrNull(MON_FEE) as TAG_PACKAGE_PIC_V
         |""".stripMargin+","
    //流量消耗
    sql=sql+
      s"""
         |(case when  toFloat64OrZero(TOTAL_FLUX)<=0  then 'B112_01_001'
         |when  toFloat64OrZero(TOTAL_FLUX)>0 and toFloat64OrZero(TOTAL_FLUX)<=500 then 'B112_01_002'
         |when   toFloat64OrZero(TOTAL_FLUX)>500 and toFloat64OrZero(TOTAL_FLUX)<=2000  then 'B112_01_003'
         |when   toFloat64OrZero(TOTAL_FLUX)>2000 and toFloat64OrZero(TOTAL_FLUX)<=5000  then 'B112_01_004'
         |when   toFloat64OrZero(TOTAL_FLUX)>5000 and toFloat64OrZero(TOTAL_FLUX)<=10000  then 'B112_01_005'
         |when   toFloat64OrZero(TOTAL_FLUX)>10000 and toFloat64OrZero(TOTAL_FLUX)<=15000  then 'B112_01_006'
         |when   toFloat64OrZero(TOTAL_FLUX)>15000 and toFloat64OrZero(TOTAL_FLUX)<=30000  then 'B112_01_007'
         |when   toFloat64OrZero(TOTAL_FLUX)>30000  then 'B112_01_008'
         | end) EVENT_FLUX,
         | (case when  toFloat64OrZero(TOTAL_FLUX)<=0  then '${maptags.get("B112_01_001").get}'
         |when  toFloat64OrZero(TOTAL_FLUX)>0 and toFloat64OrZero(TOTAL_FLUX)<=500 then '${maptags.get("B112_01_002").get}'
         |when   toFloat64OrZero(TOTAL_FLUX)>500 and toFloat64OrZero(TOTAL_FLUX)<=2000  then '${maptags.get("B112_01_003").get}'
         |when   toFloat64OrZero(TOTAL_FLUX)>2000 and toFloat64OrZero(TOTAL_FLUX)<=5000  then '${maptags.get("B112_01_004").get}'
         |when   toFloat64OrZero(TOTAL_FLUX)>5000 and toFloat64OrZero(TOTAL_FLUX)<=10000  then '${maptags.get("B112_01_005").get}'
         |when   toFloat64OrZero(TOTAL_FLUX)>10000 and toFloat64OrZero(TOTAL_FLUX)<=15000  then '${maptags.get("B112_01_006").get}'
         |when   toFloat64OrZero(TOTAL_FLUX)>15000 and toFloat64OrZero(TOTAL_FLUX)<=30000  then '${maptags.get("B112_01_007").get}'
         |when   toFloat64OrZero(TOTAL_FLUX)>30000  then '${maptags.get("B112_01_008").get}'
         | end) EVENT_FLUX_C,
         |TOTAL_FLUX as EVENT_FLUX_V
         |""".stripMargin+","

    //月消费
    sql=sql+
      s"""
         |(case when toFloat32OrNull(MON_TOTAL_FEE)<10 then 'B112_02_001'
         |when toFloat32OrNull(MON_TOTAL_FEE)>=10 and toFloat32OrNull(MON_TOTAL_FEE)<20 then 'B112_02_002'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=20 and toFloat32OrNull(MON_TOTAL_FEE)<60  then 'B112_02_003'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=60 and toFloat32OrNull(MON_TOTAL_FEE)<100  then 'B112_02_004'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=100 and toFloat32OrNull(MON_TOTAL_FEE)<150  then 'B112_02_005'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=150 and toFloat32OrNull(MON_TOTAL_FEE)<300  then 'B112_02_006'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=300  then 'B112_02_007'
         |else 'B112_02_008' end) EVENT_CONSUM,
         |(case when toFloat32OrNull(MON_TOTAL_FEE)<10 then '${maptags.get("B112_02_001").get}'
         |when toFloat32OrNull(MON_TOTAL_FEE)>=10 and toFloat32OrNull(MON_TOTAL_FEE)<20 then '${maptags.get("B112_02_002").get}'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=20 and toFloat32OrNull(MON_TOTAL_FEE)<60  then '${maptags.get("B112_02_003").get}'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=60 and toFloat32OrNull(MON_TOTAL_FEE)<100  then '${maptags.get("B112_02_004").get}'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=100 and toFloat32OrNull(MON_TOTAL_FEE)<150  then '${maptags.get("B112_02_005").get}'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=150 and toFloat32OrNull(MON_TOTAL_FEE)<300  then '${maptags.get("B112_02_006").get}'
         |when  toFloat32OrNull(MON_TOTAL_FEE)>=300  then '${maptags.get("B112_02_007").get}'
         |else '${maptags.get("B112_02_008").get}' end) EVENT_CONSUM_C,
         |toFloat32OrNull(MON_TOTAL_FEE) as EVENT_CONSUM_V
         |""".stripMargin+","


    sql=sql+GenSelectTagSql_C("手机品牌","MANU_NAME")+",";;

    //    //视频流量消耗
    //    sql=sql+
    //      s"""
    //         |(case when  toFloat64OrZero(TOTAL_FLUX_VIDEO)<=0  then 'B112_07_001'
    //         |when  toFloat64OrZero(TOTAL_FLUX_VIDEO)>0 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=512000 then 'B112_07_002'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>512000 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=2097152  then 'B112_07_003'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>2097152 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=5120000  then 'B112_07_004'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>5120000 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=10485760  then 'B112_07_005'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>10485760 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=15728640  then 'B112_07_006'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>15728640 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=31457280  then 'B112_07_007'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>31457280  then 'B112_07_008'
    //         | end) EVENT_VIDEO_FLUX,
    //         |(case when  toFloat64OrZero(TOTAL_FLUX_VIDEO)<=0  then '${maptags.get("B112_07_001").get}'
    //         |when  toFloat64OrZero(TOTAL_FLUX_VIDEO)>0 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=512000 then '${maptags.get("B112_07_002").get}'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>512000 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=2097152  then '${maptags.get("B112_07_003").get}'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>2097152 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=5120000  then '${maptags.get("B112_07_004").get}'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>5120000 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=10485760  then '${maptags.get("B112_07_005").get}'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>10485760 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=15728640  then '${maptags.get("B112_07_006").get}'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>15728640 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=31457280  then '${maptags.get("B112_07_007").get}'
    //         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>31457280  then '${maptags.get("B112_07_008").get}'
    //         | end) EVENT_VIDEO_FLUX_C,
    //         |TOTAL_FLUX_VIDEO${if(month=="202103")"*0.001*0.001" else ""} as EVENT_VIDEO_FLUX_V
    //         |""".stripMargin+","
    //视频流量消耗
    sql=sql+
      s"""
         |(case when  toFloat64OrZero(TOTAL_FLUX_VIDEO)<=0  then 'B112_07_001'
         |when  toFloat64OrZero(TOTAL_FLUX_VIDEO)>0 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=512 then 'B112_07_002'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>512 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=2096  then 'B112_07_003'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>2096 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=5120  then 'B112_07_004'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>5120 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=10240  then 'B112_07_005'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>10240 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=15720  then 'B112_07_006'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>15720 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=31480  then 'B112_07_007'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>31480  then 'B112_07_008'
         | end) EVENT_VIDEO_FLUX,
         |(case when  toFloat64OrZero(TOTAL_FLUX_VIDEO)<=0  then '${maptags.get("B112_07_001").get}'
         |when  toFloat64OrZero(TOTAL_FLUX_VIDEO)>0 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=512 then '${maptags.get("B112_07_002").get}'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>512 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=2096  then '${maptags.get("B112_07_003").get}'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>2096 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=5120  then '${maptags.get("B112_07_004").get}'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>5120 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=10240  then '${maptags.get("B112_07_005").get}'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>10240 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=15720  then '${maptags.get("B112_07_006").get}'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>15720 and toFloat64OrZero(TOTAL_FLUX_VIDEO)<=31480  then '${maptags.get("B112_07_007").get}'
         |when   toFloat64OrZero(TOTAL_FLUX_VIDEO)>31480  then '${maptags.get("B112_07_008").get}'
         | end) EVENT_VIDEO_FLUX_C,
         | toFloat64OrZero(TOTAL_FLUX_VIDEO)*0.001 as EVENT_VIDEO_FLUX_V
         |""".stripMargin+","

    //是否出账
    sql=sql+
      s"""
         |(case when IS_ACCT='1' then 'B112_14_002'
         |when  IS_ACCT='0' then 'B112_14_003'
         |else 'B112_14_001' end) EVENT_IS_ACCT,
         |(case when  IS_ACCT='1' then '${maptags.get("B112_14_002").get}'
         |when  IS_ACCT='0' then '${maptags.get("B112_14_003").get}'
         |else '${maptags.get("B112_14_001").get}' end) EVENT_IS_ACCT_C,
         |IS_ACCT as EVENT_IS_ACCT_V
         |""".stripMargin+","

    sql=sql+
      s"""
         |['B112_09_002'] as `EVENT_CANCEL_PROD.E`,
         |['订购产品用户'] as `EVENT_CANCEL_PROD.C`,
         |['dg'] as `EVENT_CANCEL_PROD.V`
         |""".stripMargin+""
    //如果不传月份 取2020 12月前所有 订购用户

    sql=sql+
      s"""
         |from (
         |	select  MONTH_ID,DEVICE_NUMBER, PROV_DESC, SERVICE_TYPE, INNET_MONTHS, CUST_SEX, CERT_AGE,
         |	 TOTAL_FLUX, TOTAL_FEE, MON_TOTAL_FEE, any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC, MAX(MON_FEE) as MON_FEE,
         |	 FLUX_M, RESOURCE_NAME, PKG_NAME, MANU_NAME, MODEL_NAME, IS_ACCT, MAX(TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO,
         |	 groupArray(CANCEL_TYPE) as CANCEL_TYPE
         |	 from
         |	(
         |		SELECT  MONTH_ID, DEVICE_NUMBER, PROV_DESC, SERVICE_TYPE, INNET_MONTHS, CUST_SEX, CERT_AGE, TOTAL_FLUX, TOTAL_FEE, MON_TOTAL_FEE, PRODUCT_CLASS_DESC, MON_FEE, FLUX_M, RESOURCE_NAME, PKG_NAME, MANU_NAME, MODEL_NAME, IS_ACCT, TOTAL_FLUX_VIDEO
	         |    ,'dg' as CANCEL_TYPE
         |	 FROM ads.XXH_ALL_MONTH where MONTH_ID ='${month}'
         |  ${lr_UserSQL}
         |	union all
         |	SELECT  MONTH_ID, DEVICE_NUMBER, PROV_DESC, SERVICE_TYPE, INNET_MONTHS, CUST_SEX, CERT_AGE, TOTAL_FLUX, TOTAL_FEE, MON_TOTAL_FEE, PRODUCT_CLASS_DESC, MON_FEE, FLUX_M, RESOURCE_NAME, PKG_NAME, MANU_NAME, MODEL_NAME, IS_ACCT, TOTAL_FLUX_VIDEO,CANCEL_TYPE
         |  FROM ads.XXH_ALL_CANCEL_MONTH xacm where MONTH_ID ='${month}'
         |  ${lr_UserSQL}
         |	) s
         |	group by
         |	 MONTH_ID,DEVICE_NUMBER, PROV_DESC, SERVICE_TYPE, INNET_MONTHS, CUST_SEX, CERT_AGE,
         |	 TOTAL_FLUX, TOTAL_FEE, MON_TOTAL_FEE,FLUX_M, RESOURCE_NAME, PKG_NAME, MANU_NAME, MODEL_NAME, IS_ACCT
         |) t
         |""".stripMargin

    println(sql)
    //执行
    RunClickhouseSQL(sql);

    //【3】生成tags 缓存表

    0
  }

  def zt_tag_C_XXH_APP_sp(month:String="",isInsert:Boolean=false)= {
    if (isInsert == false) {
      zt_tag_C_XXH_APP(month, uid_l = "0", uid_r = "150")
    } else {
      zt_tag_C_XXH_APP(month, uid_l = "0", uid_r = "150", isInsert = true)
    }
    zt_tag_C_XXH_APP(month, uid_l = "150", uid_r = "176", isInsert = true);
    zt_tag_C_XXH_APP(month, uid_l = "176", uid_r = "186", isInsert = true);
    zt_tag_C_XXH_APP(month, uid_l = "186", uid_r = "9999", isInsert = true);
  }
  ///生成大网列标签 APP应用情况
  def zt_tag_C_XXH_APP(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String=""):Int = {
    var sql: String = ""
    var lr_UserSQL=if(uid_l=="") "" else s" and DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER <'${uid_r}'"
    if (isInsert == false) {
      sql = sql +
        """
          |create table ads.ZT_USER_TAG_XXH_APP  ENGINE = MergeTree PARTITION BY MONTH_ID_APP ORDER BY DEVICE_NUMBER_APP  as
          |""".stripMargin
    } else {
      sql = sql +
        """
          |insert into  ads.ZT_USER_TAG_XXH_APP
          |""".stripMargin
    }

    //    sql=sql+
    //      s"""
    //         | select MONTH_ID as MONTH_ID_APP, DEVICE_NUMBER as DEVICE_NUMBER_APP,groupArray(tag_id) as `EVENT_APP_USE.E`,groupArray(tag_name) as `EVENT_APP_USE.C`,groupArray(ONE_FLUX) as `EVENT_APP_USE.V` from
    //         |(
    //         |select MONTH_ID, DEVICE_NUMBER,ONE_FLUX${if(month=="202103")"*0.001*0.001" else ""} as ONE_FLUX,
    //         |case when t.tag_id='' then 'B112_08_001' else t.tag_id end as tag_id,
    //         |case when t.tag_id='' then '其他' else t.tag_name end as tag_name,
    //         |s.APP_USE as TAG_VALUE,
    //         |'event_app_use' as TAG_ClASS
    //         |from
    //         |(select MONTH_ID, DEVICE_NUMBER,ONE_FLUX,
    //         |(case when ONE_FLUX>${if(month=="202103")"100000" else "0.1"}  and ONE_FLUX<=${if(month=="202103")"512000" else "0.5"} then APP_NAME||'_0.1G-0.5G'
    //         |when   ONE_FLUX>${if(month=="202103")"512000" else "0.5"} and ONE_FLUX<=${if(month=="202103")"2097152" else "2"}  then  APP_NAME||'_0.5G-2G'
    //         |when   ONE_FLUX>${if(month=="202103")"2097152" else "2"} and ONE_FLUX<=${if(month=="202103")"5120000" else "5"}  then  APP_NAME||'_2G-5G'
    //         |when   ONE_FLUX>${if(month=="202103")"5120000" else "5"} and ONE_FLUX<=${if(month=="202103")"10485760" else "10"}  then  APP_NAME||'_5G-10G'
    //         |when   ONE_FLUX>${if(month=="202103")"10485760" else "10"}  and ONE_FLUX<=${if(month=="202103")"20971520" else "20"}   then  APP_NAME||'_10G-20G'
    //         |when   ONE_FLUX>${if(month=="202103")"20971520" else "20"}  then APP_NAME||'_20G以上'
    //         | end) APP_USE
    //         |from
    //         |(
    //         |	select DISTINCT * from (
    //         |		select * from  ads.XXH_ALL_APP_MONTH where MONTH_ID ='${month}' and ONE_FLUX >${if(month=="202103")"100000" else "0.1"}
    //         |		UNION ALL
    //         |		select * from  ads.XXH_ALL_APP_CANCEL_MONTH where MONTH_ID ='${month}' and ONE_FLUX >${if(month=="202103")"100000" else "0.1"}
    //         |	) a
    //         |) a1
    //         |)s
    //         |left join ads.DIC_USERTAG  t on s.APP_USE=t.tag_name
    //         |) g
    //         |group by MONTH_ID,DEVICE_NUMBER
    //         |""".stripMargin+""

    sql=sql+
      s"""
         | select MONTH_ID as MONTH_ID_APP, DEVICE_NUMBER as DEVICE_NUMBER_APP,groupArray(tag_id) as `EVENT_APP_USE.E`,groupArray(tag_name) as `EVENT_APP_USE.C`,groupArray(ONE_FLUX) as `EVENT_APP_USE.V` from
         |(
         |select MONTH_ID, DEVICE_NUMBER,ONE_FLUX*0.001 as ONE_FLUX,
         |case when t.tag_id='' then 'B112_08_001' else t.tag_id end as tag_id,
         |case when t.tag_id='' then '其他' else t.tag_name end as tag_name,
         |s.APP_USE as TAG_VALUE,
         |'event_app_use' as TAG_ClASS
         |from
         |(select MONTH_ID, DEVICE_NUMBER,ONE_FLUX,
         |(case when ONE_FLUX>100  and ONE_FLUX<=512 then APP_NAME||'_0.1G-0.5G'
         |when   ONE_FLUX>512 and ONE_FLUX<=2096  then  APP_NAME||'_0.5G-2G'
         |when   ONE_FLUX>2096 and ONE_FLUX<=5120 then  APP_NAME||'_2G-5G'
         |when   ONE_FLUX>5120 and ONE_FLUX<=10240 then  APP_NAME||'_5G-10G'
         |when   ONE_FLUX>10240  and ONE_FLUX<=20960   then  APP_NAME||'_10G-20G'
         |when   ONE_FLUX>20960 then APP_NAME||'_20G以上'
         | end) APP_USE
         |from
         |(
         |	select DISTINCT * from (
         |		select * from  ads.XXH_ALL_APP_MONTH where MONTH_ID ='${month}' and ONE_FLUX >100  ${lr_UserSQL}
         |		UNION ALL
         |		select * from  ads.XXH_ALL_APP_CANCEL_MONTH where MONTH_ID ='${month}' and ONE_FLUX >100  ${lr_UserSQL}
         |	) a
         |) a1
         |)s
         |left join ads.DIC_USERTAG  t on s.APP_USE=t.tag_name
         |) g
         |group by MONTH_ID,DEVICE_NUMBER
         |""".stripMargin+""

    printf(sql)
    //执行
    RunClickhouseSQL(sql);
    0
  }


  //生成快手大网列标签
  def zt_tag_C_XXH_kuaishou_sp(month:String="")={
    zt_tag_C_XXH_kuaishou(month,uid_l="0",uid_r="131")
    zt_tag_C_XXH_kuaishou(month,uid_l="131",uid_r="132")
    zt_tag_C_XXH_kuaishou(month,uid_l="132",uid_r="150")
    zt_tag_C_XXH_kuaishou(month,uid_l="150",uid_r="156")
    zt_tag_C_XXH_kuaishou(month,uid_l="156",uid_r="166")
    zt_tag_C_XXH_kuaishou(month,uid_l="166",uid_r="176")
    zt_tag_C_XXH_kuaishou(month,uid_l="176",uid_r="1768")
    zt_tag_C_XXH_kuaishou(month,uid_l="1768",uid_r="1855")
    zt_tag_C_XXH_kuaishou(month,uid_l="1855",uid_r="186")
    zt_tag_C_XXH_kuaishou(month,uid_l="186",uid_r="1865")
    zt_tag_C_XXH_kuaishou(month,uid_l="1865",uid_r="9999")
  }
  ///生成快手大网列标签
  def zt_tag_C_XXH_kuaishou(month:String="",uid_l:String,uid_r:String):Int ={
    val maptags: Map[String, String]=get_alltags()
    //【2】生成大网全量用户标签 列存储表
    var sql:String=""
    sql=sql+
      """
        |insert into ads.ZT_USER_TAG_XXH_kuaishou
        |SELECT DEVICE_NUMBER,
        |""".stripMargin

    if(month!=""){
      sql=sql+s"'${month}' as MONTH_ID,";
    }else{
      sql=sql+" MONTH_ID,";
    }

    sql=sql+GenSelectTagSql_C("性别","CUST_SEX")+",";
    sql=sql+GenSelectTagSql_C("省份","PROV_DESC")+",";
    sql=sql+GenSelectTagSql_C("网络类型","SERVICE_TYPE")+",";
    sql=sql+GenSelectTagSql_C("年龄阶段","CERT_AGE")+",";
    //入网时长
    val yearStr=Year.now.getValue().toString();

    sql=sql+
      s"""
         |(case when (${yearStr}- floor(INNET_MONTHS*0.0001))>=20 then 'A112_07_001'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=10 and (${yearStr}- floor(INNET_MONTHS*0.0001))<20 then 'A112_07_002'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=5 and (${yearStr}- floor(INNET_MONTHS*0.0001))<10 then 'A112_07_003'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=2 and (${yearStr}- floor(INNET_MONTHS*0.0001))<5 then 'A112_07_004'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=1 and (${yearStr}- floor(INNET_MONTHS*0.0001))<2 then 'A112_07_005'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))<1 and (${yearStr}- floor(INNET_MONTHS*0.0001))>=0 then 'A112_07_006'
         |else 'A112_07_007' end) TAG_INTIME ,
         |(case when (${yearStr}- floor(INNET_MONTHS*0.0001))>=20 then '${maptags.get("A112_07_001").get}'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=10 and (${yearStr}- floor(INNET_MONTHS*0.0001))<20 then '${maptags.get("A112_07_002").get}'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=5 and (${yearStr}- floor(INNET_MONTHS*0.0001))<10 then '${maptags.get("A112_07_003").get}'
         |when (${yearStr}- floor(INNET_MONTHS*0.0001))>=2 and (${yearStr}- floor(INNET_MONTHS*0.0001))<5 then '${maptags.get("A112_07_004").get}'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))>=1 and (${yearStr}- floor(INNET_MONTHS*0.0001))<2 then '${maptags.get("A112_07_005").get}'
         |when  (${yearStr}- floor(INNET_MONTHS*0.0001))<1 and (${yearStr}- floor(INNET_MONTHS*0.0001))>=0 then '${maptags.get("A112_07_006").get}'
         |else '${maptags.get("A112_07_007").get}' end) TAG_INTIME_C,
         |(${yearStr}- floor(INNET_MONTHS*0.0001)) as TAG_INTIME_V
         |""".stripMargin +","

    sql=sql+GenSelectTagSql_C("套餐","PRODUCT_CLASS_DESC")+",";

    //套餐价格
    sql=sql+
      s"""
         |(case when toFloat32OrNull(MON_FEE)<10 then 'A112_09_001'
         |when toFloat32OrNull(MON_FEE)>=10 and toFloat32OrNull(MON_FEE)<20 then 'A112_09_002'
         |when  toFloat32OrNull(MON_FEE)>=20 and toFloat32OrNull(MON_FEE)<60  then 'A112_09_003'
         |when  toFloat32OrNull(MON_FEE)>=60 and toFloat32OrNull(MON_FEE)<100  then 'A112_09_004'
         |when  toFloat32OrNull(MON_FEE)>=100 and toFloat32OrNull(MON_FEE)<150  then 'A112_09_005'
         |when  toFloat32OrNull(MON_FEE)>=150 and toFloat32OrNull(MON_FEE)<300  then 'A112_09_006'
         |when  toFloat32OrNull(MON_FEE)>=300  then 'A112_09_007'
         |else 'A112_09_008' end) TAG_PACKAGE_PIC,
         |(case when toFloat32OrNull(MON_FEE)<10 then '${maptags.get("A112_09_001").get}'
         |when toFloat32OrNull(MON_FEE)>=10 and toFloat32OrNull(MON_FEE)<20 then '${maptags.get("A112_09_002").get}'
         |when  toFloat32OrNull(MON_FEE)>=20 and toFloat32OrNull(MON_FEE)<60  then '${maptags.get("A112_09_003").get}'
         |when  toFloat32OrNull(MON_FEE)>=60 and toFloat32OrNull(MON_FEE)<100  then '${maptags.get("A112_09_004").get}'
         |when  toFloat32OrNull(MON_FEE)>=100 and toFloat32OrNull(MON_FEE)<150  then '${maptags.get("A112_09_005").get}'
         |when  toFloat32OrNull(MON_FEE)>=150 and toFloat32OrNull(MON_FEE)<300  then '${maptags.get("A112_09_006").get}'
         |when  toFloat32OrNull(MON_FEE)>=300  then '${maptags.get("A112_09_007").get}'
         |else '${maptags.get("A112_09_008").get}' end) TAG_PACKAGE_PIC_C,
         |toFloat32OrNull(MON_FEE) as TAG_PACKAGE_PIC_V
         |""".stripMargin+","
    //流量消耗
    sql=sql+
      s"""
         |(case when  TOTAL_FLUX<=0  then 'B112_01_001'
         |when  TOTAL_FLUX>0 and TOTAL_FLUX<=500 then 'B112_01_002'
         |when   TOTAL_FLUX>500 and TOTAL_FLUX<=2000  then 'B112_01_003'
         |when   TOTAL_FLUX>2000 and TOTAL_FLUX<=5000  then 'B112_01_004'
         |when   TOTAL_FLUX>5000 and TOTAL_FLUX<=10000  then 'B112_01_005'
         |when   TOTAL_FLUX>10000 and TOTAL_FLUX<=15000  then 'B112_01_006'
         |when   TOTAL_FLUX>15000 and TOTAL_FLUX<=30000  then 'B112_01_007'
         |when   TOTAL_FLUX>30000  then 'B112_01_008'
         | end) EVENT_FLUX,
         | (case when  TOTAL_FLUX<=0  then '${maptags.get("B112_01_001").get}'
         |when  TOTAL_FLUX>0 and TOTAL_FLUX<=500 then '${maptags.get("B112_01_002").get}'
         |when   TOTAL_FLUX>500 and TOTAL_FLUX<=2000  then '${maptags.get("B112_01_003").get}'
         |when   TOTAL_FLUX>2000 and TOTAL_FLUX<=5000  then '${maptags.get("B112_01_004").get}'
         |when   TOTAL_FLUX>5000 and TOTAL_FLUX<=10000  then '${maptags.get("B112_01_005").get}'
         |when   TOTAL_FLUX>10000 and TOTAL_FLUX<=15000  then '${maptags.get("B112_01_006").get}'
         |when   TOTAL_FLUX>15000 and TOTAL_FLUX<=30000  then '${maptags.get("B112_01_007").get}'
         |when   TOTAL_FLUX>30000  then '${maptags.get("B112_01_008").get}'
         | end) EVENT_FLUX_C,
         |TOTAL_FLUX as EVENT_FLUX_V
         |""".stripMargin+","

    //月消费
    sql=sql+
      s"""
         |(case when MON_TOTAL_FEE<10 then 'B112_02_001'
         |when MON_TOTAL_FEE>=10 and MON_TOTAL_FEE<20 then 'B112_02_002'
         |when  MON_TOTAL_FEE>=20 and MON_TOTAL_FEE<60  then 'B112_02_003'
         |when  MON_TOTAL_FEE>=60 and MON_TOTAL_FEE<100  then 'B112_02_004'
         |when  MON_TOTAL_FEE>=100 and MON_TOTAL_FEE<150  then 'B112_02_005'
         |when  MON_TOTAL_FEE>=150 and MON_TOTAL_FEE<300  then 'B112_02_006'
         |when  MON_TOTAL_FEE>=300  then 'B112_02_007'
         |else 'B112_02_008' end) EVENT_CONSUM,
         |(case when MON_TOTAL_FEE<10 then '${maptags.get("B112_02_001").get}'
         |when MON_TOTAL_FEE>=10 and MON_TOTAL_FEE<20 then '${maptags.get("B112_02_002").get}'
         |when  MON_TOTAL_FEE>=20 and MON_TOTAL_FEE<60  then '${maptags.get("B112_02_003").get}'
         |when  MON_TOTAL_FEE>=60 and MON_TOTAL_FEE<100  then '${maptags.get("B112_02_004").get}'
         |when  MON_TOTAL_FEE>=100 and MON_TOTAL_FEE<150  then '${maptags.get("B112_02_005").get}'
         |when  MON_TOTAL_FEE>=150 and MON_TOTAL_FEE<300  then '${maptags.get("B112_02_006").get}'
         |when  MON_TOTAL_FEE>=300  then '${maptags.get("B112_02_007").get}'
         |else '${maptags.get("B112_02_008").get}' end) EVENT_CONSUM_C,
         |MON_TOTAL_FEE as EVENT_CONSUM_V
         |""".stripMargin+","


    sql=sql+GenSelectTagSql_C("手机品牌","MANU_NAME")+",";;

    //视频流量消耗
    sql=sql+
      s"""
         |(case when  TOTAL_FLUX_VIDEO<=0  then 'B112_07_001'
         |when  TOTAL_FLUX_VIDEO>0 and TOTAL_FLUX_VIDEO<=512 then 'B112_07_002'
         |when   TOTAL_FLUX_VIDEO>512 and TOTAL_FLUX_VIDEO<=2096  then 'B112_07_003'
         |when   TOTAL_FLUX_VIDEO>2096 and TOTAL_FLUX_VIDEO<=5120  then 'B112_07_004'
         |when   TOTAL_FLUX_VIDEO>5120 and TOTAL_FLUX_VIDEO<=10240  then 'B112_07_005'
         |when   TOTAL_FLUX_VIDEO>10240 and TOTAL_FLUX_VIDEO<=15720  then 'B112_07_006'
         |when   TOTAL_FLUX_VIDEO>15720 and TOTAL_FLUX_VIDEO<=31480  then 'B112_07_007'
         |when   TOTAL_FLUX_VIDEO>31480  then 'B112_07_008'
         | end) EVENT_VIDEO_FLUX,
         |(case when  TOTAL_FLUX_VIDEO<=0  then '${maptags.get("B112_07_001").get}'
         |when  TOTAL_FLUX_VIDEO>0 and TOTAL_FLUX_VIDEO<=512 then '${maptags.get("B112_07_002").get}'
         |when   TOTAL_FLUX_VIDEO>512 and TOTAL_FLUX_VIDEO<=2096  then '${maptags.get("B112_07_003").get}'
         |when   TOTAL_FLUX_VIDEO>2096 and TOTAL_FLUX_VIDEO<=5120  then '${maptags.get("B112_07_004").get}'
         |when   TOTAL_FLUX_VIDEO>5120 and TOTAL_FLUX_VIDEO<=10240  then '${maptags.get("B112_07_005").get}'
         |when   TOTAL_FLUX_VIDEO>10240 and TOTAL_FLUX_VIDEO<=15720  then '${maptags.get("B112_07_006").get}'
         |when   TOTAL_FLUX_VIDEO>15720 and TOTAL_FLUX_VIDEO<=31480  then '${maptags.get("B112_07_007").get}'
         |when   TOTAL_FLUX_VIDEO>31480  then '${maptags.get("B112_07_008").get}'
         | end) EVENT_VIDEO_FLUX_C,
         | TOTAL_FLUX_VIDEO*0.001 as EVENT_VIDEO_FLUX_V
         |""".stripMargin+","

    //是否出账
    sql=sql+
      s"""
         |(case when IS_ACCT='1' then 'B112_14_002'
         |when  IS_ACCT='0' then 'B112_14_003'
         |else 'B112_14_001' end) EVENT_IS_ACCT,
         |(case when  IS_ACCT='1' then '${maptags.get("B112_14_002").get}'
         |when  IS_ACCT='0' then '${maptags.get("B112_14_003").get}'
         |else '${maptags.get("B112_14_001").get}' end) EVENT_IS_ACCT_C,
         |IS_ACCT as EVENT_IS_ACCT_V
         |""".stripMargin+","

    sql=sql+
      s"""
         |['B112_09_001'] as `EVENT_CANCEL_PROD.E`,
         |['其他'] as `EVENT_CANCEL_PROD.C`,
         |[''] as `EVENT_CANCEL_PROD.V`
         |""".stripMargin+""
    //如果不传月份 取2020 12月前所有 订购用户
    if(month==""){


      sql=sql+
        s"""
           | FROM ads.XXH_ALL_MONTH where MONTH_ID <='202012'
           |""".stripMargin
    }else if(month>="202101"){

      sql=sql+
        s"""
           |from (
           |	select  MONTH_ID,DEVICE_NUMBER, PROV_DESC, SERVICE_TYPE, INNET_MONTHS, CUST_SEX, CERT_AGE,
           |	 TOTAL_FLUX, TOTAL_FEE, MON_TOTAL_FEE, any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC, MAX(MON_FEE) as MON_FEE,
           |	 MANU_NAME, MODEL_NAME, IS_ACCT, MAX(TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO,
           |	 groupArray(CANCEL_TYPE) as CANCEL_TYPE
           |	 from
           |	(
           |		SELECT  MONTH_ID, DEVICE_NUMBER, PROV_DESC,'' as  SERVICE_TYPE,30000101 as  INNET_MONTHS,
           |		if(CUST_SEX==1,'男','女') as CUST_SEX,
           |		multiIf((2021-CERT_AGE)>=2010,'10后',(2021-CERT_AGE)>=2000,'00后',(2021-CERT_AGE)>=1990,'90后',(2021-CERT_AGE)>=1980,'80后',
           |		(2021-CERT_AGE)>=1970,'70后',(2021-CERT_AGE)<1970,'70前','未知') as CERT_AGE,
           |		TOTAL_FLUX, TOTAL_FEE, TOTAL_FEE as  MON_TOTAL_FEE, PRODUCT_CLASS_DESC, '' as MON_FEE,
           |		'' as MANU_NAME, MODEL_NAME, '99' as IS_ACCT, TOTAL_FLUX_VIDEO
           |    ,'dg' as CANCEL_TYPE
           |	 FROM ads.XXH_KUAISHOU_MONTH where MONTH_ID ='${month}'
           |   and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'
           |   and DEVICE_NUMBER  not in (SELECT DEVICE_NUMBER FROM ads.XXH_ALL_MONTH where  MONTH_ID ='${month}')
           |	) s
           |	group by
           |	 MONTH_ID,DEVICE_NUMBER, PROV_DESC, SERVICE_TYPE, INNET_MONTHS, CUST_SEX, CERT_AGE,
           |	 TOTAL_FLUX, TOTAL_FEE, MON_TOTAL_FEE,  MANU_NAME, MODEL_NAME, IS_ACCT
           |) t
           |""".stripMargin
    }

    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }
  ///生成快手大网列标签 APP应用情况
  def zt_tag_C_XXH_APP_kuaishou(month:String,isInsert:Boolean=false):Int = {
    var sql: String = ""
    sql = sql +
      """
        |insert into  ads.ZT_USER_TAG_XXH_APP_kuaishou
        |""".stripMargin
    sql=sql+
      s"""
         | select MONTH_ID as MONTH_ID_APP, DEVICE_NUMBER as DEVICE_NUMBER_APP,groupArray(tag_id) as `EVENT_APP_USE.E`,groupArray(tag_name) as `EVENT_APP_USE.C`,groupArray(ONE_FLUX) as `EVENT_APP_USE.V` from
         |(
         |select MONTH_ID, DEVICE_NUMBER,ONE_FLUX*0.001 as ONE_FLUX,
         |case when t.tag_id='' then 'B112_08_001' else t.tag_id end as tag_id,
         |case when t.tag_id='' then '其他' else t.tag_name end as tag_name,
         |s.APP_USE as TAG_VALUE,
         |'event_app_use' as TAG_ClASS
         |from
         |(select MONTH_ID, DEVICE_NUMBER,ONE_FLUX,
         |(case when ONE_FLUX>100  and ONE_FLUX<=512 then APP_NAME||'_0.1G-0.5G'
         |when   ONE_FLUX>512 and ONE_FLUX<=2096  then  APP_NAME||'_0.5G-2G'
         |when   ONE_FLUX>2096 and ONE_FLUX<=5120 then  APP_NAME||'_2G-5G'
         |when   ONE_FLUX>5120 and ONE_FLUX<=10240 then  APP_NAME||'_5G-10G'
         |when   ONE_FLUX>10240  and ONE_FLUX<=20960   then  APP_NAME||'_10G-20G'
         |when   ONE_FLUX>20960 then APP_NAME||'_20G以上'
         | end) APP_USE
         |from
         |(
         |	select DISTINCT * from (
         |		select MONTH_ID,DEVICE_NUMBER,ONE_FLUX_KUAISHOU as ONE_FLUX,'快手' APP_NAME from  ads.XXH_KUAISHOU_MONTH
         |   where MONTH_ID ='${month}' and ONE_FLUX >100
         |	) a
         |) a1
         |)s
         |left join ads.DIC_USERTAG  t on s.APP_USE=t.tag_name
         |) g
         |group by MONTH_ID,DEVICE_NUMBER
         |""".stripMargin+""

    printf(sql)
    //执行
    RunClickhouseSQL(sql);
    0
  }

  //全量订购关系恢复快照
  def zt_tag_C_ORDER_Per_sp(): Unit ={
    zt_tag_C_ORDER_Per("202002","202001");
    zt_tag_C_ORDER_Per("202003","202002");
    zt_tag_C_ORDER_Per("202004","202003");
    zt_tag_C_ORDER_Per("202006","202005");
    zt_tag_C_ORDER_Per("202007","202006");
    zt_tag_C_ORDER_Per("202008","202007");
    zt_tag_C_ORDER_Per("202009","202008");
    zt_tag_C_ORDER_Per("202010","202009");
    zt_tag_C_ORDER_Per("202011","202010");
    zt_tag_C_ORDER_Per("202012","202011");

    //zt_tag_C_ORDER_Per("202002","202001");
    zt_tag_C_ORDER_Per("202103","202102");
    zt_tag_C_ORDER_Per("202104","202103");
    zt_tag_C_ORDER_Per("202105","202104");
    zt_tag_C_ORDER_Per("202106","202105");
    zt_tag_C_ORDER_Per("202107","202106");
    zt_tag_C_ORDER_Per("202108","202107");
  }
  def zt_tag_C_ORDER_Per(month:String="",month_d1: String):Int ={
    var sql:String=""
    sql=sql+
      """
        |insert into ads.ETL_TD_ORDER_RELATIONS_YEAR
        |""".stripMargin

    sql=sql+
      s"""
         |select '${month}' THEMONTH,
         |if(s2.USERID='',s1.PROVINCE,s2.PROVINCE) as PROVINCE,
         |if(s2.USERID='',s1.AREA,s2.AREA) as AREA,
         |if(s2.USERID='',s1.CHANNEL,s2.CHANNEL) as CHANNEL,
         |if(s2.USERID='',s1.CPID,s2.CPID) as CPID,
         |if(s2.USERID='',s1.SPID,s2.SPID) as SPID,
         |if(s2.USERID='',s1.USERID,s2.USERID) as USERID,
         |if(s2.USERID='',s1.ORDERTIME,s2.ORDERTIME) as ORDERTIME,
         |if(s2.USERID='',s1.CANCELTIME,s2.CANCELTIME) as CANCELTIME,
         |if(s2.USERID='',s1.ENDTIME,s2.ENDTIME) as ENDTIME,
         |if(s2.USERID='',s1.LASTSYNCTIME,s2.LASTSYNCTIME) as LASTSYNCTIME,
         |if(s2.USERID='',s1.CANCELCHANNEL,s2.CANCELCHANNEL) as CANCELCHANNEL
         |from
         |(
         |	select * from ads.ETL_TD_ORDER_RELATIONS_YEAR  where THEMONTH ='${month_d1}'
         |) s1
         |FULL  outer JOIN
         |(
         |	SELECT THEMONTH,PROVINCE,AREA,CHANNEL,CPID,SPID,USERID,ORDERTIME,CANCELTIME,ENDTIME,LASTSYNCTIME,CANCELCHANNEL
         |	 FROM ads.ETL_TD_ORDER_RELATIONS_MONTH  where THEMONTH ='${month}'
         |) s2 on s1.USERID=s2.USERID and s1.SPID=s2.SPID
         |""".stripMargin

    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }


  def zt_tag_C_ORDER_All(): Unit ={
    zt_tag_C_ORDER_sp("202106");
    zt_tag_C_ORDER_sp("202001",isInsert = true);
    zt_tag_C_ORDER_sp("202002",isInsert = true);
    zt_tag_C_ORDER_sp("202003",isInsert = true);
    zt_tag_C_ORDER_sp("202004",isInsert = true);
    zt_tag_C_ORDER_sp("202005",isInsert = true);
    zt_tag_C_ORDER_sp("202006",isInsert = true);
    zt_tag_C_ORDER_sp("202007",isInsert = true);
    zt_tag_C_ORDER_sp("202008",isInsert = true);
    zt_tag_C_ORDER_sp("202009",isInsert = true);
    zt_tag_C_ORDER_sp("202010",isInsert = true);
    zt_tag_C_ORDER_sp("202011",isInsert = true);
    zt_tag_C_ORDER_sp("202012",isInsert = true);

    zt_tag_C_ORDER_sp("202101",isInsert = true);
    zt_tag_C_ORDER_sp("202102",isInsert = true);
    zt_tag_C_ORDER_sp("202103",isInsert = true);
    zt_tag_C_ORDER_sp("202104",isInsert = true);
    zt_tag_C_ORDER_sp("202105",isInsert = true);
    //zt_tag_C_ORDER("202106",isInsert = true);
    zt_tag_C_ORDER_sp("202107",isInsert = true);
    zt_tag_C_ORDER_sp("202108",isInsert = true);
    zt_tag_C_ORDER_sp("202109",isInsert = true);
    zt_tag_C_ORDER_sp("202110",isInsert = true);
    zt_tag_C_ORDER_sp("202111",isInsert = true);
    zt_tag_C_ORDER_sp("202112",isInsert = true);
    zt_tag_C_ORDER_sp("202201",isInsert = true);
    zt_tag_C_ORDER_sp("202202",isInsert = true);
    zt_tag_C_ORDER_sp("202203",isInsert = true);
  }

  def zt_tag_C_ORDER_sp(month:String="",isInsert:Boolean=false)={
    if(isInsert==false){
      zt_tag_C_ORDER_t(month,uid_l="0",uid_r="150")
    }else{
      zt_tag_C_ORDER_t(month,uid_l="0",uid_r="150",isInsert = true)
    }
    zt_tag_C_ORDER_t(month,uid_l="150",uid_r="176",isInsert = true);
    zt_tag_C_ORDER_t(month,uid_l="176",uid_r="186",isInsert = true);
    zt_tag_C_ORDER_t(month,uid_l="186",uid_r="9999",isInsert = true);

    //    if(isInsert==false){
    //      zt_tag_C_ORDER_t(month,uid_l="0",uid_r="131")
    //    }else{
    //      zt_tag_C_ORDER_t(month,uid_l="0",uid_r="131",isInsert = true)
    //    }
    //    zt_tag_C_ORDER_t(month,uid_l="131",uid_r="132",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="132",uid_r="150",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="150",uid_r="156",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="156",uid_r="166",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="166",uid_r="176",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="176",uid_r="1768",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="1768",uid_r="1855",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="1855",uid_r="186",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="186",uid_r="1865",isInsert = true);
    //    zt_tag_C_ORDER_t(month,uid_l="1865",uid_r="9999",isInsert = true);
  }
  ///生成订单标签
  def zt_tag_C_ORDER_t(month:String="",uid_l:String,uid_r:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    //【1】先删除表
    //DropTag_C_First();
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    val pr1full_month=DateUtils.getNMonth(dateStr, 1,"yyyy-MM-dd")
    val the_L_Day=month+"01"
    val the_R_Day=DateUtils.getNMonth(dateStr, 1,"yyyyMMdd")
    //【2】生成大网全量用户标签 列存储表
    var sql:String=""
    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_TAG_ORDER  ENGINE = MergeTree PARTITION BY THEMONTH ORDER BY USERID  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_TAG_ORDER
          |""".stripMargin
    }

    sql=sql+
      """
        |--select toString(THEMONTH) as THEMONTH,USERID ,
        |--any(TAG_AREA) as TAG_AREA,any(TAG_AREA_C) AS TAG_AREA_C,any(TAG_AREA_V) AS TAG_AREA_V,
        |--groupArray(EVENT_CPNAME) as `EVENT_CPNAME.E`,groupArray(EVENT_CPNAME_C) as `EVENT_CPNAME.C`,groupArray(EVENT_CPNAME_V) as `EVENT_CPNAME.V`,
        |--groupArray(EVENT_SPNAME) as `EVENT_SPNAME.E`,groupArray(EVENT_SPNAME_C) as `EVENT_SPNAME.C`,groupArray(EVENT_SPNAME_V) as `EVENT_SPNAME.V`,
        |--groupArray(EVENT_CATEGORYNAME) as `EVENT_CATEGORYNAME.E`,groupArray(EVENT_CATEGORYNAME_C) as `EVENT_CATEGORYNAME.C`,groupArray(EVENT_CATEGORYNAME_V) as `EVENT_CATEGORYNAME.V`,
        |--groupArray(EVENT_CHANNEL) as `EVENT_CHANNEL.E`,groupArray(EVENT_CHANNEL_C) as `EVENT_CHANNEL.C`,groupArray(EVENT_CHANNEL_V) as `EVENT_CHANNEL.V`,
        |--groupArray(EVENT_CHANNEL_BELONGTO) as `EVENT_CHANNEL_BELONGTO.E`,groupArray(EVENT_CHANNEL_BELONGTO_C) as `EVENT_CHANNEL_BELONGTO.C`,groupArray(EVENT_CHANNEL_BELONGTO_V) as `EVENT_CHANNEL_BELONGTO.V`,
        |--groupArray(EVENT_ORDER_PRICE) as `EVENT_ORDER_PRICE.E`,groupArray(EVENT_ORDER_PRICE_C) as `EVENT_ORDER_PRICE.C`,groupArray(EVENT_ORDER_PRICE_V) as `EVENT_ORDER_PRICE.V`,
        |--groupArray(EVENT_ORDER_FLOWP) as `EVENT_ORDER_FLOWP.E`,groupArray(EVENT_ORDER_FLOWP_C) as `EVENT_ORDER_FLOWP.C`,groupArray(EVENT_ORDER_FLOWP_V) as `EVENT_ORDER_FLOWP.V`,
        |--groupArray(EVENT_ORDER_CANCEL) as `EVENT_ORDER_CANCEL.E`,groupArray(EVENT_ORDER_CANCEL_C) as `EVENT_ORDER_CANCEL.C`,groupArray(EVENT_ORDER_CANCEL_V) as `EVENT_ORDER_CANCEL.V`,
        |--groupArray(EVENT_ORDER_MONTH) as `EVENT_ORDER_MONTH.E`,groupArray(EVENT_ORDER_MONTH_C) as `EVENT_ORDER_MONTH.C`,groupArray(EVENT_ORDER_MONTH_V) as `EVENT_ORDER_MONTH.V`,
        |--groupArray(EVENT_CANCEL_DIFF) as `EVENT_CANCEL_DIFF.E`,groupArray(EVENT_CANCEL_DIFF_C) as `EVENT_CANCEL_DIFF.C`,groupArray(EVENT_CANCEL_DIFF_V) as `EVENT_CANCEL_DIFF.V`
        |--from (
        |with toYYYYMM(ORDERTIME) as OTSTR, toYYYYMM(CANCELTIME) as CTSTR
        |select THEMONTH,USERID,
        |""".stripMargin
    sql=sql+GenSelectTagSql_C("城市","AREA",field_value = "AREA")+",";
    sql=sql+GenSelectTagSql_C("产品类别","CATEGORYNAME2",field_value = "CPTYPE2")+",";
    sql=sql+GenSelectTagSql_C("订购产品","SPNAME",field_value = "SPID")+",";
    sql=sql+GenSelectTagSql_C("产品大类","CATEGORYNAME",field_value = "CPTYPE")+",";
    sql=sql+GenSelectTagSql_C("订购渠道","CHANNEL",field_value = "CHANNEL",sp="#")+",";
    sql=sql+GenSelectTagSql_C("渠道大类","BELONGTO",field_value = "BELONGTO")+",";
    sql=sql+GenSelectTagSql_C("权益领取","VIP_SPNAME",field_value = "VIPID")+",";
    sql=sql+GenSelectTagSql_C("订购时间","ORDER_TIME2",field_value = "ORDERTIME",use_tag_nv = "tag_value")+",";
    sql=sql+GenSelectTagSql_C("退订时间","CANCELTIME2",field_value = "CANCELTIME",use_tag_nv = "tag_value")+",";
    //产品订购时长
    sql=sql+
      s"""
         |(case when  DIFF_MONYH=0  then 'B112_11_002'
         |when  DIFF_MONYH>=1 and DIFF_MONYH<3 then 'B112_11_003'
         |when  DIFF_MONYH>=3 and DIFF_MONYH<6 then 'B112_11_004'
         |when  DIFF_MONYH>=6 and DIFF_MONYH<12 then 'B112_11_005'
         |when  DIFF_MONYH>=12 and DIFF_MONYH<24 then 'B112_11_006'
         |when  DIFF_MONYH>=24  then 'B112_11_007'
         | end) EVENT_ORDER_MONTH,
         | (case when  DIFF_MONYH=0  then '${maptags.get("B112_11_002").get}'
         |when  DIFF_MONYH>=1 and DIFF_MONYH<3 then '${maptags.get("B112_11_003").get}'
         |when  DIFF_MONYH>=3 and DIFF_MONYH<6 then '${maptags.get("B112_11_004").get}'
         |when  DIFF_MONYH>=6 and DIFF_MONYH<12 then '${maptags.get("B112_11_005").get}'
         |when  DIFF_MONYH>=12 and DIFF_MONYH<24 then '${maptags.get("B112_11_006").get}'
         |when  DIFF_MONYH>=24  then '${maptags.get("B112_11_007").get}'
         | end) EVENT_ORDER_MONTH_C,
         |DIFF_MONYH as EVENT_ORDER_MONTH_V
         |""".stripMargin+","
    //退订产品时长
    sql=sql+
      s"""
         |(case when  DIFF_CANCEL_MONYH<0  then 'B112_12_001'
         |when  DIFF_CANCEL_MONYH=0  then 'B112_12_002'
         |when  DIFF_CANCEL_MONYH>=1 and DIFF_CANCEL_MONYH<3 then 'B112_12_003'
         |when  DIFF_CANCEL_MONYH>=3 and DIFF_CANCEL_MONYH<6 then 'B112_12_004'
         |when  DIFF_CANCEL_MONYH>=6 and DIFF_CANCEL_MONYH<12 then 'B112_12_005'
         |when  DIFF_CANCEL_MONYH>=12  then 'B112_12_006'
         | end) EVENT_CANCEL_DIFF,
         | (case when  DIFF_CANCEL_MONYH<0  then '${maptags.get("B112_12_001").get}'
         |when  DIFF_CANCEL_MONYH=0  then '${maptags.get("B112_12_002").get}'
         |when  DIFF_CANCEL_MONYH>=1 and DIFF_CANCEL_MONYH<3 then '${maptags.get("B112_12_003").get}'
         |when  DIFF_CANCEL_MONYH>=3 and DIFF_CANCEL_MONYH<6 then '${maptags.get("B112_12_004").get}'
         |when  DIFF_CANCEL_MONYH>=6 and DIFF_CANCEL_MONYH<12 then '${maptags.get("B112_12_005").get}'
         |when  DIFF_CANCEL_MONYH>=12  then '${maptags.get("B112_12_006").get}'
         | end) EVENT_CANCEL_DIFF_C,
         |DIFF_CANCEL_MONYH as EVENT_CANCEL_DIFF_V
         |""".stripMargin+","

    //订购产品价格
    sql=sql+
      s"""
         |(case when  PRICE=0  then 'B112_16_002'
         |when  PRICE>=1 and PRICE<=3 then 'B112_16_003'
         |when  PRICE>3 and PRICE<=8 then 'B112_16_004'
         |when  PRICE>8 and PRICE<=15 then 'B112_16_005'
         |when  PRICE>15 and PRICE<=20 then 'B112_16_006'
         |when  PRICE>20  then 'B112_16_007'
         |else 'B112_16_001'
         | end) EVENT_ORDER_PRICE,
         | (case when  PRICE=0  then '${maptags.get("B112_16_002").get}'
         |when  PRICE>=1 and PRICE<=3 then '${maptags.get("B112_16_003").get}'
         |when  PRICE>3 and PRICE<=8 then '${maptags.get("B112_16_004").get}'
         |when  PRICE>8 and PRICE<=15 then '${maptags.get("B112_16_005").get}'
         |when  PRICE>15 and PRICE<=20 then '${maptags.get("B112_16_006").get}'
         |when  PRICE>20  then '${maptags.get("B112_16_007").get}'
         |else '${maptags.get("B112_16_001").get}'
         | end) EVENT_ORDER_PRICE_C,
         |PRICE as EVENT_ORDER_PRICE_V
         |""".stripMargin+","

    //产品流量使用比
    sql=sql+
      s"""
         |(case when flow_P>=0 and flow_P<=5 then 'B112_17_001'
         |when  flow_P>5 and flow_P<=20 then 'B112_17_002'
         |when  flow_P>20 and flow_P<=50 then 'B112_17_003'
         |when  flow_P>50 and flow_P<=80 then 'B112_17_004'
         |when  flow_P>80 then 'B112_17_005'
         |else 'B112_17_006'
         | end) EVENT_ORDER_FLOWP,
         | (case when flow_P>=0 and flow_P<=5 then '${maptags.get("B112_17_001").get}'
         |when  flow_P>5 and flow_P<=20 then '${maptags.get("B112_17_002").get}'
         |when  flow_P>20 and flow_P<=50 then '${maptags.get("B112_17_003").get}'
         |when  flow_P>50 and flow_P<=80 then '${maptags.get("B112_17_004").get}'
         |when  flow_P>80 then '${maptags.get("B112_17_005").get}'
         |else '${maptags.get("B112_17_006").get}'
         | end) EVENT_ORDER_FLOWP_C,
         |flow_P as EVENT_ORDER_FLOWP_V
         |""".stripMargin+","

    //产品订购状态
    //    sql=sql+
    //      s"""
    //         |multiIf(CANCELTIME='1970-01-01','B112_13_002',CANCELTIME>='${dateStr}' and CANCELTIME<'${pr1full_month}','B112_13_003','B112_13_001') as EVENT_ORDER_CANCEL,
    //         |multiIf(CANCELTIME='1970-01-01','${maptags.get("B112_13_002").get}',CANCELTIME>='${dateStr}' and CANCELTIME<'${pr1full_month}','${maptags.get("B112_13_003").get}','${maptags.get("B112_13_001").get}') as EVENT_ORDER_CANCEL_C,
    //         |multiIf(CANCELTIME='1970-01-01',1,CANCELTIME>='${dateStr}' and CANCELTIME<'${pr1full_month}',0,-1) as EVENT_ORDER_CANCEL_V
    //         |""".stripMargin+""

    //产品订购状态[新]
    sql=sql+
      s"""
         |multiIf(OTSTR = '${month}' AND CTSTR <> '${month}', 'B112_25_001', OTSTR = '${month}' AND CTSTR = '${month}', 'B112_25_002', OTSTR < '${month}' AND (CANCELTIME > '1970-01-01' and CTSTR < '${month}'), 'B112_25_003', OTSTR < '${month}' AND (CANCELTIME = '1970-01-01' or CTSTR > '${month}'), 'B112_25_004', OTSTR < '${month}' AND CTSTR = '${month}', 'B112_25_005', 'B112_25_006') as EVENT_ORDER_STATE,
         |multiIf(OTSTR = '${month}' AND CTSTR <> '${month}', '当月定未退', OTSTR = '${month}' AND CTSTR = '${month}', '当月定已退', OTSTR < '${month}' AND (CANCELTIME > '1970-01-01' and CTSTR < '${month}'), '历史已退', OTSTR < '${month}' AND (CANCELTIME = '1970-01-01' or CTSTR > '${month}'), '续订且当月未退', OTSTR < '${month}' AND CTSTR = '${month}', '续订且当月退', '其他') as EVENT_ORDER_STATE_C,
         |EVENT_ORDER_STATE_C as EVENT_ORDER_STATE_V
         |""".stripMargin+""

    sql=sql+
      s"""
         |from (
         |with toDate(concat(SUBSTRING(toString(THEMONTH),1,4),'-' ,SUBSTRING(toString(THEMONTH),5,2),'-01')) as mstr
         |select THEMONTH ,USERID,PROVINCE,AREA,ORDERTIME,CANCELTIME,ENDTIME,
         |ifNull(CHANNEL,'') as CHANNEL ,BELONGTO,
         |s1.CPID,SPID,SPNAME ,d.CPTYPE ,d.CATEGORYNAME,d.CPTYPE2 ,d.CATEGORYNAME2 ,VIPID, VIP_SPNAME,MAXFLOW,PRICE,
         |ORDERTIME,CANCELTIME,ORDER_TIME2,CANCELTIME2,
         |dateDiff('month', ORDERTIME,mstr) DIFF_MONYH,
         |dateDiff('month', if(CANCELTIME='1970-01-01',addMonths(mstr,1),CANCELTIME),mstr) DIFF_CANCEL_MONYH,
         |USERID2,LLCP,FLOW,if(MAXFLOW=='',0,FLOW/toFloat64OrNull(MAXFLOW))*100 as flow_P
         |from
         |(
         |	select
         |	if(o1.THEMONTH=0,toString(o2.THEMONTH),toString(o1.THEMONTH)) as THEMONTH,
         |	if(isNull(o1.PROVINCE) or o1.PROVINCE='' ,o2.PROVINCE,o1.PROVINCE) as PROVINCE,
         |	if(isNull(o1.AREA) or o1.AREA='',o2.AREA,o1.AREA) as AREA,
         |	CHANNEL,d1.BELONGTO as BELONGTO,
         |	if(isNull(o1.CPID) or o1.CPID='',o2.CPID,o1.CPID) as CPID,
         |	if(isNull(o1.SPID) or o1.SPID='',o2.SPID,o1.SPID) as SPID,
         |	--if(isNull(o1.SPNAME) or o1.SPNAME='',o2.SPNAME,o1.SPNAME) as SPNAME,
         |	if(o1.USERID='',o2.USERID,o1.USERID) as USERID,
         |	ORDERTIME,CANCELTIME,ENDTIME,
         | 	toYYYYMM(ORDERTIME) as ORDER_TIME1,
         |	multiIf(ORDER_TIME1<201701,'201701L',ORDER_TIME1>202701,'202701R',toString(ORDER_TIME1)) as ORDER_TIME2,
         |	toYYYYMM(CANCELTIME) as CANCELTIME1,
         |	multiIf(CANCELTIME1<201701 and CANCELTIME1!=197001,'201701L',toString(CANCELTIME1)) as CANCELTIME2,
         |	LLCP,VIPID, if(VIPID='','未领取',VIP_SPNAME) as VIP_SPNAME,
         |	if(o2.USERID='',-1,FLOW) as FLOW,
         |	--CPTYPE,
         |	o1.USERID USERID1,
         |	o2.USERID USERID2
         |	from
         | (
         | select * from  ads.ETL_TD_ORDER_RELATIONS_YEAR  where THEMONTH ='${month}'
         | --and (CANCELTIME='1970-01-01' or  (CANCELTIME>='${dateStr}' and CANCELTIME<'${pr1full_month}'))
         | and   USERID>='${uid_l}' and USERID<'${uid_r}'
         | --and (CANCELTIME='1970-01-01' or CANCELTIME>='${dateStr}')
         | ) o1
         |	left join (
         |		select any(THEMONTH) as THEMONTH ,USERID,SPID,any(CPID) as CPID,any(SPNAME) as SPNAME ,
         |		toString(groupArray(LLCP)) as LLCP,
         |		sum(FLOW) FLOW,any(PROVINCE) as PROVINCE,any(AREA) as AREA from
         |		(
         |			SELECT * from ads.TD_DXFLOWINPUT_MONTH where THEMONTH ='${month}'
         |		) group by USERID,SPID
         |	)o2
         |	on o1.USERID=o2.USERID and o1.SPID=o2.SPID
         | 	left join
         |	(
         |		select USERVAL,VIPID,if(`ds.VIPID`=='','',ds.SPNAME) as VIP_SPNAME
         |		from ads.ETL_TL_VIP_LOG a1
         |		left join (select * from ads.DIM_SXXHY  where SETID =1) ds
         |		on a1.VIPID =ds.VIPID
         |		where THEDAY >='${the_L_Day}'and THEDAY<'${the_R_Day}'
         |		and   USERVAL>='${uid_l}' and USERVAL<'${uid_r}'
         |		--and VIPID in(select VIPID from ads.DIM_SXXHY where SETID =1)
         |	) o3 on o1.USERID=o3.USERVAL
         |  left join ads.DIM_TB_CHANNELS d1 on o1.CHANNEL=d1.ID
         |	-- where o2.USERID!=''
         |	--and o1.USERID!=''
         |) s1
         |left join ads.ETL_V_TB_SP_INFO d  on s1.SPID=d.SPID
         |) s
         |--) t
         |--GROUP by THEMONTH,USERID
         |""".stripMargin+""
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  //【废弃】生成未订购标签
  def zt_tag_C_UNORDER_all()={
    val rtSet:SortedSet[String]= get_runtagMonth("202110")
    var mark:Boolean=true
    rtSet.foreach(mStr=>
    {
      if(mark==true){
        zt_tag_C_UNORDER_sp(mStr)
        mark=false
      }else{
        zt_tag_C_UNORDER_sp(mStr,isInsert=true)
      }
    }
    )


  }
  //【废弃】
  def zt_tag_C_UNORDER_sp(month:String,isInsert:Boolean=false)={
    zt_tag_C_UNORDER(month,isInsert=isInsert,uid_l="0",uid_r="131")
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="131",uid_r="132");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="132",uid_r="150");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="150",uid_r="156");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="156",uid_r="166");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="166",uid_r="176");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="176",uid_r="1768");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="1768",uid_r="1855");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="1855",uid_r="186");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="186",uid_r="1865");
    zt_tag_C_UNORDER(month,isInsert=true,uid_l="1865",uid_r="9999");
  }
  //【废弃】
  def zt_tag_C_UNORDER(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="")={
    var sql:String=""
    if(isInsert==false){
      sql=sql+
        """
          | create table ads.ZT_USER_UN_ORDER  ENGINE = MergeTree PARTITION BY THEMONTH_UN ORDER BY USERID_UN  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_UN_ORDER
          |""".stripMargin
    }
    val lrSql_USERID = if (uid_l =="") "" else s" and  USERID>='${uid_l}' and USERID<'${uid_r}'"
    val lrSql_DEVICE_NUMBER = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    sql=sql+
      s"""
         |select '${month}' as THEMONTH_UN, USERID as USERID_UN,unTags as `EVENT_UNSPNAME.E`,unSpnames as  `EVENT_UNSPNAME.C`,unSpids as `EVENT_UNSPNAME.V`
         |from (
         |	select USERID,arrayMap(x->has(spids,x),groupSpids) as indexs,
         |	arrayFilter((x,i)->i=0,groupTagids,indexs) as unTags,
         |	arrayFilter((x,i)->i=0,groupSpids,indexs) as unSpids,
         |	arrayFilter((x,i)->i=0,groupSpnames,indexs) as unSpnames
         |	from
         |	(
         |		select if(USERID='',DEVICE_NUMBER,USERID) as USERID,spids from
         |		(
         |			select USERID ,groupArray(SPID) as spids
         |			from (
         |				select USERID,SPID
         |				from ads.ETL_TD_ORDER_RELATIONS_YEAR y
         |				where THEMONTH >='202001' and THEMONTH<='${month}' ${lrSql_USERID}
         |			)
         |			GROUP BY USERID
         |		) t1
         |		full join
         |		(select DISTINCT DEVICE_NUMBER from ads.XXH_ALL_MONTH where MONTH_ID ='${month}' ${lrSql_DEVICE_NUMBER}) t2
         |		on t1.USERID=t2.DEVICE_NUMBER
         |	) g2,
         |	(
         |		select groupArray(tag_id) as groupTagids, groupArray(SPID) as groupSpids,groupArray(SPNAME) as groupSpnames from
         |		(
         |		select tag_id, SPID,SPNAME from  ads.ETL_V_TB_SP_INFO a
         |		inner join (select tag_id,tag_name from ads.DIC_USERTAG where english_name ='event_unspname') b on a.SPNAME = b.tag_name
         |		order by tag_id
         |		)
         |	) g1
         |)
         |""".stripMargin

    print(sql)
    //RunClickhouseSQL(sql);
  }

  //  ///生成订单标签
  //  def zt_tag_C_ORDER_bak0801(month:String="",isInsert:Boolean=false):Int ={
  //    val maptags: Map[String, String]=get_alltags()
  //    //【1】先删除表
  //    //DropTag_C_First();
  //
  //    //【2】生成大网全量用户标签 列存储表
  //    var sql:String=""
  //    if(isInsert==false){
  //      sql=sql+
  //        """
  //          |create table ads.ZT_USER_TAG_ORDER  ENGINE = MergeTree PARTITION BY THEMONTH ORDER BY USERID  as
  //          |""".stripMargin
  //    }else{
  //      sql=sql+
  //        """
  //          |insert into ads.ZT_USER_TAG_ORDER
  //          |""".stripMargin
  //    }
  //
  //    sql=sql+
  //      """
  //        |select toString(THEMONTH) as THEMONTH,USERID ,
  //        |MAX(TAG_AREA) as TAG_AREA,MAX(TAG_AREA_C) AS TAG_AREA_C,MAX(TAG_AREA_V) AS TAG_AREA_V,
  //        |groupArray(EVENT_CPNAME) as `EVENT_CPNAME.E`,groupArray(EVENT_CPNAME_C) as `EVENT_CPNAME.C`,groupArray(EVENT_CPNAME_V) as `EVENT_CPNAME.V`,
  //        |groupArray(EVENT_SPNAME) as `EVENT_SPNAME.E`,groupArray(EVENT_SPNAME_C) as `EVENT_SPNAME.C`,groupArray(EVENT_SPNAME_V) as `EVENT_SPNAME.V`,
  //        |groupArray(EVENT_CATEGORYNAME) as `EVENT_CATEGORYNAME.E`,groupArray(EVENT_CATEGORYNAME_C) as `EVENT_CATEGORYNAME.C`,groupArray(EVENT_CATEGORYNAME_V) as `EVENT_CATEGORYNAME.V`,
  //        |groupArray(EVENT_CHANNEL) as `EVENT_CHANNEL.E`,groupArray(EVENT_CHANNEL_C) as `EVENT_CHANNEL.C`,groupArray(EVENT_CHANNEL_V) as `EVENT_CHANNEL.V`,
  //        |groupArray(EVENT_ORDER_CANCEL) as `EVENT_ORDER_CANCEL.E`,groupArray(EVENT_ORDER_CANCEL_C) as `EVENT_ORDER_CANCEL.C`,groupArray(EVENT_ORDER_CANCEL_V) as `EVENT_ORDER_CANCEL.V`,
  //        |groupArray(EVENT_ORDER_MONTH) as `EVENT_ORDER_MONTH.E`,groupArray(EVENT_ORDER_MONTH_C) as `EVENT_ORDER_MONTH.C`,groupArray(EVENT_ORDER_MONTH_V) as `EVENT_ORDER_MONTH.V`
  //        |from (
  //        |select THEMONTH,USERID,
  //        |""".stripMargin
  //    sql=sql+GenSelectTagSql_C("城市","AREA",field_value = "AREA")+",";
  //    sql=sql+GenSelectTagSql_C("产品类别","CPNAME",field_value = "CPID")+",";
  //    sql=sql+GenSelectTagSql_C("订购产品","SPNAME",field_value = "SPID")+",";
  //    sql=sql+GenSelectTagSql_C("产品大类","CATEGORYNAME",field_value = "CATEGORYID")+",";
  //    sql=sql+GenSelectTagSql_C("订购渠道","CHANNEL",field_value = "CHANNEL",sp="#")+",";
  //
  //    //产品订购时长
  //    sql=sql+
  //      s"""
  //         |(case when  DIFF_MONYH<=1  then 'B112_11_002'
  //         |when  DIFF_MONYH>1 and DIFF_MONYH<=6 then 'B112_11_003'
  //         |when  DIFF_MONYH>6 and DIFF_MONYH<=12 then 'B112_11_004'
  //         |when  DIFF_MONYH>12 and DIFF_MONYH<=24 then 'B112_11_005'
  //         |when  DIFF_MONYH>24  then 'B112_11_006'
  //         | end) EVENT_ORDER_MONTH,
  //         | (case when  DIFF_MONYH<=1  then '${maptags.get("B112_11_002").get}'
  //         |when  DIFF_MONYH>1 and DIFF_MONYH<=6 then '${maptags.get("B112_11_003").get}'
  //         |when  DIFF_MONYH>6 and DIFF_MONYH<=12 then '${maptags.get("B112_11_004").get}'
  //         |when  DIFF_MONYH>12 and DIFF_MONYH<=24 then '${maptags.get("B112_11_005").get}'
  //         |when  DIFF_MONYH>24  then '${maptags.get("B112_11_006").get}'
  //         | end) EVENT_ORDER_MONTH_C,
  //         |DIFF_MONYH as EVENT_ORDER_MONTH_V
  //         |""".stripMargin+","
  //
  //    //订购状态
  //    sql=sql+
  //      s"""
  //         |if(CANCELTIME='1970-01-01','B112_13_002','B112_13_003') as EVENT_ORDER_CANCEL,
  //         |if(CANCELTIME='1970-01-01','${maptags.get("B112_13_002").get}','${maptags.get("B112_13_003").get}') as EVENT_ORDER_CANCEL_C,
  //         |if(CANCELTIME='1970-01-01',1,0) as EVENT_ORDER_CANCEL_V
  //         |""".stripMargin+""
  //
  //      sql=sql+
  //        s"""
  //           |from (with toString(THEMONTH) as mstr
  //           |select THEMONTH,USERID,AREA,CANCELTIME,
  //           |ifNull(o.CHANNEL,'') as CHANNEL ,o.SPID,o.SPNAME,o.CPID,d.CPNAME,d.CATEGORYID ,d.CATEGORYNAME,
  //           |dateDiff('month', ORDERTIME, toDate(concat(SUBSTRING(mstr,1,4),'-' ,SUBSTRING(mstr,5,2),'-01'))) DIFF_MONYH
  //           |from ads.HIS_FLOW_ORDER o
  //           |left join ads.DIM_PRODUCT_CATEGORY d on o.SPID =d.SPID
  //           |${if(month=="") "where THEMONTH>='202001' " else s"where THEMONTH ='${month}'"}
  //           |) s
  //           |) t
  //           |GROUP by THEMONTH,USERID
  //           |""".stripMargin+""
  //    println(sql)
  //    //执行
  //    //InsertJsonTag2EsSQL(sql);
  //
  //    0
  //  }

  //  ///生成退订产品距今标签 全部
  //  def zt_tag_C_CANCEL_DIFF_All(): Unit ={
  //    zt_tag_C_CANCEL_DIFF("202002",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202003",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202004",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202005",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202006",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202007",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202008",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202009",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202010",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202011",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202012",isInsert = true);
  //
  //    zt_tag_C_CANCEL_DIFF("202101",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202102",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202103",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202104",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202105",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202106",isInsert = true);
  //    zt_tag_C_CANCEL_DIFF("202107",isInsert = true);
  //    //zt_tag_C_CANCEL_DIFF("202108",isInsert = true);
  //  }
  //  ///生成退订产品距今标签
  //  def zt_tag_C_CANCEL_DIFF(month:String,isInsert:Boolean=false):Int ={
  //    val maptags: Map[String, String]=get_alltags()
  //
  //    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
  //    val thmonth:String= DateUtils.getNMonth(dateStr,1)
  //    val lyear:String=month.substring(0,4)+"-12-31"
  //    println(thmonth)
  //
  //    var sql:String=""
  //    if(isInsert==false){
  //      sql=sql+
  //        """
  //          |create table ads.ZT_USER_TAG_CANCEL_DIFF ENGINE = MergeTree PARTITION BY THEMONTH_C_D ORDER BY USERID_C_D  as
  //          |""".stripMargin
  //    }else{
  //      sql=sql+
  //        """
  //          |insert into ads.ZT_USER_TAG_CANCEL_DIFF
  //          |""".stripMargin
  //    }
  //
  //    sql=sql+
  //      s"""
  //         |select '${month}' as THEMONTH_C_D,USERID as USERID_C_D,
  //         |(case when  DIFF_CANCEL_MONYH<0  then 'B112_12_001'
  //         |when  DIFF_CANCEL_MONYH=0  then 'B112_12_002'
  //         |when  DIFF_CANCEL_MONYH>=1 and DIFF_CANCEL_MONYH<3 then 'B112_12_003'
  //         |when  DIFF_CANCEL_MONYH>=3 and DIFF_CANCEL_MONYH<6 then 'B112_12_004'
  //         |when  DIFF_CANCEL_MONYH>=6 and DIFF_CANCEL_MONYH<12 then 'B112_12_005'
  //         |when  DIFF_CANCEL_MONYH>=12  then 'B112_12_006'
  //         | end) EVENT_CANCEL_DIFF,
  //         | (case when  DIFF_CANCEL_MONYH<0  then '${maptags.get("B112_12_001").get}'
  //         |when  DIFF_CANCEL_MONYH=0  then '${maptags.get("B112_12_002").get}'
  //         |when  DIFF_CANCEL_MONYH>=1 and DIFF_CANCEL_MONYH<3 then '${maptags.get("B112_12_003").get}'
  //         |when  DIFF_CANCEL_MONYH>=3 and DIFF_CANCEL_MONYH<6 then '${maptags.get("B112_12_004").get}'
  //         |when  DIFF_CANCEL_MONYH>=6 and DIFF_CANCEL_MONYH<12 then '${maptags.get("B112_12_005").get}'
  //         |when  DIFF_CANCEL_MONYH>=12  then '${maptags.get("B112_12_006").get}'
  //         | end) EVENT_CANCEL_DIFF_C,
  //         |DIFF_CANCEL_MONYH as EVENT_CANCEL_DIFF_V,SPID
  //         |from
  //         |(
  //         |  with toDate(concat(SUBSTRING(toString(THEMONTH),1,4),'-' ,SUBSTRING(toString(THEMONTH),5,2),'-01')) as mstr
  //         |	SELECT USERID,SPID,
  //         |	dateDiff('month', if(CANCELTIME='1970-01-01',addMonths(mstr,1),CANCELTIME),mstr) DIFF_CANCEL_MONYH
  //         |	FROM
  //         |	(
  //         |  	select THEMONTH,USERID ,SPID,CANCELTIME
  //         |		from ads.ETL_TD_ORDER_RELATIONS_YEAR
  //         |		where THEMONTH='${month}'
  //         |    and CANCELTIME !='1970-01-01' and CANCELTIME<'${thmonth}'
  //         |	) q
  //         |) s
  //         |--where s.etime !=toDate('${thmonth}')   and EVENT_CANCEL_DIFF_V>=0
  //         |""".stripMargin+""
  //    println(sql)
  //    //执行
  //    //RunClickhouseSQL(sql);
  //
  //    0
  //  }
  //  ///生成退订产品距今标签 bak
  //  def zt_tag_C_CANCEL_DIFF_bak(month:String,isInsert:Boolean=false):Int ={
  //    val maptags: Map[String, String]=get_alltags()
  //
  //    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
  //    val thmonth:String= DateUtils.getNMonth(dateStr,1)
  //    println(thmonth)
  //
  //    var sql:String=""
  //    if(isInsert==false){
  //      sql=sql+
  //        """
  //          |create table ads.ZT_USER_TAG_CANCEL_DIFF ENGINE = MergeTree PARTITION BY THEMONTH_C_D ORDER BY USERID_C_D  as
  //          |""".stripMargin
  //    }else{
  //      sql=sql+
  //        """
  //          |insert into ads.ZT_USER_TAG_CANCEL_DIFF
  //          |""".stripMargin
  //    }
  //
  //    sql=sql+
  //      s"""
  //         |select '${month}' as THEMONTH_C_D,USERID as USERID_C_D,if(dateDiff('month', etime, toDate('${thmonth}'))<0,0,dateDiff('month', etime, toDate('${thmonth}')))  EVENT_CANCEL_DIFF_V,
  //         |(case when EVENT_CANCEL_DIFF_V >=0  and  EVENT_CANCEL_DIFF_V<1 then 'B112_12_002'
  //         |when EVENT_CANCEL_DIFF_V >=1  and  EVENT_CANCEL_DIFF_V<3 then 'B112_12_003'
  //         |when EVENT_CANCEL_DIFF_V >=3  and  EVENT_CANCEL_DIFF_V<6 then 'B112_12_004'
  //         |when EVENT_CANCEL_DIFF_V>=6 and EVENT_CANCEL_DIFF_V<12 then 'B112_12_005'
  //         |when EVENT_CANCEL_DIFF_V>=12 then 'B112_12_006'
  //         | end) EVENT_CANCEL_DIFF,
  //         | (case when EVENT_CANCEL_DIFF_V >=0  and  EVENT_CANCEL_DIFF_V<1 then '${maptags.get("B112_12_002").get}'
  //         | when EVENT_CANCEL_DIFF_V >=1  and  EVENT_CANCEL_DIFF_V<3 then '${maptags.get("B112_12_003").get}'
  //         | when EVENT_CANCEL_DIFF_V >=3  and  EVENT_CANCEL_DIFF_V<6 then '${maptags.get("B112_12_004").get}'
  //         | when EVENT_CANCEL_DIFF_V>=6 and EVENT_CANCEL_DIFF_V<12 then '${maptags.get("B112_12_005").get}'
  //         | when EVENT_CANCEL_DIFF_V>=12 then '${maptags.get("B112_12_006").get}'
  //         |  end) EVENT_CANCEL_DIFF_C
  //         |from
  //         |(
  //         |	SELECT USERID,
  //         |	arrayElement(groupArray(1)(ENDTIME),1) as etime
  //         |	FROM
  //         |	(
  //         |		select USERID ,SPID ,
  //         |		case when ENDTIME='1970-01-01' then toDate('${thmonth}') else ENDTIME end as ENDTIME
  //         |		from ads.HIS_FLOW_ORDER
  //         |		where THEMONTH >='202001' and THEMONTH <='${month}'
  //         |		order by ENDTIME desc
  //         |	)GROUP BY USERID
  //         |) s
  //         |where s.etime !=toDate('${thmonth}')   and EVENT_CANCEL_DIFF_V>=0
  //         |""".stripMargin+""
  //    println(sql)
  //    //执行
  //    //RunClickhouseSQL(sql);
  //
  //    0
  //  }

  ///生成用户订购状态标签
  def zt_tag_User_OrderState_All(): Unit ={
    zt_tag_User_OrderState("202106");
    zt_tag_User_OrderState("202001",isInsert = true);
    zt_tag_User_OrderState("202002",isInsert = true);
    zt_tag_User_OrderState("202003",isInsert = true);
    zt_tag_User_OrderState("202004",isInsert = true);
    zt_tag_User_OrderState("202005",isInsert = true);
    zt_tag_User_OrderState("202006",isInsert = true);
    zt_tag_User_OrderState("202007",isInsert = true);
    zt_tag_User_OrderState("202008",isInsert = true);
    zt_tag_User_OrderState("202009",isInsert = true);
    zt_tag_User_OrderState("202010",isInsert = true);
    zt_tag_User_OrderState("202011",isInsert = true);
    zt_tag_User_OrderState("202012",isInsert = true);

    zt_tag_User_OrderState("202101",isInsert = true);
    zt_tag_User_OrderState("202102",isInsert = true);
    zt_tag_User_OrderState("202103",isInsert = true);
    zt_tag_User_OrderState("202104",isInsert = true);
    zt_tag_User_OrderState("202105",isInsert = true);
    //zt_tag_User_OrderState("202106",isInsert = true);
    zt_tag_User_OrderState("202107",isInsert = true);
    zt_tag_User_OrderState("202108",isInsert = true);
    zt_tag_User_OrderState("202109",isInsert = true);
  }
  ///生成用户订购状态标签
  def zt_tag_User_OrderState_sp(month:String,isInsert:Boolean=false):Int = {
    zt_tag_User_OrderState(month,uid_l="0",uid_r="150",isInsert = true)
    zt_tag_User_OrderState(month,uid_l="150",uid_r="176",isInsert = true);
    zt_tag_User_OrderState(month,uid_l="176",uid_r="186",isInsert = true);
    zt_tag_User_OrderState(month,uid_l="186",uid_r="9999",isInsert = true);
  }
  def zt_tag_User_OrderState(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String=""):Int ={
    val maptags: Map[String, String]=get_alltags()
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    val thmonth:String= DateUtils.getNMonth(dateStr,1)

    val lrSql_DEVICE_NUMBER = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    val lrSql_USERID = if (uid_l =="") "" else s" and  USERID>='${uid_l}' and USERID<'${uid_r}'"
    var sql:String=""
    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_ORDER_STATE ENGINE = MergeTree PARTITION BY THEMONTH_BL ORDER BY USERID_BL  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_ORDER_STATE
          |""".stripMargin
    }
    sql=sql+
      s"""
         |select '${month}' as THEMONTH_BL,DEVICE_NUMBER as USERID_BL,
         |toDate('1970-01-01') as cTime,
         |'B112_19_003' as EVENT_USER_OSTATE,
         |'未订过' as EVENT_USER_OSTATE_C,
         |toDate('1970-01-01') as EVENT_USER_OSTATE_V from (
         |	select DISTINCT DEVICE_NUMBER from
         |	(
         |		select   DEVICE_NUMBER from ads.XXH_ALL_MONTH where 1=1 ${lrSql_DEVICE_NUMBER}
         |		union all
         |		select  DEVICE_NUMBER from ads.XXH_KUAISHOU_MONTH xkm where 1=1 ${lrSql_DEVICE_NUMBER}
         |	)
         |) s
         |where s.DEVICE_NUMBER not in (
         |	select USERID from   ads.ztemp_relation_users  where 1=1 ${lrSql_USERID}--ads.ETL_TD_ORDER_RELATIONS
         |)
         |union all
         |SELECT '${month}' as THEMONTH_BL,USERID as USERID_BL,
         |arrayJoin(groupArray(1)(CANCELTIME1)) AS cTime,
         |if(cTime>='${thmonth}' ,'B112_19_001','B112_19_002') as EVENT_USER_OSTATE,
         |if(cTime>='${thmonth}' ,'在订','退订') as EVENT_USER_OSTATE_C,
         |cTime as EVENT_USER_OSTATE_V
         |FROM
         |  (
         |    SELECT USERID ,
         |    if(CANCELTIME='1970-01-01', toDate('${thmonth}'),CANCELTIME) as CANCELTIME1
         |    FROM ads.ETL_TD_ORDER_RELATIONS_YEAR
         |    where THEMONTH ='${month}' ${lrSql_USERID}
         |    ORDER BY CANCELTIME1 DESC
         |  )
         |GROUP BY USERID
         |""".stripMargin
    println(sql)
    //执行
    RunClickhouseSQL(sql);
    0
  }

  def zt_tag_C_ORDER_SumDate_All(): Unit ={
    zt_tag_C_ORDER_SumDate("202001");
    zt_tag_C_ORDER_SumDate("202002",isInsert = true);
    zt_tag_C_ORDER_SumDate("202003",isInsert = true);
    zt_tag_C_ORDER_SumDate("202004",isInsert = true);
    zt_tag_C_ORDER_SumDate("202005",isInsert = true);
    zt_tag_C_ORDER_SumDate("202006",isInsert = true);
    zt_tag_C_ORDER_SumDate("202007",isInsert = true);
    zt_tag_C_ORDER_SumDate("202008",isInsert = true);
    zt_tag_C_ORDER_SumDate("202009",isInsert = true);
    zt_tag_C_ORDER_SumDate("202010",isInsert = true);
    zt_tag_C_ORDER_SumDate("202011",isInsert = true);
    zt_tag_C_ORDER_SumDate("202012",isInsert = true);

    zt_tag_C_ORDER_SumDate("202101",isInsert = true);
    zt_tag_C_ORDER_SumDate("202102",isInsert = true);
    zt_tag_C_ORDER_SumDate("202103",isInsert = true);
    zt_tag_C_ORDER_SumDate("202104",isInsert = true);
    zt_tag_C_ORDER_SumDate("202105",isInsert = true);
    zt_tag_C_ORDER_SumDate("202106",isInsert = true);
    zt_tag_C_ORDER_SumDate("202107",isInsert = true);
    zt_tag_C_ORDER_SumDate("202108",isInsert = true);
    zt_tag_C_ORDER_SumDate("202109",isInsert = true);
  }
  ///生成产品订购总时长标签
  def zt_tag_C_ORDER_SumDate(month:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    var sql:String=""
    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_TAG_ORDER_SUMDATE ENGINE = MergeTree PARTITION BY THEMONTH_OS ORDER BY USERID_OS  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_TAG_ORDER_SUMDATE
          |""".stripMargin
    }

    // 全量统计总时长
    //    select  USERID,sum(DiffDate) as sumDate
    //    from
    //    (
    //      select  USERID ,dateDiff('month',ORDERTIME,if(ENDTIME='1970-01-01' or ENDTIME>='2021-12-31',toDate('2021-07-01'),ENDTIME))
    //    as DiffDate
    //      from ads.ETL_TD_ORDER_RELATIONS_YEAR
    //    where  THEMONTH ='202106'
    //    ) s
    //    group by USERID

    sql=sql+
      s"""
         |select '${month}' as THEMONTH_OS,USERID as USERID_OS,
         |(case when  sumDate<=1  then 'B112_15_002'
         |when  sumDate>1 and sumDate<=6 then 'B112_15_003'
         |when  sumDate>6 and sumDate<=12 then 'B112_15_004'
         |when  sumDate>12 and sumDate<=24 then 'B112_15_005'
         |when  sumDate>24  then 'B112_15_006'
         | end) EVENT_ORDER_SUMMONTH,
         | (case when  sumDate<=1  then '${maptags.get("B112_15_002").get}'
         |when  sumDate>1 and sumDate<=6 then '${maptags.get("B112_15_003").get}'
         |when  sumDate>6 and sumDate<=12 then '${maptags.get("B112_15_004").get}'
         |when  sumDate>12 and sumDate<=24 then '${maptags.get("B112_15_005").get}'
         |when  sumDate>24  then '${maptags.get("B112_15_006").get}'
         | end) EVENT_ORDER_SUMMONTH_C,
         |sumDate as EVENT_ORDER_SUMMONTH_V
         |from
         |(
         |	select  USERID,sum(dateDiff('month',ORDERTIME,ENDTIME1)+1) as sumDate
         |  from
         |  (select DISTINCT USERID ,ORDERTIME, if(ENDTIME='1970-01-01', toDate('${dateStr}'),ENDTIME) as ENDTIME1
         |  from ads.HIS_FLOW_ORDER
         |  where THEMONTH <='${month}' ) s
         |  group by USERID
         |) t
         |""".stripMargin+""
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  ///生成RMF标签
  def zt_tag_RMF(month:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    var sql:String=""

    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_RFM ENGINE = MergeTree PARTITION BY THEMONTH_RFM ORDER BY USERID_RFM  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_RFM
          |""".stripMargin
    }

    sql=sql+
      s"""
         |select '${month}' as THEMONTH_RFM, USERID as USERID_RFM,
         |(case when CLASS =1 then 'A112_03_001'
         |when  CLASS =2 then 'A112_03_002'
         |when  CLASS =3 then 'A112_03_003'
         |when  CLASS =4 then 'A112_03_004'
         |when  CLASS =5 then 'A112_03_005'
         | end) TAG_RFM,
         | (case when CLASS =1 then '${maptags.get("A112_03_001").get}'
         | when  CLASS =2 then '${maptags.get("A112_03_002").get}'
         | when  CLASS =3 then '${maptags.get("A112_03_003").get}'
         | when  CLASS =4 then '${maptags.get("A112_03_004").get}'
         | when CLASS =5 then '${maptags.get("A112_03_005").get}'
         |  end) TAG_RFM_C,CLASS as TAG_RFM_V
         |from ads.ALS_RMF_CLUSTER2_RESULT """.stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }


  //生成投诉次数标签
  def zt_tag_complain(month:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    var sql:String=""

    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_COMPLAIN ENGINE = MergeTree PARTITION BY THEMONTH_COMPLAIN ORDER BY USERID_COMPLAIN  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_COMPLAIN
          |""".stripMargin
    }

    sql=sql+
      s"""
         |select '${month}' as THEMONTH_COMPLAIN,
         |ACCEPT_PHONENUM as USERID_COMPLAIN,
         |(case when TAG_COMPLAIN_V = 0 then 'B112_22_001'
         |when TAG_COMPLAIN_V = 1 then 'B112_22_002'
         |when TAG_COMPLAIN_V >= 2 and TAG_COMPLAIN_V <= 3 then 'B112_22_003'
         |when TAG_COMPLAIN_V >= 4 and TAG_COMPLAIN_V <= 5 then 'B112_22_004'
         |when TAG_COMPLAIN_V > 5 then 'B112_22_005'
         | end) TAG_COMPLAIN,
         | (case when TAG_COMPLAIN_V = 0 then '${maptags.get("B112_22_001").get}'
         | when  TAG_COMPLAIN_V = 1 then '${maptags.get("B112_22_002").get}'
         | when  TAG_COMPLAIN_V >= 2 and TAG_COMPLAIN_V <= 3 then '${maptags.get("B112_22_003").get}'
         | when  TAG_COMPLAIN_V >= 4 and TAG_COMPLAIN_V <= 5 then '${maptags.get("B112_22_004").get}'
         | when TAG_COMPLAIN_V > 5 then '${maptags.get("B112_22_005").get}'
         | end) TAG_COMPLAIN_C,
         | COUNT(1) as TAG_COMPLAIN_V
         | from ads.FCT_CS_COMPLAINT_DETAIL
         | where THEMONTH < '${month}'
         | group by ACCEPT_PHONENUM""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  //生成APP偏好标签【近三个月】
  def zt_tag_app_preference(month:String, isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()

    var sql:String=""

    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_APP_PREFERENCE ENGINE = MergeTree PARTITION BY THEMONTH_APP_PREF ORDER BY USERID_APP_PREF  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_APP_PREFERENCE
          |""".stripMargin
    }

    implicit val formats:AnyRef with Formats = Serialization.formats(NoTypeHints)

    val scalaList: List[String] = JavaConversions.asScalaBuffer(CommonKit.filterList(maptags.asJava, "B112_23")).toList
    val scalaMap: Map[String, String] = JavaConversions.mapAsScalaMap(CommonKit.filterMap(maptags.asJava, "B112_23")).toMap

    var tagList = Serialization.write(scalaList).replaceAll("\"", "'");
    var tagMap = Serialization.write(scalaMap);
    var startMonth = DateUtils.getMMonth(month, -2, "yyyyMM");

    sql=sql+
      s"""
         | with NULLIF(APP_NAME, '') as APPNAME
         | select '${month}' as THEMONTH_APP_PREF,
         | DEVICE_NUMBER as USERID_APP_PREF,
         | arrayMap(x -> JSONExtractString('${tagMap}', x), `TAG_APP_PREF.C`) `TAG_APP_PREF.E`,
         | groupUniqArray(if(has(${tagList}, APPNAME) = 1, APPNAME, '其他')) as `TAG_APP_PREF.C`,
         | `TAG_APP_PREF.C` as `TAG_APP_PREF.V`
         | from ads.XXH_ALL_APP_MONTH
         | where MONTH_ID >= '${startMonth}' and MONTH_ID <= '${month}' and ONE_FLUX > 1024
         | group by DEVICE_NUMBER""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  ///【废弃】生成退订预测数据
  def zt_tag_cancel_data(month:String,isInsert:Boolean=false,cancelmark:Int=999):Int ={
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    val pr1full_month=DateUtils.getNMonth(dateStr, 1,"yyyy-MM-dd")
    val p1month=DateUtils.getNMonth(dateStr, 0,"yyyyMM")
    val p2month=DateUtils.getNMonth(dateStr, -1,"yyyyMM")
    val p3month=DateUtils.getNMonth(dateStr, -2,"yyyyMM")
    val p4month=DateUtils.getNMonth(dateStr, -3,"yyyyMM")

    var cancel2Int8=231
    if(cancelmark!=999){
      cancel2Int8=cancelmark;
    }
    var order_sql1=
      s"""
         |	where  THEMONTH='${p1month}' and  CANCELTIME='1970-01-01'
         |	and ORDERTIME <'${pr1full_month}'
         |""".stripMargin
    if(cancelmark==0){
      order_sql1=
        s"""
           |	where  CANCELTIME >='${dateStr}' and  CANCELTIME <'${pr1full_month}'
			     |  and ORDERTIME <'${dateStr}'
           |""".stripMargin
    } else if (cancelmark==1){
      order_sql1=
        s"""
           |	where  THEMONTH='${p1month}' and  CANCELTIME='1970-01-01'
           |	and ORDERTIME <'${dateStr}'
           |  order by rand32()
           |	LIMIT 3500000
           |""".stripMargin
    }

    var sql:String=""
    sql=sql+
      s"""
         |insert into ads.ALS_XXH_ORDER_C1
         |select '${p1month}' as TARGET_MONTH,${cancelmark} as CANCELMARK, * from (
         |	select USERID,toString(MONTH3) as MONTH3,
         |	PROVINCE,ifNull(CHANNEL,'') as CHANNEL,
         |	ifNull(CPID,'') as CPID,
         |	ifNull(SPID,'') as SPID,
         |	ORDERTIME,DIFF_MONYH,CANCELTIME,
         |	THEMONTH as MONTH_FLOW,FLOW from (
         |	   --准备当月退订的前三个月 的结构
         |		select distinct USERID,toString(MONTH3) as MONTH3,
         |		replaceOne(replaceOne(replaceOne(PROVINCE,'省',''),'市',''),'自治区','') as PROVINCE,
         |		CHANNEL,CPID,SPID,ORDERTIME,DIFF_MONYH,CANCELTIME  from (
         |		 	select distinct USERID,MONTH3
         |			from ads.HIS_FLOW_ORDER
         |			array join [${p3month},${p2month},${p1month}] as MONTH3
         |		  ${order_sql1}
         |			--and USERID ='18664107383'
         |		) s
         |		--取当月的order表中的 值
         |		left join
         |		(
         |		   select USERID,any(PROVINCE) as PROVINCE,
         |				any(CHANNEL) as CHANNEL ,any(CPID) as CPID ,SPID,
         |				any(ORDERTIME) as ORDERTIME,any(CANCELTIME) as CANCELTIME,
         |				max(DIFF_MONYH) as DIFF_MONYH
         |		   from (
         |				with toString(THEMONTH) as mstr
         |				select USERID,THEMONTH,PROVINCE,CHANNEL,CPID,SPID,ORDERTIME,CANCELTIME,
         |				dateDiff('month', ORDERTIME, toDate(concat(SUBSTRING(mstr,1,4),'-' ,SUBSTRING(mstr,5,2),'-01')))+1 DIFF_MONYH
         |				from
         |				ads.HIS_FLOW_ORDER
         |        ${order_sql1}
         |				--and USERID ='18664107383'
         |			) group by  USERID,SPID
         |		) s01 on s.USERID=s01.USERID
         |	) s11
         |	--流量日志表
         |	 left join
         |	 (
         |	 	select THEMONTH,USERID,SPID,max(FLOW) as FLOW from (
         |	 	select THEMONTH,USERID,SPID,FLOW from ads.TD_DXFLOWINPUT_MONTH where THEMONTH in ('${p3month}','${p2month}','${p1month}')
         |	 	--and USERID ='18664107383'
         |	 	)
         |	 	group by THEMONTH,USERID,SPID
         |	 ) s12
         |	 on s11.MONTH3=s12.THEMONTH and s11.USERID =s12.USERID and s11.SPID=s12.SPID
         | ) s21 left join
         |  --信息化大表
         |
         |(
         |select MONTH_ID,DEVICE_NUMBER,
         | if(INNET_MONTHS=0,x2.INNET_MONTHS,INNET_MONTHS) as INNET_MONTHS,
         | if(CUST_SEX='',ifNull(x2.CUST_SEX,''),ifNull(CUST_SEX,'')) as CUST_SEX,
         | if(CERT_AGE='',ifNull(x2.CERT_AGE,''),ifNull(CERT_AGE,'')) as CERT_AGE,
         | if(TOTAL_FLUX=0,ifNull(x2.TOTAL_FLUX,0),ifNull(TOTAL_FLUX,0)) as TOTAL_FLUX,
         | if(TOTAL_FEE=0,ifNull(x2.TOTAL_FEE,0),ifNull(TOTAL_FEE,0)) as TOTAL_FEE,
         | if(PRODUCT_CLASS_DESC='',ifNull(x2.PRODUCT_CLASS_DESC,''),ifNull(PRODUCT_CLASS_DESC,'')) as PRODUCT_CLASS_DESC,
         | if(MANU_NAME='',ifNull(x2.MANU_NAME,''),ifNull(MANU_NAME,'')) as MANU_NAME,
         |  toUInt32(if(IS_ACCT='999',ifNull(x2.IS_ACCT,0),ifNull(IS_ACCT,0))) as IS_ACCT,
         | if(TOTAL_FLUX_VIDEO=0,ifNull(x2.TOTAL_FLUX_VIDEO,0),ifNull(TOTAL_FLUX_VIDEO,0)) as TOTAL_FLUX_VIDEO
         | from
         | 	(
         |	 	select MONTH3 as  MONTH_ID,DEVICE_NUMBER,INNET_MONTHS,
         |			-- CUST_SEX ,CERT_AGE,TOTAL_FLUX ,TOTAL_FEE ,PRODUCT_CLASS_DESC,MANU_NAME,IS_ACCT,MIN(REAL_TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO
         |			ifNull(CUST_SEX,'') as CUST_SEX ,
         |			ifNull(CERT_AGE,'') as CERT_AGE,
         |			toFloat64OrZero(ifNull(TOTAL_FLUX,'0')) as TOTAL_FLUX ,
         |			toFloat64OrZero(ifNull(TOTAL_FEE,'0')) as TOTAL_FEE ,
         |			ifNull(PRODUCT_CLASS_DESC,'') as PRODUCT_CLASS_DESC,
         |			ifNull(MANU_NAME,'') as MANU_NAME,
         |			toInt64OrZero(ifNull(IS_ACCT,'999')) as IS_ACCT,
         |			ifNull(TOTAL_FLUX_VIDEO,0) as TOTAL_FLUX_VIDEO
         |		from
         |		(
         |			select distinct DEVICE_NUMBER,MONTH3
         |			from  ads.XXH_ALL_MONTH
         |			array join ['${p3month}','${p2month}','${p1month}'] as MONTH3
         |			where MONTH_ID in ('${p3month}','${p2month}','${p1month}')
         |      and DEVICE_NUMBER in (select DISTINCT USERID from ads.HIS_FLOW_ORDER where THEMONTH in ('${p3month}','${p2month}','${p1month}'))
         |			--and  DEVICE_NUMBER ='13001000025'
         |	    ) x0 left join
         |		 --信息化大表
         |		 (
         |			select  if(like(MONTH_ID,'%12'), toString(toInt32(MONTH_ID)+89),toString(toInt32(MONTH_ID)+1)) as MONTH_ID ,DEVICE_NUMBER,INNET_MONTHS,
         |			CUST_SEX ,CERT_AGE,TOTAL_FLUX ,TOTAL_FEE ,any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC,MANU_NAME,IS_ACCT,MIN(REAL_TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO
         |			from
         |			 (
         |				 select *,toFloat64OrZero(TOTAL_FLUX_VIDEO) as REAL_TOTAL_FLUX_VIDEO  from  ads.XXH_ALL_MONTH
         |				 where MONTH_ID in ('${p4month}','${p3month}','${p2month}')
         |				 --and  DEVICE_NUMBER ='13001000025'
         |				 and DEVICE_NUMBER in (select DISTINCT USERID from ads.HIS_FLOW_ORDER where THEMONTH in ('${p3month}','${p2month}','${p1month}'))
         |			 )s
         |			 group by MONTH_ID,DEVICE_NUMBER,INNET_MONTHS,CUST_SEX ,CERT_AGE ,TOTAL_FLUX ,TOTAL_FEE ,MANU_NAME, IS_ACCT
         |		) x1 on x0.MONTH3=x1.MONTH_ID and x0.DEVICE_NUMBER=x1.DEVICE_NUMBER
         |	) xx1
         |
         |	 left join
         |	--按月排序 取最先有值的字段，和 数值型平均值   用来补缺失值
         |	 (
         |		SELECT
         |			DEVICE_NUMBER,
         |			any(INNET_MONTHS) as INNET_MONTHS,
         |			any(CUST_SEX) as CUST_SEX, --排除NULL值
         |			any(CERT_AGE) as CERT_AGE,
         |			avg(TOTAL_FLUX) as TOTAL_FLUX ,
         |			avg(TOTAL_FEE) as TOTAL_FEE ,
         |			any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC,
         |			any(MANU_NAME) as MANU_NAME,
         |			any(CERT_AGE) as CERT_AGE,
         |			any(IS_ACCT) as IS_ACCT,
         |			avg(REAL_TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO
         |		FROM
         |		  (
         |			 --去除5 月份以后的重复数据
         |			 select MONTH_ID,DEVICE_NUMBER,INNET_MONTHS,CUST_SEX,CERT_AGE,
         |			 toFloat64OrNull(TOTAL_FLUX) as TOTAL_FLUX,toFloat64OrNull(TOTAL_FEE) as TOTAL_FEE,
         |			 any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC,MANU_NAME,
         |			 toInt64OrNull(IS_ACCT) as IS_ACCT,MIN(REAL_TOTAL_FLUX_VIDEO) as REAL_TOTAL_FLUX_VIDEO
         |			 from
         |			 (
         |				 select *,toFloat64OrZero(TOTAL_FLUX_VIDEO) as REAL_TOTAL_FLUX_VIDEO  from  ads.XXH_ALL_MONTH
         |				 where MONTH_ID in ('${p4month}','${p3month}','${p2month}')
         |				 --and  DEVICE_NUMBER ='13001000025'
         |				 and DEVICE_NUMBER in (select DISTINCT USERID from ads.HIS_FLOW_ORDER where THEMONTH in ('${p4month}','${p3month}','${p2month}'))
         |			 )s
         |			 group by MONTH_ID,DEVICE_NUMBER,INNET_MONTHS,CUST_SEX ,CERT_AGE ,TOTAL_FLUX ,TOTAL_FEE ,MANU_NAME, IS_ACCT
         |			 order by MONTH_ID
         |		  )
         |		group by  DEVICE_NUMBER
         |	) x2 on xx1.DEVICE_NUMBER=x2.DEVICE_NUMBER
         |)s22
         | on s21.MONTH3=s22.MONTH_ID and s21.USERID=s22.DEVICE_NUMBER
         |""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);


    //生成编码表
    var sql2:String=""
    sql2=sql2+
      s"""
         |insert into ads.ALS_XXH_ORDER_C2
         |select
         |any(TARGET_MONTH) as TARGET_MONTH,
         |rowNumberInAllBlocks() as ROWNUMBER,
         |any(CANCELMARK) as CANCELMARK,
         |USERID,
         |any(PROVINCE) as PROVINCE,
         |any(PROVINCE_DECODE) as PROVINCE_DECODE,
         |any(CPID) as CPID,
         |any(CPID_DECODE) as CPID_DECODE,
         |SPID,any(SPID_DECODE) as SPID_DECODE,
         |any(DIFF_MONYH) as DIFF_MONYH,
         |any(DIFF_MONYH_P) as DIFF_MONYH_P,
         |any(CANCELTIME) as CANCELTIME,
         |groupArray(FLOW) as FLOW,
         |groupArray(FLOW_P) as FLOW_P,
         |any(INNET_MONTHS) as INNET_MONTHS,
         |any(CUST_SEX) as CUST_SEX,
         |any(CUST_SEX_DECODE) as CUST_SEX_DECODE,
         |any(CERT_AGE) as CERT_AGE,
         |any(CERT_AGE_DECODE) as CERT_AGE_DECODE,
         |groupArray(TOTAL_FLUX) as TOTAL_FLUX,
         |groupArray(TOTAL_FLUX_P) as TOTAL_FLUX_P,
         |groupArray(TOTAL_FEE) as TOTAL_FEE,
         |groupArray(TOTAL_FEE_P) as TOTAL_FEE_P,
         |any(PRODUCT_CLASS_DESC) as PRODUCT_CLASS_DESC,
         |groupArray(MANU_NAME) as MANU_NAME,
         |maxForEach(MANU_NAME_DECODE) as MANU_NAME_DECODE, --手机型号有变化按位 或 合并onehot
         |groupArray(IS_ACCT) as IS_ACCT,
         |groupArray(TOTAL_FLUX_VIDEO) as TOTAL_FLUX_VIDEO,
         |groupArray(TOTAL_FLUX_VIDEO_P) as TOTAL_FLUX_VIDEO_P
         |from
         |(
         |	SELECT TARGET_MONTH,CANCELMARK, USERID,MONTH3,
         |	PROVINCE,p1.DECODE as PROVINCE_DECODE,
         |	CPID,cp1.CODE,cp2.DECODE as CPID_DECODE,
         |	SPID,sp1.CODE,sp2.DECODE as SPID_DECODE,
         |	DIFF_MONYH, if(DIFF_MONYH>70,70,DIFF_MONYH)/70 as DIFF_MONYH_P, CANCELTIME,
         |	MONTH_FLOW,FLOW, if(FLOW>15000,15000,FLOW)/15000 as FLOW_P,
         |	MONTH_ID, DEVICE_NUMBER, INNET_MONTHS, CUST_SEX,s1.DECODE as CUST_SEX_DECODE,
         |	CERT_AGE,a1.DECODE as CERT_AGE_DECODE, TOTAL_FLUX,if(TOTAL_FLUX>20000,20000,TOTAL_FLUX)/20000 as TOTAL_FLUX_P,
         |	TOTAL_FEE,if(TOTAL_FEE>300,300,TOTAL_FEE)/300 as TOTAL_FEE_P, PRODUCT_CLASS_DESC,
         |	MANU_NAME,m1.CODE,m2.DECODE as MANU_NAME_DECODE, IS_ACCT,
         |	TOTAL_FLUX_VIDEO,if(TOTAL_FLUX_VIDEO>20000,20000,TOTAL_FLUX_VIDEO)/20000 as TOTAL_FLUX_VIDEO_P
         |	FROM ads.ALS_XXH_ORDER_C1 c1
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='PROVINCE') p1 on c1.PROVINCE =p1.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='CPID') cp1 on c1.CPID =cp1.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='CPID') cp2 on cp1.CODE =cp2.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='SPID') sp1 on c1.SPID =sp1.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='SPID') sp2 on sp1.CODE =sp2.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='SEX') s1 on c1.CUST_SEX =s1.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='AGE') a1 on c1.CERT_AGE =a1.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='MANU_NAME') m1 on c1.MANU_NAME =m1.CODE
         |	left join
         |	(select * from ads.ADIC_ONE_HOT where `TYPE`='MANU_NAME') m2 on m1.CODE =m2.CODE
         |	where TARGET_MONTH='${p1month}'
         |	and CANCELMARK ='${cancel2Int8}'
         |	--where DEVICE_NUMBER ='13001056668' order by SPID
         |	--LIMIT 500
         |) s group by USERID,SPID
         |""".stripMargin+""
    print(sql2)
    //执行2
    RunClickhouseSQL(sql2);
    0
  }
  ///【废弃】生成退订分析多维表
  def zt_tag_cancel_fin(month:String,isInsert:Boolean=false):Int ={
    var sql:String=""
    sql=sql+
      s"""
         |insert into ads.FIN_ALS_XXH_ORDER_RESULT
         |SELECT
         |    TARGET_MONTH,concat(toString(CANCEL_P*5),'-',toString(if((CANCEL_P+1)*5>=100,100,(CANCEL_P+1)*5)),'%') as CANCEL_P1,
         |    CANCEL_P*5 as CANCEL_P_ORDER,
         |    PROVINCE,SPNAME,CPNAME,CHANNEL_NAME,
         |     COUNT(USERID) AS USER_COUNT,
         |     SUM(WILL_CANCEL) AS WILL_CANCEL_COUNT,
         |     SUM(CANCELMARK) AS CANCEL_COUNT
         |  from
         |  (
         |	  select TARGET_MONTH,USERID,CANCEL_P,PROVINCE,CHANNEL,
         |	  c.SPID as SPID,CANCELMARK,sp.SPNAME as SPNAME,sp.CPNAME as CPNAME,ch.NAME as CHANNEL_NAME,
         |	  if(CANCEL_P>=3,1,0) as  WILL_CANCEL,CANCELMARK
         |	  from
         |	  (
         |		  select DISTINCT a.TARGET_MONTH as TARGET_MONTH,a.USERID as USERID,intDiv(CANCEL_P*100,5)  as CANCEL_P,
         |		  PROVINCE,CHANNEL,a.SPID as SPID,h.CANCELMARK as CANCELMARK
         |		  from
         |		  (
         |			  select *,toUInt32(if(like(TARGET_MONTH,'%12'),
         |			  toString(toInt32(TARGET_MONTH)+89),toString(toInt32(TARGET_MONTH)+1))) as THEMONTH2
         |			  from ads.ALS_XXH_ORDER_RESULT where TARGET_MONTH='${month}'
         |			  --where USERID in ('13057239289','13057239602','13057239752')
         |		  ) a
         |		  left join
         |		  (
         |		  	select *  from  ads.ALS_XXH_ORDER_C1 where TARGET_MONTH='${month}' and CANCELMARK=231
         |		  	 --and USERID in ('13057239289','13057239602','13057239752')
         |		  ) b
         |		  on a.USERID =b.USERID and a.TARGET_MONTH =b.TARGET_MONTH and a.SPID =b.SPID
         |		  left join
         |		  (
         |			select THEMONTH,SPID,USERID,if(CANCELTIME='1970-01-01',0,1) as CANCELMARK from ads.HIS_FLOW_ORDER where THEMONTH in
         |			(select  toUInt32(if(like(TARGET_MONTH,'%12'), toString(toInt32(TARGET_MONTH)+89),toString(toInt32(TARGET_MONTH)+1))) as TARGET_MONTH
         |			from ( select  DISTINCT TARGET_MONTH from  ads.ALS_XXH_ORDER_C1 where TARGET_MONTH='${month}'))
         |			--and USERID in ('13057239289','13057239602','13057239752')
         | 		  ) h on a.THEMONTH2=h.THEMONTH and a.USERID=h.USERID and a.SPID=h.SPID
         |		  --('13057239289','13057239602','13057239752')
         |	  ) c
         |	  left join  ads.ETL_V_TB_SP_INFO sp on c.SPID=sp.SPID
         |	  left join ads.DIM_TB_CHANNELS ch on c.CHANNEL=ch.ID
         |  ) s
         | GROUP BY TARGET_MONTH,CANCEL_P,PROVINCE,SPNAME,CPNAME,CHANNEL_NAME
         |""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }
  ///【废弃】生成退订预测标签
  def zt_tag_cancel(month:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    var sql:String=""

    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_ORDER_CANCEL ENGINE = MergeTree PARTITION BY THEMONTH_CEL ORDER BY USERID_CEL  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_ORDER_CANCEL
          |""".stripMargin
    }

    sql=sql+
      s"""
         |select '${month}' as THEMONTH_CEL, USERID as USERID_CEL,
         |(case when CANCEL_P>=0.15 then 'C100_01_001'
         |when  CANCEL_P<0.15 then 'C100_01_002'
         |else 'C100_01_003'
         | end) ALS_CANCEL,
         | (case when CANCEL_P>=0.15 then '${maptags.get("C100_01_001").get}'
         | when  CANCEL_P<0.15 then '${maptags.get("C100_01_002").get}'
         | else '${maptags.get("C100_01_003").get}'
         |  end) ALS_CANCEL_C,CANCEL_P as ALS_CANCEL_V
         |from
         |(
         |	select any(TARGET_MONTH) as TARGET_MONTH, USERID ,avg(CANCEL_P) as CANCEL_P
         |	from
         |	(select * from ads.ALS_XXH_ORDER_RESULT where TARGET_MONTH ='${month}' ) q
         |	group by USERID
         |)
         |""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  ///【废弃】生成快手预测标签
  def zt_tag_kuaishou(month:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    var sql:String=""

    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_ORDER_KUAISHOU ENGINE = MergeTree PARTITION BY THEMONTH_KS ORDER BY USERID_KS  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_ORDER_KUAISHOU
          |""".stripMargin
    }

    sql=sql+
      s"""
         |select '${month}' as THEMONTH_KS, DEVICE_NUMBER as USERID_KS,
         |(case when IS_ORDER=2 then 'C100_02_001'
         |when  IS_ORDER=1 then 'C100_02_002'
         |else 'C100_02_003'
         | end) ALS_ORDER_KUAISHOU,
         | (case when IS_ORDER=2 then '${maptags.get("C100_02_001").get}'
         | when  IS_ORDER=1 then '${maptags.get("C100_02_002").get}'
         | else '${maptags.get("C100_02_003").get}'
         |  end) ALS_ORDER_KUAISHOU_C,PREDPROB2 as ALS_ORDER_KUAISHOU_V
         |from ads.XXH_KUAISHOU_YUCEJI_RESULT
         |where MONTH_ID ='${month}'
         |""".stripMargin;
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  //参与活动标签
  def zt_tag_C_activity_join_All(): Unit ={
    zt_tag_C_activity_join("202102")
    zt_tag_C_activity_join("202103",isInsert = true)
    zt_tag_C_activity_join("202104",isInsert = true)
    zt_tag_C_activity_join("202105",isInsert = true)
    zt_tag_C_activity_join("202106",isInsert = true)
    zt_tag_C_activity_join("202107",isInsert = true)
    zt_tag_C_activity_join("202108",isInsert = true)
    zt_tag_C_activity_join("202109",isInsert = true)
    zt_tag_C_activity_join("202110",isInsert = true)
  }
  ///生成参与活动标签
  def zt_tag_C_activity_join(month:String,isInsert:Boolean=false):Int ={
    val maptags: Map[String, String]=get_alltags()
    val dateStr:String= month.substring(0,4)+"-"+month.substring(4)+"-01"
    val dateStrAdd1=DateUtils.getNMonth(dateStr, 1,"yyyy-MM-dd")
    var sql:String=""
    if(isInsert==false){
      sql=sql+
        """
          |create table ads.ZT_USER_ACTIVITY_JOIN ENGINE = MergeTree PARTITION BY THEMONTH_ACT ORDER BY USERID_ACT  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.ZT_USER_ACTIVITY_JOIN
          |""".stripMargin
    }

    sql=sql+
      s"""select '${month}' as THEMONTH_ACT,MEMBER_PHONE as USERID_ACT,"""

    sql=sql+GenSelectTagSql_C("参与活动","title",field_value = "ACTIVITY_UUID")+"";
    sql=sql+
      s"""
         |from
         |(
         |select ACTIVITY_UUID,MEMBER_PHONE,title from ads.ACTIVITY_MEMBER_JOIN_RECORD r
         |inner join ads.DIC_BLADE_ACTIVITY a on r.ACTIVITY_UUID =a.activity_uuid
         |where r.CREATE_TIME>='${dateStr}' and   r.CREATE_TIME<'${dateStrAdd1}'
         |and  match(MEMBER_PHONE,'\\d{11}')
         |)
         |""".stripMargin+""
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }

  //生成宽表 【按1 2 3 顺序来执行】
  def z_user_tag_JOIN_All(): Unit ={
//    z_user_tag_JOIN_sp_New("202112",isInsert = false)
//    z_user_tag_JOIN_sp_New("202001",isInsert = true)
//    z_user_tag_JOIN_sp_New("202002",isInsert = true)
//    z_user_tag_JOIN_sp_New("202003",isInsert = true)
//    z_user_tag_JOIN_sp_New("202004",isInsert = true)
//    z_user_tag_JOIN_sp_New("202005",isInsert = true)
//    z_user_tag_JOIN_sp_New("202006",isInsert = true)
//    z_user_tag_JOIN_sp_New("202007",isInsert = true)
//    z_user_tag_JOIN_sp_New("202008",isInsert = true)
//    z_user_tag_JOIN_sp_New("202009",isInsert = true)
//    z_user_tag_JOIN_sp_New("202010",isInsert = true)
//    z_user_tag_JOIN_sp_New("202011",isInsert = true)
//    z_user_tag_JOIN_sp_New("202012",isInsert = true)
//
//    z_user_tag_JOIN_sp_New("202101",isInsert = true)
//    z_user_tag_JOIN_sp_New("202102",isInsert = true)
//    z_user_tag_JOIN_sp_New("202103",isInsert = true)
//    z_user_tag_JOIN_sp_New("202104",isInsert = true)
//    z_user_tag_JOIN_sp_New("202105",isInsert = true)
//    z_user_tag_JOIN_sp_New("202106",isInsert = true)
//    z_user_tag_JOIN_sp_New("202107",isInsert = true)
//    z_user_tag_JOIN_sp_New("202108",isInsert = true)
//    z_user_tag_JOIN_sp_New("202109",isInsert = true)
    z_user_tag_JOIN_sp_New("202110",isInsert = true)
    z_user_tag_JOIN_sp_New("202111",isInsert = true)

    z_user_tag_JOIN_sp_New("202201",isInsert = true)
    z_user_tag_JOIN_sp_New("202202",isInsert = true)
    z_user_tag_JOIN_sp_New("202203",isInsert = true)
  }
  //生成单月宽表【】【】【】
  def z_user_tag_JOIN_All(month:String="",isInsert:Boolean=true, temp_tableName:String="Z_USER_TAG_FLAT_temp",clu_tableName:String="Z_USER_TAG_FLAT_clu1",isUpdateSchema:Boolean=false ): Unit ={
    //【1】分批插入单月数据 dao temp表
    z_user_tag_JOIN_sp_New(month=month,temp_tableName=temp_tableName,isInsert=isInsert)

    if(isUpdateSchema==true){
      //【2】根据最新的本地temp缓存表  和 clu线上表进行动态对比，更新成最新的列
      z_user_tag_update_Clu(temp_tableName=temp_tableName,clu_tableName=clu_tableName)
    }

    //【3】从temp表 插入到 视图Z_USER_TAG_FLAT_ALL
    z_user_tag_Insert_cluALL(month=month,temp_tableName=temp_tableName,clu_tableName=clu_tableName)
  }
  ///【1】分批插入单月数据  step 用户步长
  def z_user_tag_JOIN_sp_New(month:String="",isInsert:Boolean=true,temp_tableName:String="Z_USER_TAG_FLAT_temp")={
    //    //先删掉月份分区
    //    RunClickhouseSQL(s"alter TABLE ads.Z_USER_TAG_FLAT_clu on cluster cluster_3s_1r drop partition '${month}'");
    //    //等待20秒
    //    Thread.sleep(20000)

    val rtSet:SortedSet[String]= get_runtagUserIds(30000000)
    val rtList:List[String]= rtSet.toList
    var mark:Boolean=true
    print("list:" + rtSet)
    for( idx <- 1 to  rtList.length-1){
      //左侧号码
      val lStr:String=rtList.apply(idx-1)
      //右侧号码
      val rStr:String=rtList.apply(idx)
      println(lStr.concat("-").concat(rStr))

      //如果是新建表，且第一次进入循环  create
      if(mark==true&&isInsert==false){
        z_user_tag_JOIN_Dynamic(month,uid_l=lStr,uid_r=rStr)
        mark=false
      }else{
        z_user_tag_JOIN_Dynamic(month,uid_l=lStr,uid_r=rStr,isInsert = true);
      }
    }


  }
  //动态生成合并标签(动态根据CFG_ZT_TAG_JOIN先生成本地temp缓存表)
  def z_user_tag_JOIN_Dynamic(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="",temp_tableName:String="Z_USER_TAG_FLAT_temp")={
    var creat_sql:String=""
    if(isInsert==false){

      RunClickhouseSQL(s"drop table if exists  ads.${temp_tableName} ");
      Thread.sleep(8000)
      //ads.Z_USER_TAG
      creat_sql=creat_sql+
        s"""
          |create table ads.${temp_tableName}  ENGINE = MergeTree PARTITION BY THEMONTH_V ORDER BY USERID_V  as
          |""".stripMargin
    }else{
      creat_sql=creat_sql+
        s"""
          |insert into ads.${temp_tableName}
          |""".stripMargin
    }

    var sql:String="select TABLE_NAME,JOINSTR,JOIN_TABLE from  ads.CFG_ZT_TAG_JOIN order by id "
    //    val lrSql_USERID = if (uid_l =="") "" else s" and  USERID>='${uid_l}' and USERID<'${uid_r}'"
    var field_sql:String=" "
    var runSQL:String=" from "
    var userStr_sql:String=" multiIf("
    var joinList= ExecClickhouseSQL(sql)
    //存储表 对应的月份和userID字段名称
    var table_months = new util.HashMap[String, ZT_Table_IDs]()
    for( idx <- 0 to  joinList.size()-1) {
      val row= joinList.get(idx)
      val table_name=row.get("TABLE_NAME").toString

      var sql_table:String="desc ads."+table_name
      var list_cols= ExecClickhouseSQL(sql_table)
      //找到这个表对应的月份字段名 和 userid字段名
      var zt:ZT_Table_IDs=new ZT_Table_IDs
      //"表中包含的字段"
      var cols:String="";
      breakable {
        for (i <- 0 to list_cols.size()-1) {
          val row_cols = list_cols.get(i)
          val name: String = row_cols.get("name").toString
          if ((name.contains("USERID") || name.contains("DEVICE_NUMBER"))&&zt.userId=="") {
            zt.userId = name
          }
          else if ((name.contains("MONTH"))&&zt.monthId=="") {
            zt.monthId = name
          }
          else  {
            cols=cols+"`"+name+"`,"
          }
        }
      }
      //cols= cols.substring(0,cols.length-1)
      zt.cols=cols
      //
      table_months.put(table_name,zt)
    }
    //生成拼接sql
    for( j <- 0 to  joinList.size()-1) {
      val row= joinList.get(j)
      val table_name=row.get("TABLE_NAME").toString
      var joinStr=row.get("JOINSTR").toString
      if(joinStr!=""){
        joinStr=joinStr+" JOIN "
      }
      val join_table=row.get("JOIN_TABLE").toString
      val zt= table_months.get(table_name)
      var on_SQL=""
      val month_SQL = if (zt.monthId =="") " 1=1 " else s" ${zt.monthId} ='${month}'"
      if(join_table!=""){
        on_SQL=s" on t_${join_table}.${ table_months.get(join_table).userId}=t_${table_name}.${zt.userId}  "
      }
      runSQL=runSQL+
        s"""
           | ${joinStr} (select * from ads.${table_name} where ${month_SQL}  and  ${zt.userId}>='${uid_l}' and ${zt.userId}<'${uid_r}') t_${table_name} ${on_SQL}
           |""".stripMargin

      //userid_str
      userStr_sql=userStr_sql+s"${zt.userId}!='',${zt.userId},"
      //字段
//      if(j==0){
//        field_sql=field_sql+zt.monthId+" as THEMONTH_V,"+zt.userId+" as USERID_V,"+zt.cols
//      }else{
        field_sql=field_sql+zt.cols
      //}
    }
    field_sql= field_sql.substring(0,field_sql.length-1)
    field_sql=s"select '${month}' as THEMONTH_V,"+userStr_sql+"'') as USERID_V,"+field_sql
    runSQL=creat_sql+field_sql+runSQL
    print(runSQL)
    RunClickhouseSQL(runSQL)

  }
  //【2】根据最新的本地temp缓存表  和 clu线上表进行动态对比，更新成最新的列
  def z_user_tag_update_Clu(temp_tableName:String="Z_USER_TAG_FLAT_temp",clu_tableName:String="Z_USER_TAG_FLAT_clu1"): Unit ={
    //查找 在用宽表 和最新合并的temp的不同
    var sql:String=
      s"""
         |select temp.name as temp_name,temp.type as tp,clu.name as clu_name from
         |(
         |	select name,`type`
         |	from  system.columns
         |	where `table`='${temp_tableName}'
         |) temp
         |full outer join
         |(
         |	select name,`type`
         |	from  system.columns
         |	where `table`='${clu_tableName}'
         |) clu
         |on temp.name=clu.name
         |""".stripMargin
    val list = ExecClickhouseSQL(sql)
    //结束的col
    var after_tempCol:String=null
    var after_cluCol:String=null
    //【0】生成 list update
    var listUpdate=new  util.ArrayList[FlatListUpdate]
    var flatListUpdate=new FlatListUpdate()
    for( idx <- 0 to  list.size()-1) {
      val row = list.get(idx)
      val temp_name = row.get("temp_name").toString
      val tp = row.get("tp").toString
      val clu_name = row.get("clu_name").toString

      //如果线上缺少这个列 就记录下来
      if(clu_name=="") {
        //如果上一个不是空，说明上一个是after row
        if(after_cluCol!=""){
          flatListUpdate=new FlatListUpdate()
          flatListUpdate.after_col=after_tempCol
          var map=new util.HashMap[String, String]()
          map.put("temp_name",temp_name)
          map.put("tp",tp)
          flatListUpdate.list_allUpdate.add(map)
        }
        else{
          var map=new util.HashMap[String, String]()
          map.put("temp_name",temp_name)
          map.put("tp",tp)
          flatListUpdate.list_allUpdate.add(map)
        }

        //如果是最后一个 且 clu_name是空
        if(idx==list.size()-1){
          listUpdate.add(flatListUpdate)
        }
      }
      else{
        if(after_cluCol!=""){
          //do 呐thing
        }else{
          listUpdate.add(flatListUpdate)
        }
      }
      after_tempCol=temp_name
      after_cluCol=clu_name
    }


    //【2】生成更新的sql
    var sqlUpdate:String=""
    if(listUpdate.size()>0){
      //【1】drop 视图
      val sqlDrop_View=
        s"""
           |drop table ads.Z_USER_TAG_FLAT_ALL ON cluster cluster_3s_1r
           |""".stripMargin
      print(sqlDrop_View)
      RunClickhouseSQL(sqlDrop_View)
      Thread.sleep(8000)

      for( idx <- 0 to  listUpdate.size()-1) {
        val lOne = listUpdate.get(idx)

        var l = lOne.list_allUpdate.size()-1
        // while 循环执行
        while (l >=0) {
          print(l)
          val rOne = lOne.list_allUpdate.get(l)
          var sqlUpdate=
            s"""
               |ALTER TABLE ads.${clu_tableName} ON cluster cluster_3s_1r  add COLUMN `${rOne.get("temp_name").toString}` ${rOne.get("tp").toString}
               |after `${lOne.after_col}`
               |""".stripMargin
          print(sqlUpdate)
          Thread.sleep(8000)
          //更新表结构
          RunClickhouseSQL(sqlUpdate)
          l = l - 1
        }
      }

      //【3】再创建 视图
      val sqlCreat_View=
        s"""
           |CREATE TABLE ads.Z_USER_TAG_FLAT_ALL ON cluster cluster_3s_1r AS ads.${clu_tableName}
           |ENGINE = Distributed(cluster_3s_1r, ads, ${clu_tableName}, rand())
           |""".stripMargin
      print(sqlCreat_View)
      RunClickhouseSQL(sqlCreat_View)
      Thread.sleep(8000)
    }
  }
  //【3】从temp表 插入到 视图Z_USER_TAG_FLAT_ALL
  def z_user_tag_Insert_cluALL(month:String,temp_tableName:String="Z_USER_TAG_FLAT_temp",clu_tableName:String="Z_USER_TAG_FLAT_clu1"): Unit = {
    //【1】drop partition
    val sqlDrop_View=
      s"""
         |alter table ads.${clu_tableName} on cluster cluster_3s_1r drop partition '${month}'
         |""".stripMargin
    print(sqlDrop_View)
    RunClickhouseSQL(sqlDrop_View)
    Thread.sleep(8000)

    var sql:String=
      s"""
         |	select name
         |	from  system.columns
         |	where `table`='Z_USER_TAG_FLAT_ALL'
         |""".stripMargin
    val list = ExecClickhouseSQL(sql)

    var insert_sql:String="INSERT INTO ads.Z_USER_TAG_FLAT_ALL select "
    for( i <- 0 to  list.size()-1) {
      val row = list.get(i)
      val name = row.get("name").toString

      insert_sql=insert_sql+"`"+name+"`,"
      //特殊处理
      //投诉次数0次暂时不要  省份在生成long表时处理，地区原ZT表数据无空值   其他不强行作为未知
    }
    insert_sql= insert_sql.substring(0,insert_sql.length-1)
    insert_sql=insert_sql+s" from ads.${temp_tableName} where THEMONTH_V='${month}'"

    print(insert_sql)
    RunClickhouseSQL(insert_sql)
  }


  //合并大网标签【快过时了】
  def z_user_tag_JOIN(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="")={
    var sql:String=""
    if(isInsert==false){
      //ads.Z_USER_TAG
      sql=sql+
        """
          |create table ads.Z_USER_TAG_FLAT_temp  ENGINE = MergeTree PARTITION BY THEMONTH_V ORDER BY USERID_V  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.Z_USER_TAG_FLAT_temp
          |""".stripMargin
    }

    val lrSql_USERID = if (uid_l =="") "" else s" and  USERID>='${uid_l}' and USERID<'${uid_r}'"
    val lrSql_NUMBER_XXH_L = if (uid_l =="") "" else s" and  DEVICE_NUMBER_XXH_L>='${uid_l}' and DEVICE_NUMBER_XXH_L<'${uid_r}'"
    val lrSql_USERID_OS = if (uid_l =="") "" else s" and  USERID_OS>='${uid_l}' and USERID_OS<'${uid_r}'"
    //val lrSql_USERID_C_D = if (uid_l =="") "" else s" and  USERID_C_D>='${uid_l}' and USERID_C_D<'${uid_r}'"
    val lrSql_DEVICE_NUMBER = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    val lrSql_DEVICE_NUMBER_APP = if (uid_l =="") "" else s" and  DEVICE_NUMBER_APP>='${uid_l}' and DEVICE_NUMBER_APP<'${uid_r}'"
    val lrSql_USERID_BL = if (uid_l =="") "" else s" and  USERID_BL>='${uid_l}' and USERID_BL<'${uid_r}'"
    val lrSql_USERID_CEL = if (uid_l =="") "" else s" and  USERID_CEL>='${uid_l}' and USERID_CEL<'${uid_r}'"
    val lrSql_USERID_KS = if (uid_l =="") "" else s" and  USERID_KS>='${uid_l}' and USERID_KS<'${uid_r}'"
    val lrSql_USERID_ACT = if (uid_l =="") "" else s" and  USERID_ACT>='${uid_l}' and USERID_ACT<'${uid_r}'"
    //val lrSql_USERID_UN = if (uid_l =="") "" else s" and  USERID_UN>='${uid_l}' and USERID_UN<'${uid_r}'"
    val lrSql_USERID_COMPLAIN = if (uid_l =="") "" else s" and  USERID_COMPLAIN>='${uid_l}' and USERID_COMPLAIN<'${uid_r}'"
    val lrSql_USERID_PREF = if (uid_l =="") "" else s" and  USERID_APP_PREF>='${uid_l}' and USERID_APP_PREF<'${uid_r}'"

    //--multiIf(USERID!='',THEMONTH, DEVICE_NUMBER!='', MONTH_ID, DEVICE_NUMBER_APP!='', MONTH_ID_APP, '') AS THEMONTH_V,
    //--multiIf(USERID!='',USERID, DEVICE_NUMBER!='', DEVICE_NUMBER, DEVICE_NUMBER_APP!='', DEVICE_NUMBER_APP, '') AS USERID_V,
    /**
     * select
        if(USERID_V8!='',THEMONTH_V8,THEMONTH_UN) AS THEMONTH_V,
        if(USERID_V8!='',USERID_V8,USERID_UN) AS USERID_V,
     * from
        ( --g9
     */
    sql=sql+
      s"""
         |select
         |if(USERID_V7!='',THEMONTH_V7,THEMONTH_COMPLAIN) AS THEMONTH_V,
         |if(USERID_V7!='',USERID_V7,USERID_COMPLAIN) AS USERID_V,
         |* from
         |( --g8
         |select
         |if(USERID_V1!='',THEMONTH_V1,THEMONTH_ACT) AS THEMONTH_V7,
         |if(USERID_V1!='',USERID_V1,USERID_ACT) AS USERID_V7,
         |* from
         |( --g7
         |select * from ( -- g6
         |select * from (
         |select * from (
         |select * from (
         |select
         |if(USERID!='',THEMONTH,MONTH_ID) AS THEMONTH_V1,
         |if(USERID!='',USERID,DEVICE_NUMBER) AS USERID_V1,
         |* from
         |(
         |   select
         |		if(THEMONTH!='',THEMONTH,THEMONTH_OS) AS THEMONTH,
         |		if(USERID!='',USERID,USERID_OS) AS USERID,
         |		* from
         |		(select * from ads.ZT_USER_TAG_ORDER where THEMONTH ='${month}' ${lrSql_USERID}) s11
         |		FULL OUTER JOIN  (select * from ads.ZT_USER_TAG_ORDER_SUMDATE where THEMONTH_OS ='${month}' ${lrSql_USERID_OS}) s12
         |		on s11.USERID=s12.USERID_OS
         |) g2
         |FULL OUTER JOIN
         |(
         |	select * from
         |	(
         |   select * from (
         |	    select
         |	    * from
         |	    (select * from ads.ZT_USER_TAG_XXH where MONTH_ID ='${month}'  ${lrSql_DEVICE_NUMBER}) s00
         |     left join
		    |   	(select * from ads.ZT_USER_TAG_XXH_LONG where 1=1 ${lrSql_NUMBER_XXH_L}) s001 on s00.DEVICE_NUMBER=s001.DEVICE_NUMBER_XXH_L
         |   ) s01
         |	  left join
         |	  (select * from ads.ZT_USER_TAG_XXH_APP where MONTH_ID_APP ='${month}'  ${lrSql_DEVICE_NUMBER_APP}) s02 on s01.DEVICE_NUMBER=s02.DEVICE_NUMBER_APP
         | ) xxh1
         | 	left join
         |	(select * from ads.ZT_USER_APP_PREFERENCE where THEMONTH_APP_PREF ='${month}' ${lrSql_USERID_PREF}) xxh2 on xxh1.DEVICE_NUMBER=xxh2.USERID_APP_PREF
         |) s12  on g2.USERID=s12.DEVICE_NUMBER
         |) g3
         |left join
         |(select * from ads.ZT_USER_ORDER_STATE  where THEMONTH_BL ='${month}' ${lrSql_USERID_BL}) o1
         |on g3.USERID_V1=o1.USERID_BL
         |)g4
         |left join ads.ZT_USER_RFM r1
         |on g4.USERID_V1=r1.USERID_RFM
         |) g5
         |left join (select * from  ads.ZT_ORDER_CANCEL  where THEMONTH_CEL ='${month}' ${lrSql_USERID_CEL})  cel1
         |on g5.USERID_V1=cel1.USERID_CEL
         |) g6
         |left join (select * from ads.ZT_ORDER_KUAISHOU where THEMONTH_KS ='${month}' ${lrSql_USERID_KS}) ks
         |on g6.USERID_V1=ks.USERID_KS
         |) g7
         |FULL OUTER JOIN  (select * from ads.ZT_USER_ACTIVITY_JOIN where THEMONTH_ACT ='${month}'  ${lrSql_USERID_ACT}) act
         |on g7.USERID_V1=act.USERID_ACT
         |) g8
         |FULL OUTER JOIN  (select * from ads.ZT_USER_COMPLAIN where THEMONTH_COMPLAIN ='${month}'  ${lrSql_USERID_COMPLAIN}) complain
         |on g8.USERID_V7=complain.USERID_COMPLAIN
         |""".stripMargin
    /**
     * )g9
      FULL OUTER JOIN  (select * from ads.ZT_USER_UN_ORDER where THEMONTH_UN ='${month}'  ${lrSql_USERID_UN}) unorder
      on g9.USERID_V8=unorder.USERID_UN
     */
    print(sql)
    //RunClickhouseSQL(sql);
  }
  //根据 临时数据表创建 大宽表（主要排除一些冗余字段）【快过时了】
  def create_tag_FLAT(islast:Boolean=false): Unit ={
    val chSt: Statement = ClickhouseConnect.conn().createStatement
    var tempTable="Z_USER_TAG_FLAT_temp"
    if(islast==true){
      tempTable="Z_USER_TAG_LAST_temp"
    }
    var sql:String=
      s"""
         |select name,`type`
         |from  system.columns
         |where `table`='${tempTable}'
         |""".stripMargin
    val res: ResultSet = chSt.executeQuery(sql)

    var strTable="ads.Z_USER_TAG_FLAT_clu"
    var str1= ""
    if(islast==true){
      strTable="ads.Z_USER_TAG_LAST_clu"
      str1="THEMONTH_LAST String,"
    }

    var sql2:String=s"create table ${strTable} on cluster cluster_3s_1r (${str1} `THEMONTH_V` String,  `USERID_V` String,"
    var idx=1
    while (res.next) {
      var name= res.getString("name")
      var tp= res.getString("type")

      if(name.contains("USERID") || name.contains("THEMONTH") ||name.contains("MONTH_ID") ||name.contains("DEVICE_NUMBER")||name.contains("cTime"))
      {
      }
      else{
        sql2=sql2+s"`${name}` ${tp},"
      }
      idx=idx+1
    }

    sql2= sql2.substring(0,sql2.length-1)
    sql2=sql2+" ) ENGINE = MergeTree PARTITION BY THEMONTH_V ORDER BY USERID_V ";
    print(sql2)
    RunClickhouseSQL(sql);

    chSt.close()
  }
  //将本地临时表的数据  直接 插入all视图(较慢)【快过时了】
  def temp_Insert_to_FLAT(islast:Boolean=false): Unit ={
    val chSt: Statement = ClickhouseConnect.conn().createStatement
    var tempTable="Z_USER_TAG_FLAT_temp"
    if(islast==true){
      tempTable="Z_USER_TAG_LAST_temp"
    }
    var sql:String=
      s"""
         |select name,`type`
         |from  system.columns
         |where `table`='${tempTable}'
         |""".stripMargin
    val res: ResultSet = chSt.executeQuery(sql)

    var strTable="ads.Z_USER_TAG_FLAT_ALL"
    if(islast==true){
      strTable="ads.Z_USER_TAG_LAST_ALL"
    }
    var str1=""
    if(islast==true){
      str1="THEMONTH_LAST,"
    }

    var sql2:String=s"insert into  ${strTable} with"
    sql2 = sql2 + GenSelectTagSql_C("省份","b.PROVINCE", clu_name="TMP_PROVINCE");
    sql2 = sql2 + "," + GenSelectTagSql_C("城市","b.AREA", clu_name="TMP_AREA");
    sql2 = sql2 + s" \nselect ${str1} THEMONTH_V,USERID_V,";
    var idx=1
    while (res.next) {
      var name= res.getString("name")
      var tp= res.getString("type")

      if(name.contains("USERID") || name.contains("THEMONTH") ||name.contains("MONTH_ID") ||name.contains("DEVICE_NUMBER")||name.contains("cTime"))
      {
      }
      else {
        //特殊处理 【1、投诉次数】
        if (name.contains("TAG_COMPLAIN")) {
          if (name.endsWith("_C")) {
            sql2 = sql2 + s"ifNull(${name},'0次') as `${name}`,"
          } else if (name.endsWith("_V")) {
            sql2 = sql2 + s"`${name}`,"
          } else {
            sql2 = sql2 + s"ifNull(${name},'B112_22_001') as `${name}`,"
          }
        }
        //省份处理
          else if(name.contains("TAG_PROVINCE")){
            if (name.endsWith("_C")) {
              sql2 = sql2 + s"if(${name}='',TMP_PROVINCE_C,${name}) as `${name}`,"
            } else if (name.endsWith("_V")) {
              sql2 = sql2 + s"`TAG_PROVINCE_C` as `${name}`,"
            } else {
              sql2 = sql2 + s"if(${name}='',TMP_PROVINCE,${name}) as `${name}`,"
            }
          }else if(name.contains("TAG_AREA")){//城市处理
            if (name.endsWith("_C")) {
              sql2 = sql2 + s"if(${name}='',TMP_AREA_C,${name}) as `${name}`,"
            } else if (name.endsWith("_V")) {
              sql2 = sql2 + s"`TMP_AREA_C` as `${name}`,"
            } else {
              sql2 = sql2 + s"if(${name}='',TMP_AREA,${name}) as `${name}`,"
            }
        }
        //类别 中文
        if(name.endsWith("_C") || name.endsWith(".C")){
          if(tp.contains("Nullable")){
            sql2=sql2+s"ifNull(${name},'未知') as `${name}`,"
          }
          else if(tp.contains("Array")){
            sql2=sql2+s"`${name}`,"
          }
          else {
            sql2=sql2+s"if(${name}='','未知',${name}) as `${name}`,"
          }
        }
        //值
        else if (name.endsWith("_V") || name.endsWith(".V")){
          sql2=sql2+s"`${name}`,"
        }
        //标签
        else{
          if(tp.contains("Nullable")){
            sql2=sql2+s"ifNull(${name},'AAA') as `${name}`,"
          }
          else if(tp.contains("Array")){
            sql2=sql2+s"`${name}`,"
          }
          else {
            sql2=sql2+s"if(${name}='','AAA',${name}) as `${name}`,"
          }
        }
        sql2 = sql2 + s"\n"
      }
      idx=idx+1
    }

    sql2= sql2.substring(0,sql2.length-2)
    sql2=sql2+s" from ads.${tempTable} a left join ETL_VW_TB_CALLER_AREACODE b on substring(a.USERID_V , 1, 7) = b.CALLERHEAD";
    print(sql2)
    RunClickhouseSQL(sql2);

    chSt.close()
  }


  ///【废弃】分批插入单月数据
  def z_user_tag_JOIN_sp(month:String="",isInsert:Boolean=true)={
    //    //先删掉月份分区
    //    RunClickhouseSQL(s"alter TABLE ads.Z_USER_TAG_FLAT_clu on cluster cluster_3s_1r drop partition '${month}'");
    //    //等待20秒
    //    Thread.sleep(20000)


    if(isInsert==false){
      z_user_tag_JOIN(month,uid_l="0",uid_r="1305")
    }
    else{
      z_user_tag_JOIN(month,uid_l="0",uid_r="1305",isInsert = true)
    }

    z_user_tag_JOIN(month,uid_l="1305",uid_r="131",isInsert = true);
    z_user_tag_JOIN(month,uid_l="131",uid_r="1315",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1315",uid_r="132",isInsert = true);
    z_user_tag_JOIN(month,uid_l="132",uid_r="1326",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1326",uid_r="150",isInsert = true);
    z_user_tag_JOIN(month,uid_l="150",uid_r="1554",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1554",uid_r="156",isInsert = true);
    z_user_tag_JOIN(month,uid_l="156",uid_r="1565",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1565",uid_r="166",isInsert = true);
    z_user_tag_JOIN(month,uid_l="166",uid_r="175",isInsert = true);
    z_user_tag_JOIN(month,uid_l="175",uid_r="1762",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1762",uid_r="1768",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1768",uid_r="1853",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1853",uid_r="1858",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1858",uid_r="1862",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1862",uid_r="1865",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1865",uid_r="1868",isInsert = true);
    z_user_tag_JOIN(month,uid_l="1868",uid_r="9999",isInsert = true);
  }
  //【废弃】生成去重标签表
  def z_user_tag_JOIN_LAST_sp(month:String)={
    //RunClickhouseSQL(s"truncate table ads.Z_USER_TAG_LAST_clu1 on cluster cluster_3s_1r ");

    z_user_tag_JOIN_LAST(month,uid_l="0",uid_r="131")
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="131",uid_r="132");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="132",uid_r="150");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="150",uid_r="156");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="156",uid_r="166");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="166",uid_r="176");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="176",uid_r="1768");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="1768",uid_r="1855");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="1855",uid_r="186");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="186",uid_r="1865");
    z_user_tag_JOIN_LAST(month,isInsert=true,uid_l="1865",uid_r="9999");

    //插入all表
    //RunClickhouseSQL(s"insert into ads.Z_USER_TAG_LAST_ALL select * from ads.Z_USER_TAG_LAST_temp");
  }
  ///【废弃】生成去重标签表 step 用户步长
  def z_user_tag_JOIN_LAST_sp_New(month:String="",isInsert:Boolean=true)={
    //    //等待20秒
    //    Thread.sleep(20000)

    val rtSet:SortedSet[String]= get_runtagUserIds(2000000)
    val rtList:List[String]= rtSet.toList
    var mark:Boolean=true
    for( idx <- 1 to  rtList.length-1){
      //左侧号码
      val lStr:String=rtList.apply(idx-1)
      //右侧号码
      val rStr:String=rtList.apply(idx)
      println(lStr.concat("-").concat(rStr))

      //如果是新建表，且第一次进入循环  create
      if(mark==true&&isInsert==false){
        z_user_tag_JOIN_LAST(month,uid_l=lStr,uid_r=rStr)
        mark=false
      }else{
        z_user_tag_JOIN_LAST(month,uid_l=lStr,uid_r=rStr,isInsert = true);
      }
    }


  }
  ///【废弃】
  def z_user_tag_JOIN_LAST(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="")={
    var sql:String=""
    if(isInsert==false){
      RunClickhouseSQL(s"drop table if exists  ads.Z_USER_TAG_LAST_temp");
      sql=sql+
        """
          | create table ads.Z_USER_TAG_LAST_temp  ENGINE = MergeTree PARTITION BY THEMONTH_LAST ORDER BY USERID_V  as
          |""".stripMargin
    }else{
      sql=sql+
        """
          |insert into ads.Z_USER_TAG_LAST_temp
          |""".stripMargin
    }
    val lrSql_USERID = if (uid_l =="") "" else s" and  USERID>='${uid_l}' and USERID<'${uid_r}'"
    val lrSql_NUMBER_XXH_L = if (uid_l =="") "" else s" and  DEVICE_NUMBER_XXH_L>='${uid_l}' and DEVICE_NUMBER_XXH_L<'${uid_r}'"
    val lrSql_USERID_OS = if (uid_l =="") "" else s" and  USERID_OS>='${uid_l}' and USERID_OS<'${uid_r}'"
    val lrSql_DEVICE_NUMBER = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    val lrSql_DEVICE_NUMBER_APP = if (uid_l =="") "" else s" and  DEVICE_NUMBER_APP>='${uid_l}' and DEVICE_NUMBER_APP<'${uid_r}'"
    val lrSql_USERID_BL = if (uid_l =="") "" else s" and  USERID_BL>='${uid_l}' and USERID_BL<'${uid_r}'"
    val lrSql_USERID_CEL = if (uid_l =="") "" else s" and  USERID_CEL>='${uid_l}' and USERID_CEL<'${uid_r}'"
    val lrSql_USERID_KS = if (uid_l =="") "" else s" and  USERID_KS>='${uid_l}' and USERID_KS<'${uid_r}'"
    val lrSql_USERID_ACT = if (uid_l =="") "" else s" and  USERID_ACT>='${uid_l}' and USERID_ACT<'${uid_r}'"
    val lrSql_USERID_UN = if (uid_l =="") "" else s" and  USERID_UN>='${uid_l}' and USERID_UN<'${uid_r}'"
    val lrSql_USERID_COMPLAIN = if (uid_l =="") "" else s" and  USERID_COMPLAIN>='${uid_l}' and USERID_COMPLAIN<'${uid_r}'"
    val lrSql_USERID_PREF = if (uid_l =="") "" else s" and  USERID_APP_PREF>='${uid_l}' and USERID_APP_PREF<'${uid_r}'"

    /**
     * select '${month}' as THEMONTH_LAST,
      if(USERID_V8!='',THEMONTH_V8,THEMONTH_UN) AS THEMONTH_V,
      if(USERID_V8!='',USERID_V8,USERID_UN) AS USERID_V,
     * from
      ( --g9
     */
    sql=sql+
      s"""
         |select
         |if(USERID_V7!='',THEMONTH_V7,THEMONTH_COMPLAIN) AS THEMONTH_V8,
         |if(USERID_V7!='',USERID_V7,USERID_COMPLAIN) AS USERID_V8,
         |* from
         |( --g8
         |select
         |if(USERID_V1!='',THEMONTH_V1,THEMONTH_ACT) AS THEMONTH_V7,
         |if(USERID_V1!='',USERID_V1,USERID_ACT) AS USERID_V7,
         |* from
         |( --g7
         |select * from ( -- g6
         |select * from (
         |select * from (
         |select * from (
         |select
         |if(USERID!='',THEMONTH,MONTH_ID) AS THEMONTH_V1,
         |if(USERID!='',USERID,DEVICE_NUMBER) AS USERID_V1,
         |* from
         |(
         |   select
         |		if(THEMONTH!='',THEMONTH,THEMONTH_OS) AS THEMONTH,
         |		if(USERID!='',USERID,USERID_OS) AS USERID,
         |		* from
         |		(select * from ads.ZT_USER_TAG_ORDER_LAST where 1=1 ${lrSql_USERID}) s11
         |		FULL OUTER JOIN  (select * from ads.ZT_USER_TAG_ORDER_SUMDATE_LAST where 1=1 ${lrSql_USERID_OS}) s12
         |		on s11.USERID=s12.USERID_OS
         |) g2
         |FULL OUTER JOIN
         | (
         |        	select * from
         |        	(
         |           select * from (
         |        	    select
         |        	    * from
         |        	    (select * from ads.ZT_USER_TAG_XXH_LAST where 1=1 ${lrSql_DEVICE_NUMBER}) s00
         |             left join
         |		   	(select * from ads.ZT_USER_TAG_XXH_LONG where 1=1 ${lrSql_NUMBER_XXH_L}) s001 on s00.DEVICE_NUMBER=s001.DEVICE_NUMBER_XXH_L
         |           ) s01
         |        	  left join
         |        	  (select * from ads.ZT_USER_TAG_XXH_APP_LAST where 1=1  ${lrSql_DEVICE_NUMBER_APP}) s02 on s01.DEVICE_NUMBER=s02.DEVICE_NUMBER_APP
         |         ) xxh1
         |         	left join
         |        	(select * from ads.ZT_USER_APP_PREFERENCE_LAST where 1=1 ${lrSql_USERID_PREF}) xxh2 on xxh1.DEVICE_NUMBER=xxh2.USERID_APP_PREF
         |) s12  on g2.USERID=s12.DEVICE_NUMBER
         |
         |) g3
         |left join
         |(select * from ads.ZT_USER_ORDER_STATE_LAST  where 1=1 ${lrSql_USERID_BL}) o1
         |on g3.USERID_V1=o1.USERID_BL
         |)g4
         |left join ads.ZT_USER_RFM_LAST r1
         |on g4.USERID_V1=r1.USERID_RFM
         |) g5
         |left join (select * from  ads.ZT_ORDER_CANCEL_LAST  where 1=1 ${lrSql_USERID_CEL})  cel1
         |on g5.USERID_V1=cel1.USERID_CEL
         |) g6
         |left join (select * from ads.ZT_ORDER_KUAISHOU where 1=1 ${lrSql_USERID_KS}) ks
         |on g6.USERID_V1=ks.USERID_KS
         |
         |) g7
         |FULL OUTER JOIN  (select * from ads.ZT_USER_ACTIVITY_JOIN_LAST where 1=1  ${lrSql_USERID_ACT}) act
         |on g7.USERID_V1=act.USERID_ACT
         |) g8
         |FULL OUTER JOIN  (select * from ads.ZT_USER_COMPLAIN_LAST where 1=1  ${lrSql_USERID_COMPLAIN}) complain
         |on g8.USERID_V7=complain.USERID_COMPLAIN
         |""".stripMargin
    /**
     * )g9
      FULL OUTER JOIN  (select * from ads.ZT_USER_UN_ORDER where THEMONTH_UN ='${month}'  ${lrSql_USERID_UN}) unorder
      on g9.USERID_V8=unorder.USERID_UN
     */
    print(sql)
    RunClickhouseSQL(sql);
  }

  //【废弃】生成去重最后状态表
  def ZT_user_tag_JOIN_ALL_COMMON_sp(monthv1:String, table:String, userid:String,monthid:String): Unit ={
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,uid_l="0",uid_r="131")
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="131",uid_r="132");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="132",uid_r="150");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="150",uid_r="156");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="156",uid_r="166");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="166",uid_r="176");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="176",uid_r="1768");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="1768",uid_r="1855");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="1855",uid_r="186");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="186",uid_r="1865");
    ZT_user_tag_JOIN_ALL_COMMON(monthv1,table,userid,monthid,isInsert=true,uid_l="1865",uid_r="9999");
  }
  //【废弃】生成去重最后状态表
  def ZT_user_tag_JOIN_ALL_COMMON(monthv1:String, table:String, userid:String,monthid:String,isInsert:Boolean=false, uid_l:String="",uid_r:String="")= {
    var sql:String=""

    var lr_UserSQL=if(uid_l=="") "" else s" where ${userid}>='${uid_l}' and ${userid} <'${uid_r}'"
    var lr_UserSQL_s1 =if(uid_l=="") "" else s" where s1.${userid}>='${uid_l}' and s1.${userid} <'${uid_r}'"

    if(isInsert==false){
      RunClickhouseSQL(s"drop table if exists  ads.${table}_LAST");
      sql=sql+
        s"""
           |create table ads.${table}_LAST ENGINE = MergeTree PARTITION BY ${monthid}_V1 ORDER BY ${userid}  as
           |""".stripMargin
    }else{
      sql=sql+
        s"""
           |insert into ads.${table}_LAST
           |""".stripMargin
    }
    sql=sql+
      s"""
         |select '${monthv1}' as ${monthid}_V1,s1.*
         |from ads.${table} s1
         |INNER JOIN
         |(
         |	SELECT ${userid},arrayJoin(${monthid})AS ${monthid}
         |	FROM
         |	(
         |		SELECT ${userid},groupArray(1)(${monthid})AS ${monthid}
         |		FROM
         |		  (
         |		    SELECT ${userid} ,${monthid}
         |		    FROM ads.${table} ${lr_UserSQL}
         |		    ORDER BY ${monthid} DESC
         |		  )
         |		GROUP BY ${userid}
         |	)
         |) s2  on s1.${userid}=s2.${userid}  and s1.${monthid}= s2.${monthid}
         |${lr_UserSQL_s1}
         |""".stripMargin+""
    println(sql)
    //执行
    RunClickhouseSQL(sql);

    0
  }




  ///从原始xxh etl数据中分解存入xxh大表
  def z_xxh_from_etl_sp(month:String="",isInsert:Boolean=true)={
    z_xxh_from_etl(month,uid_l="0",uid_r="131",isInsert = true)
    z_xxh_from_etl(month,uid_l="131",uid_r="132",isInsert = true);
    z_xxh_from_etl(month,uid_l="132",uid_r="150",isInsert = true);
    z_xxh_from_etl(month,uid_l="150",uid_r="156",isInsert = true);
    z_xxh_from_etl(month,uid_l="156",uid_r="166",isInsert = true);
    z_xxh_from_etl(month,uid_l="166",uid_r="176",isInsert = true);
    z_xxh_from_etl(month,uid_l="176",uid_r="1768",isInsert = true);
    z_xxh_from_etl(month,uid_l="1768",uid_r="1855",isInsert = true);
    z_xxh_from_etl(month,uid_l="1855",uid_r="186",isInsert = true);
    z_xxh_from_etl(month,uid_l="186",uid_r="1865",isInsert = true);
    z_xxh_from_etl(month,uid_l="1865",uid_r="9999",isInsert = true);
  }
  ///从原始xxh etl数据中分解存入xxh大表
  def z_xxh_from_etl(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="")={
    var sql:String=""
    sql=sql+
      """
        |insert into ads.XXH_ALL_MONTH
        |""".stripMargin

    val lrSql_USERID = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    sql=sql+
      s"""
         |select distinct MONTH_ID, SEARCH_FLAG, DEVICE_NUMBER, PROV_DESC, UPPER(SERVICE_TYPE) as SERVICE_TYPE,
         |INNET_MONTHS, CUST_SEX, CERT_AGE,
         |TOTAL_FLUX, TOTAL_FEE, ifNull(MON_TOTAL_FEE,'0') AS MON_TOTAL_FEE, PRODUCT_CLASS_DESC, null as MON_FEE, FLUX_M, RESOURCE_NAME,
         |PKG_NAME, MANU_NAME, MODEL_NAME, IS_ACCT ,TOTAL_FLUX_VIDEO, ARAE
         |from ads.XXH_ALL_MONTH_ETL
         |where MONTH_ID ='${month}' ${lrSql_USERID}
         |and DEVICE_NUMBER not in
         |(
         |select DISTINCT DEVICE_NUMBER from  ads.XXH_ALL_MONTH where MONTH_ID ='${month}' ${lrSql_USERID}
         |)
         |""".stripMargin

    print(sql)
    RunClickhouseSQL(sql);

    var sql2:String=""
    sql2=sql2+
      s"""
         |insert into ads.XXH_ALL_APP_MONTH
         |  select MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, Max(toUInt32OrZero(DAYS)) as DAYS,
         |  toUInt32OrZero(TIMES) as TIMES, toUInt32OrZero(MINS) as MINS, toFloat64OrZero(ONE_FLUX) as ONE_FLUX
         |  from
         |  ( select MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, DAYS,TIMES,MINS,ifNull(ONE_FLUX,'0') as  ONE_FLUX
         |  	from  ads.XXH_ALL_MONTH_ETL where MONTH_ID ='${month}' ${lrSql_USERID}
         |   and DEVICE_NUMBER not in
         |    (
         |      select DISTINCT DEVICE_NUMBER from  ads.XXH_ALL_APP_MONTH where MONTH_ID ='${month}' ${lrSql_USERID}
         |    )
         |  ) s
         |group by MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, TIMES, MINS, ONE_FLUX
         |""".stripMargin

    print(sql2)
    RunClickhouseSQL(sql2);
  }
  ///从原始xxh etl数据中分解存入xxh大表
  def z_xxh_from_etl_sp2(month:String="",isInsert:Boolean=true)={
    z_xxh_from_etl2(month,uid_l="0",uid_r="131",isInsert = true)
    z_xxh_from_etl2(month,uid_l="131",uid_r="132",isInsert = true);
    z_xxh_from_etl2(month,uid_l="132",uid_r="150",isInsert = true);
    z_xxh_from_etl2(month,uid_l="150",uid_r="156",isInsert = true);
    z_xxh_from_etl2(month,uid_l="156",uid_r="166",isInsert = true);
    z_xxh_from_etl2(month,uid_l="166",uid_r="176",isInsert = true);
    z_xxh_from_etl2(month,uid_l="176",uid_r="1768",isInsert = true);
    z_xxh_from_etl2(month,uid_l="1768",uid_r="1855",isInsert = true);
    z_xxh_from_etl2(month,uid_l="1855",uid_r="186",isInsert = true);
    z_xxh_from_etl2(month,uid_l="186",uid_r="1865",isInsert = true);
    z_xxh_from_etl2(month,uid_l="1865",uid_r="9999",isInsert = true);
  }
  ///从原始xxh etl数据中分解存入xxh大表
  def z_xxh_from_etl2(month:String,isInsert:Boolean=false,uid_l:String="",uid_r:String="")={
    var sql:String=""
    sql=sql+
      """
        |insert into ads.XXH_ALL_MONTH
        |""".stripMargin

    val lrSql_USERID = if (uid_l =="") "" else s" and  DEVICE_NUMBER>='${uid_l}' and DEVICE_NUMBER<'${uid_r}'"
    sql=sql+
      s"""
         |select distinct MONTH_ID, SEARCH_FLAG, DEVICE_NUMBER, PROV_DESC, UPPER(SERVICE_TYPE) as SERVICE_TYPE, toUInt32OrZero(INNET_MONTHS) INNET_MONTHS, CUST_SEX, CERT_AGE,
         |TOTAL_FLUX, TOTAL_FEE, ifNull(MON_TOTAL_FEE,'0') AS MON_TOTAL_FEE, PRODUCT_CLASS_DESC, null as MON_FEE, FLUX_M, RESOURCE_NAME,
         |PKG_NAME, MANU_NAME, MODEL_NAME, IS_ACCT ,TOTAL_FLUX_VIDEO, AREA as ARAE
         |from ads.XXH_ALL_MONTH_ETL2
         |where MONTH_ID ='${month}' ${lrSql_USERID}
         |""".stripMargin

    print(sql)
    RunClickhouseSQL(sql);

    var sql2:String=""
    sql2=sql2+
      s"""
         |insert into ads.XXH_ALL_APP_MONTH
         |  select MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, Max(toUInt32OrZero(DAYS)) as DAYS,
         |  toUInt32OrZero(TIMES) as TIMES, toUInt32OrZero(MINS) as MINS, toFloat64OrZero(ONE_FLUX) as ONE_FLUX
         |  from
         |  ( select MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, DAYS,TIMES,MINS,ifNull(ONE_FLUX,'0') as  ONE_FLUX
         |  	from  ads.XXH_ALL_MONTH_ETL2 where MONTH_ID ='${month}' ${lrSql_USERID}
         |  ) s
         |group by MONTH_ID,DEVICE_NUMBER, APP_PRE, CON_PRE, APP_NAME, TIMES, MINS, ONE_FLUX
         |""".stripMargin

    print(sql2)
    RunClickhouseSQL(sql2);
  }


}