package com.jollychic.tool;

import com.jollychic.utils.ElasticSearchConfig;
import org.elasticsearch.action.admin.indices.get.GetIndexRequest;
import org.elasticsearch.client.RequestOptions;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.client.indices.CreateIndexRequest;
import org.elasticsearch.client.indices.CreateIndexResponse;
import org.elasticsearch.common.settings.Settings;

import java.io.IOException;


public class EsJavaOpt {

    //创建新的索引 5分片 1副本
    public void CreateIndex(String idxName) throws IOException {
        RestHighLevelClient restHighLevelClient= ElasticSearchConfig.restHighLevelClient();
//        GetIndexRequest request = new GetIndexRequest();
//        request.indices(idxName);
//        boolean exists=false;
//        try {
//            exists= restHighLevelClient.indices().exists(request, RequestOptions.DEFAULT);
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
            try{
                CreateIndexRequest insertReq = new CreateIndexRequest(idxName);
                insertReq.settings(Settings.builder()
                        .put("index.number_of_shards", 3)
                        .put("index.number_of_replicas", 1)
                );
                CreateIndexResponse createIndexResponse = restHighLevelClient.indices().create(insertReq, RequestOptions.DEFAULT);
            }catch (Exception e){
                e.printStackTrace();
            }

        restHighLevelClient.close();
    }
}
