package com.jollychic.utils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

public class CommonKit {

    /**
     *
     * @param tagMap
     * @return
     */
    public static List<String> filterList(Map<String, String> tagMap, String startWithStr){
        return tagMap.entrySet().stream().filter(f -> f.getKey().startsWith(startWithStr)).map(t -> t.getValue()).collect(Collectors.toList());
    }

    /**
     *
     * @param tagMap
     * @return
     */
    public static Map<String, String> filterMap(Map<String, String> tagMap, String startWithStr){
        Map<String, String> resultMap = new HashMap<>();
        tagMap.keySet().stream().filter(f -> f.startsWith(startWithStr)).forEach(item -> {
            resultMap.put(tagMap.get(item), item);
        });
        return resultMap;
    }
}
